'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

var classCallCheck = _classCallCheck;

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var createClass = _createClass;

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var defineProperty = _defineProperty;

var TL = 0.00001;

function EQ_0(num) {
  return num < TL && num > -TL;
}

function EQ(a, b) {
  return a - b < TL && a - b > -TL;
}

function LE(a, b) {
  return a - b <= TL;
}

function GE(a, b) {
  return a - b >= TL;
}

var Comparator = {
  EQ_0: EQ_0,
  EQ: EQ,
  LE: LE,
  GE: GE
};

var Vector = /*#__PURE__*/function () {
  function Vector() {
    var x = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

    classCallCheck(this, Vector);

    defineProperty(this, "x", void 0);

    defineProperty(this, "y", void 0);

    this.x = x;
    this.y = y;
  } // set this value of this one to another vector.


  createClass(Vector, [{
    key: "set",
    value: function set(x) {
      var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      if (x instanceof Vector) {
        this.x = x.x;
        this.y = x.y;
      } else {
        this.x = x;
        this.y = y;
      }

      return this;
    } // scale another vector first then add to this vector

  }, {
    key: "addMul",
    value: function addMul(v, scl) {
      this.x += v.x * scl;
      this.y += v.y * scl;
      return this;
    } // scale a vector first then subtract the vector

  }, {
    key: "subMul",
    value: function subMul(v, scl) {
      this.x -= v.x * scl;
      this.y -= v.y * scl;
      return this;
    } // Scale this vector. An independent scaling factor can be provided
    // for each axis, or a single scaling factor that will scale both `x` and `y`.

  }, {
    key: "scl",
    value: function scl(x) {
      var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : x;
      this.x *= x;
      this.y *= y;
      return this;
    } // Add another vector to this one.

  }, {
    key: "add",
    value: function add(v) {
      this.x += v.x;
      this.y += v.y;
      return this;
    } // Add (x,y) to this one.

  }, {
    key: "translate",
    value: function translate(x, y) {
      this.x += x;
      this.y += y;
      return this;
    } // Subtract another vector from this one.

  }, {
    key: "sub",
    value: function sub(v) {
      this.x -= v.x;
      this.y -= v.y;
      return this;
    } // Change this vector to be perpendicular to what it was before. (Effectively
    // rotates it 90 degrees in a clockwise direction)

  }, {
    key: "perp",
    value: function perp() {
      var x = this.x;
      this.x = this.y;
      this.y = -x;
      return this;
    } // Rotate this vector (counter-clockwise) by the specified angle (in radians).

  }, {
    key: "rotate",
    value: function rotate(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Vector.ZERO;
      var x = this.x;
      var y = this.y;
      this.x = center.x + (x - center.x) * Math.cos(angle) - (y - center.y) * Math.sin(angle);
      this.y = center.y + (x - center.x) * Math.sin(angle) + (y - center.y) * Math.cos(angle);
      return this;
    } //  the angle v looks at this

  }, {
    key: "angle",
    value: function angle(v) {
      return Math.atan2(this.y - v.y, this.x - v.x);
    }
  }, {
    key: "reverse",
    value: function reverse() {
      this.x = -this.x;
      this.y = -this.y;
      return this;
    } // Get the dot product of this vector and another.

  }, {
    key: "dot",
    value: function dot(v) {
      return this.x * v.x + this.y * v.y;
    }
    /**
     * @param v the other vector
     * @param ref reference vector
     * @return dot product of (this - ref), (v - ref)
     * result > 0 the angle between (this - ref), (v - ref) < 90
     * result < 0 the angle between (this - ref), (v - ref) > 90
     */

  }, {
    key: "dotRef",
    value: function dotRef(v, ref) {
      return (this.x - ref.x) * (v.x - ref.x) + (this.y - ref.y) * (v.y - ref.y);
    }
    /**
     * @param v
     * @return cross product
     */

  }, {
    key: "cross",
    value: function cross(v) {
      return this.x * v.y - this.y * v.x;
    }
    /**
     * @param v the other vector
     * @param ref reference vector
     * @return cross product of (this - ref), (v - ref)
     * result < 0 if (v - ref) is on the right side of (this - ref)
     * result > 0 if (v - ref) is on the left side of (this - ref)
     */

  }, {
    key: "crossRef",
    value: function crossRef(v, ref) {
      return (this.x - ref.x) * (v.y - ref.y) - (this.y - ref.y) * (v.x - ref.x);
    } // Project this vector on to another vector.

  }, {
    key: "project",
    value: function project(v) {
      var amt = this.dot(v) / v.len2();
      this.x = amt * v.x;
      this.y = amt * v.y;
      return this;
    } // Project this vector onto a vector of unit length. This is slightly more efficient
    // than `project` when dealing with unit vectors.

  }, {
    key: "projectN",
    value: function projectN(v) {
      var amt = this.dot(v);
      this.x = amt * v.x;
      this.y = amt * v.y;
      return this;
    }
  }, {
    key: "reflect",
    // Reflect this vector on an arbitrary axis.
    value: function reflect(axis) {
      var x = this.x;
      var y = this.y;
      this.project(axis).scl(2);
      this.x -= x;
      this.y -= y;
      return this;
    }
  }, {
    key: "reflectN",
    // Reflect this vector on an arbitrary axis (represented by a unit vector). This is
    // slightly more efficient than `reflect` when dealing with an axis that is a unit vector.
    value: function reflectN(axis) {
      var x = this.x;
      var y = this.y;
      this.projectN(axis).scl(2);
      this.x -= x;
      this.y -= y;
      return this;
    }
  }, {
    key: "normalize",
    // Normalize this vector.  (make it have length of `1`)
    value: function normalize() {
      var d = this.len();

      if (d > 0) {
        this.x = this.x / d;
        this.y = this.y / d;
      }

      return this;
    } // Get the squared length of this vector.

  }, {
    key: "len2",
    value: function len2() {
      return this.x * this.x + this.y * this.y;
    } // Get the length of this vector.

  }, {
    key: "len",
    value: function len() {
      return Math.sqrt(this.len2());
    }
  }, {
    key: "setLen",
    value: function setLen(len) {
      return this.normalize().scl(len);
    } // Create a new vector with the same coordinates as this on.

  }, {
    key: "clone",
    value: function clone() {
      return new Vector(this.x, this.y);
    }
  }, {
    key: "dist2",
    value: function dist2(v) {
      return (v.x - this.x) * (v.x - this.x) + (v.y - this.y) * (v.y - this.y);
    }
  }, {
    key: "dist",
    value: function dist(v) {
      return Math.sqrt(this.dist2(v));
    }
  }, {
    key: "equalsTo",
    value: function equalsTo(v) {
      return Comparator.EQ(this.x, v.x) && Comparator.EQ(this.y, v.y);
    }
  }, {
    key: "toString",
    value: function toString() {
      return "[".concat(this.x, ", ").concat(this.y, "]");
    }
  }], [{
    key: "lerp",
    value: function lerp(start, end, t) {
      return new Vector(t * (end.x - start.x) + start.x, t * (end.y - start.y) + start.y);
    }
  }]);

  return Vector;
}();

defineProperty(Vector, "ZERO", new Vector());

var AABB = /*#__PURE__*/function () {
  createClass(AABB, null, [{
    key: "fromVector",
    value: function fromVector(v) {
      return new AABB(v.x, v.y);
    }
  }]);

  function AABB(left, bottom) {
    var right = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : left;
    var top = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : bottom;

    classCallCheck(this, AABB);

    defineProperty(this, "left", void 0);

    defineProperty(this, "right", void 0);

    defineProperty(this, "top", void 0);

    defineProperty(this, "bottom", void 0);

    this.left = left;
    this.bottom = bottom;
    this.right = right;
    this.top = top;
  }

  createClass(AABB, [{
    key: "set",
    value: function set(other) {
      this.left = other.left;
      this.bottom = other.bottom;
      this.right = other.right;
      this.top = other.top;
    }
  }, {
    key: "getCenter",
    value: function getCenter() {
      return new Vector((this.left + this.right) / 2, (this.top + this.bottom) / 2);
    }
  }, {
    key: "intersects",
    value: function intersects(aabb) {
      return this.left <= aabb.right && this.right >= aabb.left && this.bottom <= aabb.top && this.top >= aabb.bottom;
    }
  }, {
    key: "contains",
    value: function contains(aabb) {
      return this.left <= aabb.left && this.right >= aabb.right && this.bottom <= aabb.bottom && this.top >= aabb.top;
    }
  }, {
    key: "merge",
    value: function merge(other) {
      this.left = Math.min(this.left, other.left);
      this.bottom = Math.min(this.bottom, other.bottom);
      this.right = Math.max(this.right, other.right);
      this.top = Math.max(this.top, other.top);
      return this;
    }
  }, {
    key: "includes",
    value: function includes(v) {
      this.left = Math.min(this.left, v.x);
      this.bottom = Math.min(this.bottom, v.y);
      this.right = Math.max(this.right, v.x);
      this.top = Math.max(this.top, v.y);
      return this;
    }
  }, {
    key: "isPointIn",
    value: function isPointIn(vector) {
      return false;
    }
  }, {
    key: "getAABB",
    value: function getAABB() {
      return this;
    }
  }, {
    key: "getArea",
    value: function getArea() {
      return (this.top - this.bottom) * (this.right - this.left);
    }
  }, {
    key: "getOrigin",
    value: function getOrigin() {
      return this.getCenter();
    }
  }, {
    key: "getCentroid",
    value: function getCentroid() {
      return this.getCenter();
    }
  }, {
    key: "toString",
    value: function toString() {
      return "[l:".concat(this.left, ", b:").concat(this.bottom, ", r:").concat(this.right, ", t:").concat(this.top, "]");
    }
  }, {
    key: "centerX",
    get: function get() {
      return (this.left + this.right) / 2;
    }
  }, {
    key: "centerY",
    get: function get() {
      return (this.bottom + this.top) / 2;
    }
  }, {
    key: "width",
    get: function get() {
      return this.right - this.left;
    }
  }, {
    key: "height",
    get: function get() {
      return this.top - this.bottom;
    }
  }], [{
    key: "fromCenter",
    value: function fromCenter(center, width) {
      var height = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : width;
      return new AABB(center.x - width / 2, center.y - height / 2, center.x + width / 2, center.y + height / 2);
    }
  }]);

  return AABB;
}();

var CollisionResult = function CollisionResult() {
  var normal = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Vector();
  var depth = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var contacts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Array();

  classCallCheck(this, CollisionResult);

  defineProperty(this, "normal", void 0);

  defineProperty(this, "depth", void 0);

  defineProperty(this, "contacts", void 0);

  this.normal = normal;
  this.depth = depth;
  this.contacts = contacts;
};

var PI = Math.PI;
var PI2 = Math.PI * 2;
var Geom2Const = {
  PI: PI,
  PI2: PI2
}; // ## Object Pools
// A pool of `Vector` objects that are used in calculations to avoid
// allocating memory.

var T_VECTORS = [];

for (var i = 0; i < 10; i++) {
  T_VECTORS.push(new Vector());
} // A pool of arrays of numbers used in calculations to avoid allocating


var T_TESTRESULT = new CollisionResult();
/*****               Array                        *******/

/**
 * Randomly shuffle an array
 * https://stackoverflow.com/a/2450976/1293256
 * @param  {Array} array The array to shuffle
 * @return {String}      The first item in the shuffled array
 */

function shuffle(array) {
  var currentIndex = array.length;
  var temporaryValue, randomIndex; // While there remain elements to shuffle...

  while (0 !== currentIndex) {
    // Pick a remaining element...
    randomIndex = Math.floor(Math.random() * currentIndex);
    currentIndex -= 1; // And swap it with the current element.

    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }

  return array;
}
/******              number                            *****/
// value

function sameSign(num1, num2) {
  return num1 >= 0 && num2 >= 0 || num1 < 0 && num2 < 0;
}
function pMod(a, n) {
  return (a % n + n) % n;
}
function angleNormalize(a) {
  return pMod(a + PI, PI2) - PI;
}
function angleNormalizePI2(a) {
  return pMod(a, PI2);
}
function angleDiff(angle1, angle2) {
  var a = angle1 - angle2;
  return angleNormalize(a);
}
function angleDiffPI2(angle1, angle2) {
  var a = angle1 - angle2;
  return angleNormalizePI2(a);
}
/******              Vector                            *****/
// Given three colinear points p, q, r, the function checks if
// point q lies on line segment 'pr'

function onSegment(s1, s2, v) {
  return v.x <= Math.max(s1.x, s2.x) && v.x >= Math.min(s1.x, s2.x) && v.y <= Math.max(s1.y, s2.y) && v.y >= Math.min(s1.y, s2.y);
} // To find orientation of ordered triplet (v1, ref, v2).

function crossProduct3(v1, v2, v3) {
  return (v2.x - v1.x) * (v3.y - v2.y) - (v2.y - v1.y) * (v3.x - v2.x);
} // To find orientation of ordered triplet (v1, ref, v2).

function orientation(s, v) {
  return crossProduct3(s.v1, s.v2, v);
}
function testSegmentSegment(s1p1, s1p2, s2p1, s2p2) {
  // Find the four orientations needed for general and
  // special cases
  var o1 = crossProduct3(s1p1, s1p2, s2p1);
  var o2 = crossProduct3(s1p1, s1p2, s2p2);
  var o3 = crossProduct3(s2p1, s2p2, s1p1);
  var o4 = crossProduct3(s2p1, s2p2, s1p2); // General case

  if (!sameSign(o1, o2) && !sameSign(o3, o4)) return true; // Special Cases
  // s1p1, s1p2 and s2p1 are colinear and s2p1 lies on segment p1q1

  if (o1 == 0 && onSegment(s1p1, s2p1, s1p2)) return true; // s1p1, s1p2 and s2p2 are colinear and s2p2 lies on segment p1q1

  if (o2 == 0 && onSegment(s1p1, s2p2, s1p2)) return true; // s2p1, s2p2 and s1p1 are colinear and s1p1 lies on segment p2q2

  if (o3 == 0 && onSegment(s2p1, s1p1, s2p2)) return true; // s2p1, s2p2 and s1p2 are colinear and s1p2 lies on segment p2q2

  if (o4 == 0 && onSegment(s2p1, s1p2, s2p2)) return true;
  return false; // Doesn't fall in any of the above cases
}
function lineIntersection(p1, p2, p3, p4) {
  // From http://paulbourke.net/geometry/lineline2d/
  var s = ((p4.x - p3.x) * (p1.y - p3.y) - (p4.y - p3.y) * (p1.x - p3.x)) / ((p4.y - p3.y) * (p2.x - p1.x) - (p4.x - p3.x) * (p2.y - p1.y));
  return new Vector(p1.x + s * (p2.x - p1.x), p1.y + s * (p2.y - p1.y));
}
/******              Polygon                            *****/
// Check if two circles collide.

/**
 * @param {Circle} a The first circle.
 * @param {Circle} b The second circle.
 * @param {TestResult} testResult Response object (optional) that will be populated if
 *   the circles intersects.
 * @return {boolean} true if the circles intersects, false if they don't.
 */

function testCircleCircle(a, b, testResult) {
  // Check if the distance between the centers of the two
  // circles is greater than their combined radius.
  var differenceV = T_VECTORS.pop();
  if (differenceV === undefined) throw new Error('memory allocation error');
  differenceV.set(b.transform.position).sub(a.transform.position);
  var totalRadius = a.r + b.r;
  var totalRadiusSq = totalRadius * totalRadius;
  var distanceSq = differenceV.len2(); // If the distance is bigger than the combined radius, they don't intersects.

  if (distanceSq > totalRadiusSq) {
    T_VECTORS.push(differenceV);
    return false;
  } // They intersects.  If we're calculating a testResult, calculate the overlap.


  if (testResult) {
    var dist = Math.sqrt(distanceSq);
    testResult.depth = totalRadius - dist;
    testResult.normal.set(differenceV.normalize());

    if (a.r <= b.r) {
      testResult.contacts.push(testResult.normal.clone().scl(a.r).add(a.transform.position));
    } else {
      testResult.contacts.push(testResult.normal.clone().scl(-b.r).add(b.transform.position));
    }
  }

  T_VECTORS.push(differenceV);
  return true;
}
var VORONOI_REGION; // Calculates which Voronoi region a point is on a line segment.
// It is assumed that both the line and the point are relative to `(0,0)`
//
//            |       (0)      |
//     (-1)  [S]--------------[E]  (1)
//            |       (0)      |

/**
 * @param {Vector} line The line segment.
 * @param {Vector} point The point.
 * @return  {number} LEFT_VORONOI_REGION (-1) if it is the left region,
 *          MIDDLE_VORONOI_REGION (0) if it is the middle region,
 *          RIGHT_VORONOI_REGION (1) if it is the right region.
 */

(function (VORONOI_REGION) {
  VORONOI_REGION[VORONOI_REGION["LEFT"] = -1] = "LEFT";
  VORONOI_REGION[VORONOI_REGION["MIDDLE"] = 0] = "MIDDLE";
  VORONOI_REGION[VORONOI_REGION["RIGHT"] = 1] = "RIGHT";
})(VORONOI_REGION || (VORONOI_REGION = {}));

function voronoiRegion(line, point) {
  var len2 = line.len2();
  var dp = point.dot(line); // If the point is beyond the start of the line, it is in the
  // left voronoi region.

  if (dp < 0) {
    return VORONOI_REGION.LEFT;
  } // If the point is beyond the end of the line, it is in the
  // right voronoi region.
  else if (dp > len2) {
      return VORONOI_REGION.RIGHT;
    } // Otherwise, it's in the middle one.
    else {
        return VORONOI_REGION.MIDDLE;
      }
}
/**
 * Check if a polygon and a circle collide.
 * @param {Polygon} polygon The polygon.
 * @param {Circle} circle The circle.
 * @param {TestResult} response Response object (optional) that will be populated if
 *   they interset.
 * @return {boolean} true if they intersects, false if they don't.
 */


function testPolygonCircle(polygon, circle, response) {
  var circlePos = T_VECTORS.pop();
  if (circlePos === undefined) throw new Error('memory allocation error'); // Get the position of the circle relative to the polygon.

  circlePos.set(circle.transform.position);
  var radius = circle.r;
  var radius2 = radius * radius;
  var points = polygon.calcPoints;
  var len = points.length;
  var edge = T_VECTORS.pop();
  var point = T_VECTORS.pop();
  if (point === undefined || edge === undefined) throw new Error('memory allocation error'); // For each edge in the polygon:

  for (var _i2 = 0; _i2 < len; _i2++) {
    var next = (_i2 + 1) % len;
    var prev = (_i2 - 1 + len) % len;
    var overlap = 0;
    var overlapN = null; // Get the edge.

    edge.set(polygon.calcPoints[next]).sub(polygon.calcPoints[_i2]); // Calculate the center of the circle relative to the starting point of the edge.

    point.set(circlePos).sub(points[_i2]); // If the distance between the center of the circle and the point
    // is bigger than the radius, the polygon is definitely not fully in
    // the circle.

    if (response && point.len2() > radius2) ; // Calculate which Voronoi region the center of the circle is in.


    var region = voronoiRegion(edge, point); // If it's the left region:

    if (region === VORONOI_REGION.LEFT) {
      // We need to make sure we're in the RIGHT_VORONOI_REGION of the previous edge.
      edge.set(polygon.calcPoints[_i2]).sub(polygon.calcPoints[prev]); // Calculate the center of the circle relative the starting point of the previous edge

      var point2 = T_VECTORS.pop();
      if (point2 === undefined) throw new Error('memory allocation error');
      point2.set(circlePos).sub(points[prev]);
      region = voronoiRegion(edge, point2);

      if (region === VORONOI_REGION.RIGHT) {
        // It's in the region we want.  Check if the circle intersects the point.
        var dist = point.len();

        if (dist > radius) {
          // No intersection
          T_VECTORS.push(circlePos);
          T_VECTORS.push(edge);
          T_VECTORS.push(point);
          T_VECTORS.push(point2);
          return false;
        } else if (response) {
          // It intersects, calculate the overlap.
          //response.bInA = false;
          overlapN = point.normalize();
          overlap = radius - dist;
        }
      }

      T_VECTORS.push(point2); // If it's the right region:
    } else if (region === VORONOI_REGION.RIGHT) {
      // We need to make sure we're in the left region on the next edge
      edge.set(polygon.calcPoints[(next + 1) % len]).sub(polygon.calcPoints[next]); // Calculate the center of the circle relative to the starting point of the next edge.

      point.set(circlePos).sub(points[next]);
      region = voronoiRegion(edge, point);

      if (region === VORONOI_REGION.LEFT) {
        // It's in the region we want.  Check if the circle intersects the point.
        var _dist = point.len();

        if (_dist > radius) {
          // No intersection
          T_VECTORS.push(circlePos);
          T_VECTORS.push(edge);
          T_VECTORS.push(point);
          return false;
        } else if (response) {
          // It intersects, calculate the overlap.
          //response.bInA = false;
          overlapN = point.normalize();
          overlap = radius - _dist;
        }
      } // Otherwise, it's the middle region:

    } else {
      // Need to check if the circle is intersecting the edge,
      // Change the edge into its "edge normal".
      var normal = edge.perp().normalize(); // Find the perpendicular distance between the center of the
      // circle and the edge.

      var _dist2 = point.dot(normal);

      var distAbs = Math.abs(_dist2); // If the circle is on the outside of the edge, there is no intersection.

      if (_dist2 > 0 && distAbs > radius) {
        // No intersection
        T_VECTORS.push(circlePos);
        T_VECTORS.push(normal);
        T_VECTORS.push(point);
        return false;
      } else if (response) {
        // It intersects, calculate the overlap.
        overlapN = normal;
        overlap = radius - _dist2; // If the center of the circle is on the outside of the edge, or part of the
      }
    } // If this is the smallest overlap we've seen, keep it.
    // (overlapN may be null if the circle was in the wrong Voronoi region).


    if (overlapN && response && Math.abs(overlap) < Math.abs(response.depth)) {
      response.depth = overlap;
      response.normal.set(overlapN);
    }
  } // Calculate the final overlap vector - based on the smallest overlap.

  T_VECTORS.push(circlePos);
  T_VECTORS.push(edge);
  T_VECTORS.push(point);
  return true;
}
function lineHasPoint(v1, v2, p) {
  var tolerance = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0.1;
  return Math.abs(v1.dist2(v2) - (v1.dist2(p) + v2.dist2(p))) <= tolerance;
}
/**
 * Calculate distance and closest point between point and segment
 * @param pt the point
 * @param seg1 the start of segment
 * @param seg2 the end of segment
 * @param cp the closest point
 * @returns distance
 */

function point2segment(pt, seg1, seg2, cp) {
  /* Degenerated case of zero-length segment */
  if (seg1.equalsTo(seg2)) {
    if (cp !== undefined) cp.set(seg1);
    return pt.dist(seg1);
  }

  var vSeg = T_VECTORS.pop();
  var vSeg1 = T_VECTORS.pop();
  var vSeg2 = T_VECTORS.pop();

  if (vSeg === undefined || vSeg1 === undefined || vSeg2 === undefined) {
    throw new Error('temp variable memory allocation error');
  }

  vSeg.set(seg1).sub(seg2);
  vSeg1.set(seg1).sub(pt);
  vSeg2.set(seg2).sub(pt);
  var start_sp = vSeg.dot(vSeg1);
  var end_sp = -vSeg.dot(vSeg2);
  var dist;

  if (start_sp >= 0 && end_sp >= 0) {
    /* point inside segment scope */
    // get unit vector
    vSeg.normalize();
    if (cp !== undefined) cp.set(seg1).addMul(vSeg, vSeg.dot(vSeg2));
    dist = Math.abs(vSeg.cross(vSeg2));
  } else if (start_sp < 0) {
    /* point is out of scope closer to ps */
    if (cp !== undefined) cp.set(seg1);
    dist = pt.dist(seg1);
  } else {
    /* point is out of scope closer to pe */
    if (cp !== undefined) cp.set(seg2);
    dist = pt.dist(seg2);
  }

  T_VECTORS.push(vSeg);
  T_VECTORS.push(vSeg1);
  T_VECTORS.push(vSeg2);
  return dist;
}
function point2polygon(pt, points, cp) {
  var n = points.length;
  var local_cp = T_VECTORS.pop();
  var min_dist = Number.POSITIVE_INFINITY;

  if (local_cp === undefined) {
    throw new Error('temp variable memory allocation error');
  }

  for (var _i3 = 0; _i3 < n; _i3++) {
    var next = (_i3 + 1) % n;
    var dist = point2segment(pt, points[_i3], points[next], local_cp);

    if (min_dist > dist) {
      min_dist = dist;

      if (cp !== undefined) {
        cp.set(local_cp);
      }
    }
  }

  T_VECTORS.push(local_cp);
  return min_dist;
}

var Arc = /*#__PURE__*/function () {
  function Arc(center, r) {
    var startAngle = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    var endAngle = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : Geom2Const.PI2;

    classCallCheck(this, Arc);

    defineProperty(this, "c", void 0);

    defineProperty(this, "r", void 0);

    defineProperty(this, "startAngle", void 0);

    defineProperty(this, "endAngle", void 0);

    this.c = center.clone();
    this.r = r;
    this.startAngle = angleNormalizePI2(startAngle);
    this.endAngle = angleNormalizePI2(endAngle);
  }

  createClass(Arc, [{
    key: "clone",
    value: function clone() {
      return new Arc(this.c.clone(), this.r, this.startAngle, this.endAngle);
    }
    /**
     * Returns true if arc contains point, false otherwise
     * @param {Point} pt - point to test
     * @returns {boolean}
     */

  }, {
    key: "contains",
    value: function contains(pt) {
      // first check if  point on circle (pc,r)
      if (!Comparator.EQ(this.c.dist(pt), this.r)) return false;
      var angle = pt.angle(this.c);
      return Comparator.LE(this.startAngle, angle) && Comparator.LE(angle, this.endAngle);
    }
    /**
     * Get bounding box of the arc
     * @returns {AABB}
     */

  }, {
    key: "getAABB",
    value: function getAABB() {
      var func_arcs = this.breakToFunctional();
      var box = func_arcs.reduce(function (acc, arc) {
        return acc.includes(arc.start);
      }, new AABB(this.start.x, this.start.y));
      box = box.includes(this.end);
      return box;
    }
    /**
     * Breaks arc in extreme point 0, pi/2, pi, 3*pi/2 and returns array of sub-arcs
     * @returns {Arcs[]}
     */

  }, {
    key: "breakToFunctional",
    value: function breakToFunctional() {
      var func_arcs_array = [];
      var angles = [0, Math.PI / 2, 2 * Math.PI / 2, 3 * Math.PI / 2];
      var pts = [this.c.clone().translate(this.r, 0), this.c.clone().translate(0, this.r), this.c.clone().translate(-this.r, 0), this.c.clone().translate(0, -this.r)]; // If arc contains extreme point,
      // create test arc started at start point and ended at this extreme point

      var test_arcs = [];

      for (var i = 0; i < 4; i++) {
        if (this.contains(pts[i])) {
          test_arcs.push(new Arc(this.c, this.r, this.startAngle, angles[i]));
        }
      }

      if (test_arcs.length == 0) {
        // arc does contain any extreme point
        func_arcs_array.push(this.clone());
      } else {
        // arc passes extreme point
        // sort these arcs by length
        test_arcs.sort(function (arc1, arc2) {
          return arc1.length - arc2.length;
        });

        for (var _i = 0; _i < test_arcs.length; _i++) {
          var _prev_arc = func_arcs_array.length > 0 ? func_arcs_array[func_arcs_array.length - 1] : undefined;

          var _new_arc = void 0;

          if (_prev_arc) {
            _new_arc = new Arc(this.c, this.r, _prev_arc.endAngle, test_arcs[_i].endAngle);
          } else {
            _new_arc = new Arc(this.c, this.r, this.startAngle, test_arcs[_i].endAngle);
          }

          if (!Comparator.EQ_0(_new_arc.length)) {
            func_arcs_array.push(_new_arc.clone());
          }
        } // add last sub arc


        var prev_arc = func_arcs_array.length > 0 ? func_arcs_array[func_arcs_array.length - 1] : undefined;
        var new_arc;

        if (prev_arc) {
          new_arc = new Arc(this.c, this.r, prev_arc.endAngle, this.endAngle);
        } else {
          new_arc = new Arc(this.c, this.r, this.startAngle, this.endAngle);
        } // It could be 2*PI when occasionally start = 0 and end = 2*PI but this is not valid for breakToFunctional


        if (!Comparator.EQ_0(new_arc.length) && !Comparator.EQ(new_arc.sweep, 2 * Math.PI)) {
          func_arcs_array.push(new_arc.clone());
        }
      }

      return func_arcs_array;
    }
  }, {
    key: "sweep",
    get: function get() {
      return angleDiffPI2(this.endAngle, this.startAngle);
    }
    /**
     * Get start point of arc
     * @returns {Point}
     */

  }, {
    key: "start",
    get: function get() {
      var p0 = new Vector(this.c.x + this.r, this.c.y);
      return p0.rotate(this.startAngle, this.c);
    }
    /**
     * Get end point of arc
     * @returns {Point}
     */

  }, {
    key: "end",
    get: function get() {
      var p0 = new Vector(this.c.x + this.r, this.c.y);
      return p0.rotate(this.endAngle, this.c);
    }
  }, {
    key: "vertices",
    get: function get() {
      return [this.start, this.end];
    }
    /**
     * Get arc length
     * @returns {number}
     */

  }, {
    key: "length",
    get: function get() {
      return Math.abs(this.sweep * this.r);
    }
  }]);

  return Arc;
}();

// implement using
var PriorityQueue = /*#__PURE__*/function () {
  function PriorityQueue() {
    classCallCheck(this, PriorityQueue);

    defineProperty(this, "items", void 0);

    defineProperty(this, "size", void 0);

    this.items = [];
    this.size = 0;
  }

  createClass(PriorityQueue, [{
    key: "enqueue",
    value: function enqueue(item) {
      this.items.push(item);
      this.sink(this.items.length - 1);
    }
  }, {
    key: "sink",
    value: function sink(index) {
      var item = this.items[index]; // sink the current node to base

      while (index > 0 && item.compare(this.items[Math.floor((index - 1) / 2)])) {
        this.items[index] = this.items[Math.floor((index - 1) / 2)];
        index = Math.floor((index - 1) / 2);
      }

      this.items[index] = item;
    }
  }, {
    key: "dequeue",
    value: function dequeue() {
      var result = this.items[0];
      var cur = 0; // fill the bottom
      // does the current node has child

      while (cur * 2 + 1 < this.items.length) {
        if (cur * 2 + 2 >= this.items.length || this.items[cur * 2 + 1].compare(this.items[cur * 2 + 2])) {
          this.items[cur] = this.items[cur * 2 + 1];
          cur = cur * 2 + 1;
        } else {
          this.items[cur] = this.items[cur * 2 + 2];
          cur = cur * 2 + 2;
        }
      }

      if (cur < this.items.length - 1) {
        this.items[cur] = this.items[this.items.length - 1];
        this.sink(cur);
      }

      this.items.pop();
      return result;
    }
  }]);

  return PriorityQueue;
}();

function createCommonjsModule(fn, basedir, module) {
	return module = {
	  path: basedir,
	  exports: {},
	  require: function (path, base) {
      return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
    }
	}, fn(module, module.exports), module.exports;
}

function commonjsRequire () {
	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}
});

var regenerator = runtime_1;

var LinkedListNode = /*#__PURE__*/function () {
  function LinkedListNode(data) {
    classCallCheck(this, LinkedListNode);

    defineProperty(this, "data", void 0);

    defineProperty(this, "next", void 0);

    defineProperty(this, "prev", void 0);

    this.data = data;
    this.next = null;
    this.prev = null;
  }

  createClass(LinkedListNode, [{
    key: "hasPrev",
    value: function hasPrev() {
      return this.prev !== null;
    }
  }, {
    key: "hasNext",
    value: function hasNext() {
      return this.next !== null;
    }
  }]);

  return LinkedListNode;
}();
var CircularLinkedList = /*#__PURE__*/function () {
  function CircularLinkedList() {
    classCallCheck(this, CircularLinkedList);

    defineProperty(this, "length", void 0);

    defineProperty(this, "head", void 0);

    this.length = 0;
    this.head = null;
  }

  createClass(CircularLinkedList, [{
    key: "isEmpty",
    value: function isEmpty() {
      return this.head === null;
    }
  }, {
    key: "start",
    value: function start() {
      if (this.head === null) return null;
      return this.head.data;
    }
  }, {
    key: "push",
    value: function push(data) {
      var node = new LinkedListNode(data);

      if (!this.head) {
        this.head = node;
        node.prev = node;
        node.next = node;
      } else {
        node.prev = this.head.prev;
        node.next = this.head;
        this.head.prev.next = node;
        this.head.prev = node;
      }

      this.length++;
      return node;
    }
  }, {
    key: "insertAfter",
    value: function insertAfter(prevNode, data) {
      var node = new LinkedListNode(data);
      node.prev = prevNode;
      node.next = prevNode.next;
      prevNode.next.prev = node;
      prevNode.next = node;
      this.length++;
      return node;
    }
  }, {
    key: "last",
    value: function last() {
      if (this.head) {
        return this.head.prev;
      } else return undefined;
    }
    /**
     * Returns an iterator over the values
     */

  }, {
    key: "values",
    value: /*#__PURE__*/regenerator.mark(function values() {
      var current;
      return regenerator.wrap(function values$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              current = this.head;

              if (!(current !== null)) {
                _context.next = 10;
                break;
              }

              _context.next = 4;
              return current.data;

            case 4:
              if (!(current.next !== this.head)) {
                _context.next = 10;
                break;
              }

              current = current.next;
              _context.next = 8;
              return current.data;

            case 8:
              _context.next = 4;
              break;

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, values, this);
    })
  }]);

  return CircularLinkedList;
}();

var tempSupport = new Vector(); //-----------------------------------------------------------------------------
// Minkowski sum support function for GJK

function support(shape1, shape2, d) {
  // d is a vector direction (doesn't have to be normalized)
  // get points on the edge of the shapes in opposite directions
  var p1 = shape1.getFarthestPointInDirection(d);
  var p2 = shape2.getFarthestPointInDirection(tempSupport.set(d).reverse()); // perform the Minkowski Difference
  // p3 is now a point in Minkowski space on the edge of the Minkowski Difference

  return p1.sub(p2);
}
function gjk(A, B) {
  var simplex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [new Vector(), new Vector(), new Vector()];
  var index = 0; // index of current vertex of simplex

  var ao = new Vector(),
      ab = new Vector(),
      ac = new Vector();
  var abperp = new Vector(),
      acperp = new Vector();
  var d = new Vector(); // pointers

  var a, b, c; // choose a search direction
  // we use the difference of the center of the two shapes

  d.set(A.getOrigin()).sub(B.getOrigin()); // if initial direction is zero – set it to any arbitrary axis (we choose X)

  if (d.x == 0 && d.y == 0) d.x = 1; // set the first support as initial point of the new simplex

  a = simplex[0].set(support(A, B, d));
  if (a.dot(d) <= 0) return false; // no collision
  // The next search direction is always towards the origin, so the next search direction is negate(a)

  d.set(a).reverse(); // start looping

  while (true) {

    a = simplex[++index].set(support(A, B, d)); // make sure that the last point we added actually passed the origin

    if (a.dot(d) <= 0) {
      // if the point added last was not past the origin in the direction of d
      // then the Minkowski Sum cannot possibly contain the origin since
      // the last point added is on the edge of the Minkowski Difference
      return false;
    } // get direction and test simplex


    ao.set(a).reverse(); // from point A to Origin is just negative A
    // simplex has 2 points (a line segment, not a triangle yet)

    if (index < 2) {
      b = simplex[0];
      ab.set(b).sub(a); // from point A to B

      tripleProduct(ab, ao, ab, d); // normal to AB towards Origin

      if (d.len2() == 0) d.set(ab).perp();
    } else {
      b = simplex[1];
      c = simplex[0];
      ab.set(b).sub(a); // from point A to B

      ac.set(c).sub(a); // from point A to C

      tripleProduct(ab, ac, ac, acperp);

      if (acperp.dot(ao) >= 0) {
        d.set(acperp); // new direction is normal to AC towards Origin
      } else {
        tripleProduct(ac, ab, ab, abperp);

        if (abperp.dot(ao) < 0) {
          //console.log("iteration: " + iter_count);
          return true; // collision
        }

        simplex[0].set(simplex[1]); // swap first element (point C)

        d.set(abperp); // new direction is normal to AB towards Origin
      }

      simplex[1].set(simplex[2]); // swap element in the middle (point B)

      --index;
    }
  }
} // http://www.fen.bilkent.edu.tr/~ercelebi/Ax(BxC).pdf

function tripleProduct(a, b, c, r) {
  var ac = a.x * c.x + a.y * c.y; // perform a.dot(c)

  var bc = b.x * c.x + b.y * c.y; // perform b.dot(c)
  // perform b * a.dot(c) - a * b.dot(c)

  r.x = b.x * ac - a.x * bc;
  r.y = b.y * ac - a.y * bc;
  return r;
}

var Edge = /*#__PURE__*/function () {
  function Edge(startVertex, distance) {
    classCallCheck(this, Edge);

    this.startVertex = startVertex;
    this.distance = distance;
  }

  createClass(Edge, [{
    key: "compare",
    value: function compare(other) {
      return this.distance < other.distance;
    }
  }]);

  return Edge;
}();

function originDistance(a, b) {
  return -a.cross(a.clone().sub(b)) / Math.sqrt(a.dist2(b));
}
function epa(A, B, simplex, result) {
  var polytope = new CircularLinkedList();
  var edges = new PriorityQueue(); // queue

  var d = new Vector();

  if (simplex[1].crossRef(simplex[2], simplex[0]) < 0) {
    var swap = simplex[1];
    simplex[1] = simplex[2];
    simplex[2] = swap;
  }

  for (var i = 0; i < simplex.length; i++) {
    var node = polytope.push(simplex[i]);
    var dist = originDistance(simplex[i], simplex[(i + 1) % 3]);
    edges.enqueue(new Edge(node, dist));
  }

  while (true) {
    //console.log(item.distance);
    //console.log(item.startVertex.data);
    //}
    //console.log(Array.from(polytope.values()));

    var _edges$dequeue = edges.dequeue(),
        _startVertex = _edges$dequeue.startVertex,
        _distance = _edges$dequeue.distance;

    var a = _startVertex.data;
    var b = _startVertex.next.data;
    var ab = b.clone().sub(a);

    var ap = _startVertex.prev.data.clone().sub(a);

    tripleProduct(ap, ab, ab, d); //console.log(d);

    var p = support(A, B, d);

    if (p.cross(ab) / ab.len() - _distance > 0.0001) {
      // add p to polytope;
      // update distance
      var _node = polytope.insertAfter(_startVertex, p);

      edges.enqueue(new Edge(_node.prev, originDistance(_node.prev.data, _node.data)));
      edges.enqueue(new Edge(_node, originDistance(_node.data, _node.next.data)));
    } else {
      // ab is the on the boundary
      result.normal = d.normalize();
      result.depth = _distance; //console.log("iteration: " + iter_count);

      return;
    }
  }
} // http://www.fen.bilkent.edu.tr/~ercelebi/Ax(BxC).pdf

/*
function tripleProduct(a:Vector,  b:Vector,  c:Vector,  r: Vector) {
    let ac = a.x * c.x + a.y * c.y; // perform a.dot(c)
    let bc = b.x * c.x + b.y * c.y; // perform b.dot(c)

    // perform b * a.dot(c) - a * b.dot(c)
    r.x = b.x * ac - a.x * bc;
    r.y = b.y * ac - a.y * bc;
    return r;
}

//-----------------------------------------------------------------------------
// This is to compute average center (roughly). It might be different from
// Center of Gravity, especially for bodies with nonuniform density,
// but this is ok as initial direction of simplex search in GJK.

function averagePoint (vertices: Array<Vector>) {
    let avg = new Vector();
    for (let i = 0; i < vertices.length; i++) {
        avg.x += vertices[i].x;
        avg.y += vertices[i].y;
    }
    avg.x /= vertices.length;
    avg.y /= vertices.length;
    return avg;
}

//-----------------------------------------------------------------------------
// Get furthest vertex along a certain direction

function indexOfFurthestPoint (vertices: Array<Vector>, d: Vector) {

    let maxProduct = d.dot(vertices[0]);
    let index = 0;
    for (let i = 1; i < vertices.length; i++) {
        let product = d.dot(vertices[i]);
        if (product > maxProduct) {
            maxProduct = product;
            index = i;
        }
    }
    return index;
}*/
//-----------------------------------------------------------------------------
// Minkowski sum support function for GJK

/*
function support (vertices1: Array<Vector>, vertices2: Array<Vector>, d: Vector) {

    // get furthest point of first body along an arbitrary direction
    let i = indexOfFurthestPoint (vertices1, d);

    // get furthest point of second body along the opposite direction
    let j = indexOfFurthestPoint (vertices2, d.clone().reverse());

    // subtract (Minkowski sum) the two points to see if bodies 'overlap'
    return vertices1[i].clone().sub(vertices2[j]);
}*/
//-----------------------------------------------------------------------------
// The GJK yes/no test

/*
function gjk (vertices1: Array<Vector>, vertices2: Array<Vector>) {
    let iter_count = 0;
    let index = 0; // index of current vertex of simplex
    let a: Vector = new Vector(), b: Vector = new Vector(), c: Vector = new Vector(), d: Vector = new Vector();
    let ao: Vector = new Vector(), ab: Vector = new Vector(), ac: Vector = new Vector();
    let abperp: Vector = new Vector(), acperp: Vector = new Vector();
    let simplex: [Vector, Vector, Vector] = [new Vector(), new Vector(), new Vector()];

    let position1 = averagePoint (vertices1); // not a CoG but
    let position2 = averagePoint (vertices2); // it's ok for GJK )

    // initial direction from the center of 1st body to the center of 2nd body

    d.set(position1).sub(position2);

    // if initial direction is zero – set it to any arbitrary axis (we choose X)
    if ((d.x == 0) && (d.y == 0))
        d.x = 1;

    // set the first support as initial point of the new simplex
    a.set(simplex[0].set(support (vertices1, vertices2, d)));

    if (a.dot(d) <= 0)
        return 0; // no collision

    d.set(a).reverse(); // The next search direction is always towards the origin, so the next search direction is negate(a)

    while (1) {
        iter_count++;

        a.set(simplex[++index].set(support (vertices1, vertices2, d)));

        if (a.dot(d) <= 0)
            return 0; // no collision

        ao.set(a).reverse(); // from point A to Origin is just negative A

        // simplex has 2 points (a line segment, not a triangle yet)
        if (index < 2) {
            b.set(simplex[0]);
            ab.set(b).sub(a); // from point A to B
            tripleProduct (ab, ao, ab, d); // normal to AB towards Origin
            if (d.len2() == 0)
                d.set(ab).perp();
            continue; // skip to next iteration
        }

        b = simplex[1];
        c = simplex[0];
        ab.set(b).sub(a); // from point A to B
        ac.set(c).sub(a); // from point A to C
        tripleProduct(ab, ac, ac, acperp);

        if (acperp.dot(ao) >= 0) {
            d.set(acperp); // new direction is normal to AC towards Origin
        } else {

            tripleProduct (ac, ab, ab, abperp );
            if (abperp.dot(ao) < 0)
                return 1; // collision
            simplex[0].set(simplex[1]); // swap first element (point C)
            d.set(abperp); // new direction is normal to AB towards Origin
        }

        simplex[1].set(simplex[2]); // swap element in the middle (point B)
        --index;
    }
    return 0;
}*/

/* test
function Perturbation()
{
    return Math.random() * FLT_EPSILON * 100.0 * (Math.random() > 0.5 ? 1.0 : -1.0);
}

function Jostle(vec2 a)
{
    vec2 b;
    b.x = a.x + Perturbation();
    b.y = a.y + Perturbation();
    return b;
}
int main(int argc, const char * argv[]) {

    // test case from dyn4j

    vec2 vertices1[] = {
    { 4.0f, 11.0f },
    { 5.0f, 5.0f },
    { 9.0f, 9.0f },
};

    vec2 vertices2[] = {
    { 4.0f, 11.0f },
    { 5.0f, 5.0f },
    { 9.0f, 9.0f },
};

    size_t count1 = sizeof (vertices1) / sizeof (vec2); // == 3
    size_t count2 = sizeof (vertices2) / sizeof (vec2); // == 4

    while (1)
    {
        vec2 a[sizeof (vertices1) / sizeof (vec2)];
        vec2 b[sizeof (vertices2) / sizeof (vec2)];

        for (size_t i = 0; i < count1; ++i) a[i] = Jostle(vertices1[i]);
        for (size_t i = 0; i < count2; ++i) b[i] = Jostle(vertices2[i]);

        int collisionDetected = gjk (a, count1, b, count2);
        if (!collisionDetected)
        {
            printf("Found failing case:\n\t{%f, %f}, {%f, %f}, {%f, %f}\n\t{%f, %f}, {%f, %f}, {%f, %f}\n\n",
                a[0].x, a[0].y, a[1].x, a[1].y, a[2].x, a[2].y,
                b[0].x, b[0].y, b[1].x, b[1].y, b[2].x, b[2].y
            );
        }
        else
        {
            printf("Collision correctly detected\n");
        }
        iter_count = 0;
    }

    return 0;
}*/

var MAX_POC_COUNT = 5;
function resolvePointsOfContact(A, B, result) {
  var normal = result.normal;
  var depth = result.depth;
  var segmentA, segmentB;
  segmentA = A.getFarthestEdgeInDirection(normal);
  segmentB = B.getFarthestEdgeInDirection(normal.clone().reverse());
  var segmentRef, segmentInc;

  if (Math.abs(segmentA.dot(normal)) <= Math.abs(segmentB.dot(normal))) {
    segmentRef = segmentA;
    segmentInc = segmentB;
  } else {
    segmentInc = segmentA;
    segmentRef = segmentB;
  }

  var refv = segmentRef.v2.clone().sub(segmentRef.v1);
  refv.normalize();
  var o1 = refv.dot(segmentRef.v1); // clip the incident edge by the first
  // vertex of the reference edge

  var cp = clip(segmentInc.v1, segmentInc.v2, refv, o1); // if we dont have 2 points left then fail

  if (cp.length < 2) {
    console.log("error: impossible poc situation");
    return;
  } // clip whats left of the incident edge by the
  // second vertex of the reference edge
  // but we need to clip in the opposite direction
  // so we flip the direction and offset


  var o2 = refv.dot(segmentRef.v2);
  cp = clip(cp[0], cp[1], refv.clone().scl(-1), -o2); // if we dont have 2 points left then fail

  if (cp.length < 2) {
    console.log("error: impossible poc situation");
    return;
  }

  for (var i = 0; i < 2; i++) {
    var vcp = cp[i].crossRef(segmentRef.v2, segmentRef.v1);
    if (vcp < 0.01) result.contacts.push(cp[i]);
  }

  if (result.contacts.length < 1) {
    console.log(A);
    console.log(B);
    console.log(result);
    console.log(cp[0]);
    console.log(cp[1]);
    console.log(segmentRef.v2);
    console.log(segmentRef.v1);
    console.log(cp[0].crossRef(segmentRef.v2, segmentRef.v1));
    console.log(cp[1].crossRef(segmentRef.v2, segmentRef.v1));
    console.log("error: impossible poc situation");
  }
}
function clip(v1, v2, n, o) {
  var cp = new Array();
  var d1 = n.dot(v1) - o;
  var d2 = n.dot(v2) - o; // if either point is past o along n
  // then we can keep the point

  if (d1 >= 0.0) cp.push(v1);
  if (d2 >= 0.0) cp.push(v2); // finally we need to check if they
  // are on opposing sides so that we can
  // compute the correct point

  if (d1 * d2 < 0.0) {
    // if they are on different sides of the
    // offset, d1 and d2 will be a (+) * (-)
    // and will yield a (-) and therefore be
    // less than zero
    // get the vector for the edge we are clipping
    var e = v2.clone().sub(v1); // compute the location along e

    var u = d1 / (d1 - d2);
    e.scl(u);
    e.add(v1); // add the point

    cp.push(e);
  }

  return cp;
}
function resolvePointsOfContact2(A, B, result) {
  var normal = result.normal;
  var depth = result.depth;
  var segmentA, segmentB;
  segmentA = A.getFarthestEdgeInDirection(normal);
  segmentB = B.getFarthestEdgeInDirection(normal.clone().reverse());
  var segmentRef, segmentInc;

  if (Math.abs(segmentA.dot(normal)) <= Math.abs(segmentB.dot(normal))) {
    segmentRef = segmentA;
    segmentInc = segmentB;
  } else {
    segmentInc = segmentA;
    segmentRef = segmentB;
  }

  var d1 = segmentInc.v1.dotRef(segmentRef.v2, segmentRef.v1);
  var d2 = segmentInc.v2.dotRef(segmentRef.v2, segmentRef.v1);

  if (d1 > d2) {
    var swap = d1;
    d1 = d2;
    d2 = swap;
    var swapP = segmentInc.v1;
    segmentInc.v1 = segmentInc.v2;
    segmentInc.v2 = swapP;
  }

  var u1 = -d1 / (d2 - d1);
  var u2 = (segmentRef.len2() - d1) / (d2 - d1);
  var v1, v2;

  if (u1 > 0 && u1 < 1) {
    v1 = segmentInc.lerp(u1);
  } else {
    v1 = segmentInc.v1.clone();
  }

  if (u2 > 0 && u2 < 1) {
    v2 = segmentInc.lerp(u2);
  } else {
    v2 = segmentInc.v2.clone();
  }

  console.log(v1);
  console.log(v2);
  var v1c = v1.crossRef(segmentRef.v2, segmentRef.v1);
  var v2c = v2.crossRef(segmentRef.v2, segmentRef.v1);
  var startV, endV;

  if (v1c <= 0.01) {
    if (v2c <= 0.01) {
      startV = v1;
      endV = v2;
    } else {
      startV = v1;
      endV = v1;
    }
  } else {
    if (v2c <= 0.01) {
      startV = v2;
      endV = v2;
    } else {
      // TODO: replace with logger
      console.log(A);
      console.log(B);
      console.log(result);
      console.log("error: impossible poc situation");
      return;
    }
  } //console.log(startV);
  //console.log(endV);


  if (startV === endV) {
    result.contacts.push(startV);
  } else {
    for (var i = 0; i < 1 - 0.001; i += 1 / (MAX_POC_COUNT - 1)) {
      result.contacts.push(Vector.lerp(startV, endV, i));
    }

    result.contacts.push(endV);
  }
}

(function (VORONOI_REGION) {
  VORONOI_REGION[VORONOI_REGION["LEFT"] = 0] = "LEFT";
  VORONOI_REGION[VORONOI_REGION["UP"] = 1] = "UP";
  VORONOI_REGION[VORONOI_REGION["DOWN"] = 2] = "DOWN";
  VORONOI_REGION[VORONOI_REGION["RIGHT"] = 3] = "RIGHT";
})(exports.VORONOI_REGION || (exports.VORONOI_REGION = {}));

var Segment = /*#__PURE__*/function () {
  function Segment(v1, v2) {
    classCallCheck(this, Segment);

    defineProperty(this, "v1", void 0);

    defineProperty(this, "v2", void 0);

    this.v1 = v1;
    this.v2 = v2;
  }

  createClass(Segment, [{
    key: "getAABB",
    value: function getAABB() {
      return new AABB(Math.min(this.v1.x, this.v2.x), Math.min(this.v1.y, this.v2.y), Math.max(this.v1.x, this.v2.x), Math.max(this.v1.y, this.v2.y));
    }
  }, {
    key: "contains",
    value: function contains(v) {
      return lineHasPoint(this.v1, this.v2, v, 1);
    }
  }, {
    key: "dot",
    value: function dot(dir) {
      return (this.v2.x - this.v1.x) * dir.x + (this.v2.y - this.v1.y) * dir.y;
    }
    /**
    * Calculates which Voronoi region a point is on a line segment.
    * It is assumed that both the line and the point are relative to `(0,0)`
    *
    *            |       (1)      |
    *     (0)  [S]--------------[E]  (3)
    *            |       (2)      |
    * @param {Vector} point The point.
    * @return  {VORONOI_REGION} VORONOI_REGION.LEFT (0) if it is the left region,
    *          VORONOI_REGION.UP (1) if it is the up region,
    *          VORONOI_REGION.DOWN (2) if it is the down region.
    *          VORONOI_REGION.RIGHT (3) if it is the right region.
    */

  }, {
    key: "voronoiRegion",
    value: function voronoiRegion(point) {
      var len2 = this.len2();
      var dp = point.dotRef(this.v2, this.v1); // If the point is beyond the start of the line, it is in the
      // left voronoi region.

      if (dp < 0) {
        return exports.VORONOI_REGION.LEFT;
      } // If the point is beyond the end of the line, it is in the
      // right voronoi region.
      else if (dp > len2) {
          return exports.VORONOI_REGION.RIGHT;
        } // Otherwise, it's in the middle one.
        else {
            if (point.crossRef(this.v2, this.v1) < 0) return exports.VORONOI_REGION.UP;else return exports.VORONOI_REGION.DOWN;
          }
    }
  }, {
    key: "len2",
    value: function len2() {
      return this.v2.dist2(this.v1);
    }
  }, {
    key: "len",
    value: function len() {
      return this.v2.dist(this.v1);
    }
  }, {
    key: "lerp",
    value: function lerp(t) {
      return Vector.lerp(this.v1, this.v2, t);
    }
  }]);

  return Segment;
}();

var Transform = /*#__PURE__*/function () {
  /** the cosine of the rotation angle */

  /** the sine of the rotation angle */

  /** The x,y translation */
  function Transform(transform) {
    classCallCheck(this, Transform);

    defineProperty(this, "cost", 1.0);

    defineProperty(this, "sint", 0.0);

    defineProperty(this, "_pos", new Vector());

    if (transform instanceof Transform) {
      this.cost = transform.cost;
      this.sint = transform.sint;
      this._pos.x = transform._pos.x;
      this._pos.y = transform._pos.y;
    } else if (transform instanceof Vector) {
      this.cost = 1;
      this.sint = 0;
      this._pos.x = transform.x;
      this._pos.y = transform.y;
    } else {
      this.cost = 1;
      this.sint = 0;
      this._pos.x = 0;
      this._pos.y = 0;
    }
  }
  /**
   * Internal helper method to rotate this {@link Transform} by an angle &thetasym; around a point
   * @param theta theta
   * @param x the x coordinate of the point
   * @param y the y coordinate of the point
   * @since 3.3.1
   */


  createClass(Transform, [{
    key: "rotate",
    value: function rotate(theta, x, y) {
      // pre-compute cos/sin of the given angle
      var cos = Math.cos(theta);
      var sin = Math.sin(theta); // perform an optimized version of the matrix multiplication:
      // M(new) = inverse(T) * R * T * M(old)

      var cost = cos * this.cost - sin * this.sint;
      var sint = sin * this.cost + cos * this.sint;
      this.cost = cost;
      this.sint = sint;
      var cx = this._pos.x - x;
      var cy = this._pos.y - y;
      this._pos.x = cos * cx - sin * cy + x;
      this._pos.y = sin * cx + cos * cy + y;
    }
  }, {
    key: "translate",
    value: function translate(x, y) {
      this._pos.x += x;
      this._pos.y += y;
    }
  }, {
    key: "transform",
    value: function transform(vector, tv) {
      var x = vector.x;
      var y = vector.y;
      tv.x = this.cost * x - this.sint * y + this._pos.x;
      tv.y = this.sint * x + this.cost * y + this._pos.y;
      return tv;
    }
  }, {
    key: "inverseTransform",
    value: function inverseTransform(vector, tv) {
      var tx = vector.x - this._pos.x;
      var ty = vector.y - this._pos.y;
      tv.x = this.cost * tx + this.sint * ty;
      tv.y = -this.sint * tx + this.cost * ty;
      return tv;
    }
    /**
     * Sets this transform to the given transform.
     * @param transform the transform to copy
     */

  }, {
    key: "set",
    value: function set(transform) {
      this.cost = transform.cost;
      this.sint = transform.sint;
      this._pos.x = transform._pos.x;
      this._pos.y = transform._pos.y;
      return this;
    }
  }, {
    key: "mulTransform",
    value: function mulTransform(transform) {
      transform.transform(this._pos, this._pos);
      var cost = transform.cost * this.cost - transform.sint * this.sint;
      var sint = transform.sint * this.cost + transform.cost * this.sint;
      this.cost = cost;
      this.sint = sint;
      return this;
    }
  }, {
    key: "inverse",
    value: function inverse() {
      var sint = this.sint;
      var cost = this.cost;
      var x = this._pos.x;
      var y = this._pos.y;
      this._pos.x = -sint * y - cost * x;
      this._pos.y = sint * x - cost * y;
      this.sint = -sint;
      return this;
    }
    /* A * B = C
       C * B^(-1) = A
        [cost, -sint, x] [x] = [cost * x - sint * y + x]
        [sint, cost,  y] [y]   [sint * x + cost * y + x]
        [0,    0,     1] [1]   [1]
         [cost, -sint, x] [x] = [cost * x - sint * y + x]
        [sint, cost,  y] [y]   [sint * x + cost * y + x]
        [0,    0,     1] [1]   [1]
         [cost, -sint, x] [coss, -sins, x] = [cost * coss - sint * sins, , cost * x - sint * y + x]
        [sint, cost,  y] [sins, coss,  y]   [sint * coss + cost * sins, , sint * x + cost * y + x]
        [0,    0,     1] [0,    0,     1]   [0, 0, 1]
         [cost, -sint, x] ^1 = [cost,  sint, -sint * y - cost * x]
        [sint, cost,  y]      [-sint, cost, sint * x - cost * y]
        [0,    0,     1]      [0,     0,     1]
      */

  }, {
    key: "mulInverseTransform",
    value: function mulInverseTransform(transform) {
      return this.mulTransform(transform.clone().inverse());
    }
  }, {
    key: "clone",
    value: function clone() {
      return new Transform(this);
    }
    /**
     * Interpolates linearly by alpha towards the given end transform placing
     * the result in the given transform.
     * <p>
     * Interpolating from one angle to another can have two results depending on the
     * direction of the rotation.  If a rotation was from 30 to 200 the rotation could
     * be 170 or -190.  This interpolation method will always choose the smallest
     * rotation (regardless of sign) as the rotation direction.
     * @param end the end transform
     * @param alpha the amount to interpolate
     * @param result the transform to place the result
     * @since 1.2.0
     */

  }, {
    key: "lerp",
    value: function lerp(end, alpha, result) {
      // interpolate the position
      var x = this.x + alpha * (end.x - this.x);
      var y = this.y + alpha * (end.y - this.y); // compute the angle
      // get the start and end rotations
      // its key that these methods use atan2 because
      // it ensures that the angles are always within
      // the range -pi < theta < pi therefore no
      // normalization has to be done

      var rs = this.angle;
      var re = end.angle; // make sure we use the smallest rotation
      // as described in the comments above, there
      // are two possible rotations depending on the
      // direction, we always choose the smaller

      var diff = re - rs;
      if (diff < -Math.PI) diff += Geom2Const.PI2;
      if (diff > Math.PI) diff -= Geom2Const.PI2; // interpolate
      // its ok if this method produces an angle
      // outside the range of -pi < theta < pi
      // since the rotate method uses sin and cos
      // which are not bounded

      var a = diff * alpha + rs; // set the result transform to the interpolated transform
      // the following performs the following calculations:
      // result.identity();
      // result.rotate(a);
      // result.translate(x, y);

      result.cost = Math.cos(a);
      result.sint = Math.sin(a);
      result.position.x = x;
      result.position.y = y;
    }
  }, {
    key: "toString",
    value: function toString() {
      return "[x:".concat(this.position.x, ", y:").concat(this.position.y, ", a:").concat(this.angle / Math.PI * 180, "]");
    }
  }, {
    key: "angle",
    set: function set(theta) {
      this.cost = Math.cos(theta);
      this.sint = Math.sin(theta);
    }
    /**
     * Returns the rotation.
     * @return double angle in the range [-&pi;, &pi;]
     */
    ,
    get: function get() {
      return Math.atan2(this.sint, this.cost);
    }
  }, {
    key: "position",
    set: function set(pos) {
      this._pos.set(pos);
    },
    get: function get() {
      return this._pos;
    }
  }, {
    key: "x",
    get: function get() {
      return this._pos.x;
    }
  }, {
    key: "y",
    get: function get() {
      return this._pos.y;
    }
  }]);

  return Transform;
}();

var TEMP = new Vector();
var Circle = /*#__PURE__*/function () {
  createClass(Circle, [{
    key: "center",
    get: function get() {
      return this.transform.position;
    }
  }]);

  function Circle(c, r) {
    classCallCheck(this, Circle);

    defineProperty(this, "transform", void 0);

    defineProperty(this, "r", void 0);

    this.transform = new Transform(c);
    this.r = r;
  } // Rotates this polygon counter-clockwise around the origin of *its local coordinate system* (i.e. `pos`).


  createClass(Circle, [{
    key: "rotate",
    value: function rotate(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Vector.ZERO;
      this.transform.rotate(angle, center.x, center.y);
      return this;
    } // Translates the points of this polygon by a specified amount relative to the origin of *its own coordinate

  }, {
    key: "translate",
    value: function translate(x, y) {
      this.transform.translate(x, y);
      return this;
    }
  }, {
    key: "intersects",
    value: function intersects(shape, result) {
      var simplex = [new Vector(), new Vector(), new Vector()];
      var collided = gjk(this, shape, simplex);

      if (result && collided) {
        epa(this, shape, simplex, result);
        resolvePointsOfContact(this, shape, result); //throw new Error("shape intersects unavailable");

        return true;
      }

      return collided;
    }
  }, {
    key: "getAABB",
    value: function getAABB() {
      return new AABB(this.center.x - this.r, this.center.y - this.r, this.center.x + this.r, this.center.y + this.r);
    }
  }, {
    key: "isPointIn",
    value: function isPointIn(v) {
      return v.dist(this.center) <= this.r;
    }
  }, {
    key: "getArea",
    value: function getArea() {
      return this.r * this.r * Math.PI;
    }
  }, {
    key: "getOrigin",
    value: function getOrigin() {
      return this.center;
    }
  }, {
    key: "getCentroid",
    value: function getCentroid() {
      return this.center;
    }
  }, {
    key: "getFarthestPointInDirection",
    value: function getFarthestPointInDirection(d) {
      return d.clone().setLen(this.r).add(this.center);
    }
  }, {
    key: "getFarthestEdgeInDirection",
    value: function getFarthestEdgeInDirection(d) {
      TEMP.set(d).normalize();
      return new Segment(TEMP.clone().perp().scl(this.r * 0.01).addMul(TEMP, this.r).add(this.center), TEMP.clone().perp().scl(-this.r * 0.01).addMul(TEMP, this.r).add(this.center));
    }
  }, {
    key: "toString",
    value: function toString() {
      return "{p:".concat(this.transform.position, ", rot:").concat(this.transform.angle, ", rad:").concat(this.r, "}");
    }
  }]);

  return Circle;
}();

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
var TEMP$1 = new Vector();
/**
 * Polygon in this class satisfies:
 * 1. It must be a simple polygon.
 * 2. It contain the point (0, 0).
 * 3. Points are sorted in counter-clockwise order from it's center.
 */

var Polygon = /*#__PURE__*/function () {
  //public pos: Vector;
  function Polygon(pos, points) {
    classCallCheck(this, Polygon);

    defineProperty(this, "transform", void 0);

    defineProperty(this, "points", void 0);

    defineProperty(this, "calcPoints", void 0);

    this.transform = new Transform(pos);
    this.points = points;
    this.calcPoints = new Array();
    this.recalc();
  }

  createClass(Polygon, [{
    key: "rotate",
    // Rotates this polygon counter-clockwise around the origin of *its local coordinate system* (i.e. `pos`).
    value: function rotate(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Vector.ZERO;
      this.transform.rotate(angle, center.x, center.y);
      return this;
    } // Translates the points of this polygon by a specified amount relative to the origin of *its own coordinate

  }, {
    key: "translate",
    value: function translate(x, y) {
      this.transform.translate(x, y);
      return this;
    }
  }, {
    key: "rotateLocal",
    // Rotates this polygon counter-clockwise around the origin of *its local coordinate system* (i.e. `pos`).
    value: function rotateLocal(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Vector.ZERO;

      for (var i = 0; i < this.points.length; i++) {
        this.points[i].rotate(angle, center);
      }
    } // Translates the points of this polygon by a specified amount relative to the origin of *its own coordinate

  }, {
    key: "translateLocal",
    value: function translateLocal(x, y) {
      var points = this.points;
      var len = points.length;

      for (var i = 0; i < len; i++) {
        points[i].x += x;
        points[i].y += y;
      }

      return this;
    }
  }, {
    key: "recalc",
    // Calculated points - this is what is used for underlying collisions and takes into account
    // the angle/offset set on the polygon.
    value: function recalc() {
      var lengthChanged = this.points.length !== this.calcPoints.length;

      if (lengthChanged) {
        while (this.points.length < this.calcPoints.length) {
          this.calcPoints.pop();
        }

        while (this.points.length > this.calcPoints.length) {
          this.calcPoints.push(new Vector());
        }
      } // Copy the original points array and apply the offset/angle


      var points = this.points;
      var len = points.length;
      var i;

      for (i = 0; i < len; i++) {
        this.transform.transform(points[i], this.calcPoints[i]);
      }

      return this;
    }
  }, {
    key: "getOrigin",
    value: function getOrigin() {
      return this.transform.position;
    }
  }, {
    key: "getCentroid",
    value: function getCentroid() {
      var points = this.calcPoints;
      var len = points.length;
      var cx = 0;
      var cy = 0;
      var ar = 0;

      for (var i = 0; i < len; i++) {
        var p1 = points[i];
        var p2 = i === len - 1 ? points[0] : points[i + 1]; // Loop around if last point

        var a = p1.x * p2.y - p2.x * p1.y;
        cx += (p1.x + p2.x) * a;
        cy += (p1.y + p2.y) * a;
        ar += a;
      }

      ar = ar * 3; // we want 1 / 6 the area and we currently have 2*area

      cx = cx / ar;
      cy = cy / ar;
      return new Vector(cx, cy);
    }
  }, {
    key: "intersects",
    value: function intersects(shape, result) {
      var simplex = [new Vector(), new Vector(), new Vector()];
      var collided = gjk(this, shape, simplex);

      if (result && collided) {
        epa(this, shape, simplex, result);
        resolvePointsOfContact(this, shape, result); //throw new Error("shape intersects unavailable");

        return true;
      }

      return collided;
    }
  }, {
    key: "isPointIn",
    value: function isPointIn(v) {
      var points = this.calcPoints;
      var length = points.length;
      var c = false;
      var i;

      for (i = 0; i < length; i++) {
        if (points[i].y > v.y !== points[(i + 1) % length].y > v.y && v.x < (points[(i + 1) % length].x - points[i].x) * (v.y - points[i].y) / (points[(i + 1) % length].y - points[i].y) + points[i].x) {
          c = !c;
        }
      }

      if (c) {
        return true;
      }

      for (i = 0; i < length; i++) {
        var p1 = points[i];
        var p2 = points[(i + 1) % length];

        if (lineHasPoint(p1, p2, v, 1)) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: "getAABB",
    value: function getAABB() {
      return Polygon.getAABBFromPoints(this.calcPoints);
    }
  }, {
    key: "getOriginAABB",
    value: function getOriginAABB() {
      return Polygon.getAABBFromPoints(this.calcPoints);
    }
  }, {
    key: "getArea",
    value: function getArea() {
      var points = this.points;
      var len = points.length;
      var ar = 0;

      for (var i = 0; i < len; i++) {
        var p1 = points[i];
        var p2 = i === len - 1 ? points[0] : points[i + 1]; // Loop around if last point

        var a = p1.x * p2.y - p2.x * p1.y;
        ar += a;
      }

      return ar / 2;
    }
  }, {
    key: "toCanvasDraw",
    value: function toCanvasDraw() {
      var scale = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      var points = this.points;
      var len = points.length;
      var str = 'ctx.beginPath();\n';
      str += 'ctx.strokeStyle = "black";\n';
      str += 'ctx.moveTo(' + (points[0].x + this.transform.x) * scale + ',' + (points[0].y + this.transform.y) * scale + ');\n';

      for (var i = 1; i < len; i++) {
        str += 'ctx.lineTo(' + (points[i].x + this.transform.x) * scale + ',' + (points[i].y + this.transform.y) * scale + ');\n';
      }

      str += 'ctx.lineTo(' + (points[0].x + this.transform.x) * scale + ',' + (points[0].y + this.transform.y) * scale + ');\n';
      str += 'ctx.stroke();';
      return str;
    }
  }, {
    key: "getFarthestIndexInDirection",
    value: function getFarthestIndexInDirection(d) {
      var vertices = this.calcPoints;
      TEMP$1.set(vertices[0]).sub(this.transform.position);
      var maxProduct = d.dot(TEMP$1);
      var index = 0;

      for (var i = 1; i < vertices.length; i++) {
        TEMP$1.set(vertices[i]).sub(this.transform.position);
        var product = d.dot(TEMP$1);

        if (product > maxProduct) {
          maxProduct = product;
          index = i;
        }
      }

      return index;
    }
  }, {
    key: "getFarthestPointInDirection",
    value: function getFarthestPointInDirection(d) {
      return this.calcPoints[this.getFarthestIndexInDirection(d)].clone();
    }
  }, {
    key: "getFarthestEdgeInDirection",
    value: function getFarthestEdgeInDirection(d) {
      var vertices = this.calcPoints;
      var index = this.getFarthestIndexInDirection(d);
      var p0 = vertices[(index - 1 + vertices.length) % vertices.length];
      var p1 = vertices[index];
      var p2 = vertices[(index + 1) % vertices.length];
      var l = p1.clone().sub(p0).normalize();
      var r = p1.clone().sub(p2).normalize();

      if (r.dot(d) < l.dot(d)) {
        return new Segment(p1, p2);
      } else {
        return new Segment(p0, p1);
      }
    }
  }, {
    key: "recenter",
    value: function recenter() {
      var c = this.getCentroid();

      var _iterator = _createForOfIteratorHelper(this.points),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var p = _step.value;
          p.sub(c);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      this.transform.translate(c.x, c.y);
      this.recalc();
    }
  }, {
    key: "originPoints",
    get: function get() {
      return this.points;
    }
  }], [{
    key: "fromAABB",
    value: function fromAABB(aabb) {
      return new Polygon(aabb.getCenter(), [new Vector(-aabb.width / 2, -aabb.height / 2), new Vector(aabb.width / 2, -aabb.height / 2), new Vector(aabb.width / 2, aabb.height / 2), new Vector(-aabb.width / 2, aabb.height / 2)]);
    }
  }, {
    key: "getAABBFromPoints",
    value: function getAABBFromPoints(points) {
      var len = points.length;
      var xMin = points[0].x;
      var yMin = points[0].y;
      var xMax = points[0].x;
      var yMax = points[0].y;

      for (var i = 1; i < len; i++) {
        var point = points[i];

        if (point.x < xMin) {
          xMin = point.x;
        } else if (point.x > xMax) {
          xMax = point.x;
        }

        if (point.y < yMin) {
          yMin = point.y;
        } else if (point.y > yMax) {
          yMax = point.y;
        }
      }

      return new AABB(xMin, yMin, xMax, yMax);
    }
  }]);

  return Polygon;
}();

var ComposedShape = /*#__PURE__*/function () {
  function ComposedShape(shapes, transform) {
    classCallCheck(this, ComposedShape);

    this.shapes = shapes;

    defineProperty(this, "transform", void 0);

    defineProperty(this, "localTransforms", []);

    if (transform == null) {
      var centroid = this.getCentroid();
      this.transform = new Transform(centroid);
    } else {
      this.transform = transform;
    }

    for (var i = 0; i < shapes.length; i++) {
      this.localTransforms.push(shapes[i].transform.clone().mulInverseTransform(this.transform));
    }
  }

  createClass(ComposedShape, [{
    key: "recalc",
    value: function recalc() {
      for (var k = 0; k < this.shapes.length; k++) {
        this.shapes[k].transform.set(this.localTransforms[k]).mulTransform(this.transform);

        if (this.shapes[k] instanceof Polygon) {
          this.shapes[k].recalc();
        }
      }
    } // Rotates this polygon counter-clockwise around the center

  }, {
    key: "rotate",
    value: function rotate(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.transform.position;
      this.transform.rotate(angle, center.x, center.y);

      for (var k = 0; k < this.shapes.length; k++) {
        this.shapes[k].transform.set(this.localTransforms[k]).mulTransform(this.transform); //.rotate(angle, center);
      }

      return this;
    } // Translates this shape by a specified amount

  }, {
    key: "translate",
    value: function translate(x, y) {
      this.transform.translate(x, y);

      for (var k = 0; k < this.shapes.length; k++) {
        this.shapes[k].transform.set(this.localTransforms[k]).mulTransform(this.transform);
      }

      return this;
    }
  }, {
    key: "rotateLocal",
    value: function rotateLocal(angle) {
      return this;
    }
  }, {
    key: "translateLocal",
    value: function translateLocal(x, y) {
      return this;
    }
  }, {
    key: "isPointIn",
    value: function isPointIn(vector) {
      for (var k = 0; k < this.shapes.length; k++) {
        if (this.shapes[k].isPointIn(vector)) return true;
      }

      return false;
    }
  }, {
    key: "getArea",
    value: function getArea() {
      var area = 0;

      for (var k = 0; k < this.shapes.length; k++) {
        area += this.shapes[k].getArea();
      }

      return area;
    }
  }, {
    key: "getCentroid",
    value: function getCentroid() {
      var v = new Vector();
      var c = 0;

      for (var k = 0; k < this.shapes.length; k++) {
        var area = this.shapes[k].getArea();
        v.addMul(this.shapes[k].getCentroid(), area);
        c += area;
      }

      v.scl(1.0 / c);
      return v;
    }
  }, {
    key: "getOrigin",
    value: function getOrigin() {
      return this.transform.position;
    }
  }, {
    key: "getAABB",
    value: function getAABB() {
      var aabb = this.shapes[0].getAABB();

      for (var k = 1; k < this.shapes.length; k++) {
        aabb.merge(this.shapes[k].getAABB());
      }

      return aabb;
    }
  }]);

  return ComposedShape;
}();

function _createForOfIteratorHelper$1(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$1(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray$1(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$1(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$1(o, minLen); }

function _arrayLikeToArray$1(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var LQTreeElement = function LQTreeElement(aabb, data) {
  classCallCheck(this, LQTreeElement);

  defineProperty(this, "aabb", void 0);

  defineProperty(this, "data", void 0);

  this.aabb = aabb;
  this.data = data;
};

var LQTreeNode = /*#__PURE__*/function () {
  // only if the count > 0, looseBound has meaning.
  function LQTreeNode(minX, minY, maxX, maxY) {
    classCallCheck(this, LQTreeNode);

    defineProperty(this, "children", void 0);

    defineProperty(this, "baseBound", void 0);

    defineProperty(this, "count", void 0);

    defineProperty(this, "looseBound", void 0);

    defineProperty(this, "elements", void 0);

    this.children = null;
    this.baseBound = new AABB(minX, minY, maxX, maxY);
    this.looseBound = new AABB(0, 0, 0, 0);
    this.elements = [];
    this.count = 0;
  }

  createClass(LQTreeNode, [{
    key: "extendLooseBound",
    value: function extendLooseBound(result) {
      if (this.count > 0) result.merge(this.looseBound);
    }
  }, {
    key: "contains",
    value: function contains(aabb) {
      if (this.count > 0) return this.looseBound.contains(aabb);
      return false;
    }
  }, {
    key: "intersects",
    value: function intersects(aabb) {
      if (this.count > 0) return aabb.intersects(this.looseBound);
      return false;
    }
  }, {
    key: "getRegion",
    value: function getRegion(aabb) {
      var index = 0;
      if (aabb.centerX > this.baseBound.centerX) index += 2;
      if (aabb.centerY > this.baseBound.centerY) index += 1;
      return index;
    }
  }, {
    key: "addElement",
    value: function addElement(element) {
      this.elements.push(element);
      if (this.elements.length == 1) this.looseBound.set(element.aabb);
      this.looseBound.merge(element.aabb);
    }
  }, {
    key: "recalcBound",
    value: function recalcBound() {
      if (this.children === null) {
        // leaf
        if (this.elementCount > 0) {
          this.looseBound.set(this.elements[0].aabb);

          for (var i = 1; i < this.elements.length; i++) {
            this.looseBound.merge(this.elements[i].aabb);
          }
        }
      } else {
        // branch
        for (var _i = 0; _i < 3; _i++) {
          this.children[_i].extendLooseBound(this.looseBound);
        }
      }
    }
  }, {
    key: "getElements",
    value: function getElements() {
      return this.elements;
    }
  }, {
    key: "removeElement",
    value: function removeElement(element) {
      for (var i = 0; i < this.elements.length; i++) {
        if (element === this.elements[i]) {
          this.elements.splice(i, 1);
          return true;
        }
      }

      return false;
    }
  }, {
    key: "clearElements",
    value: function clearElements() {
      this.elements.length = 0;
    }
  }, {
    key: "toString",
    value: function toString() {
      var indentNum = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var str = '';
      var indent = '';

      for (var i = 0; i < indentNum; i++) {
        indent += ' ';
      }

      str += indent + 'count: ' + this.count + '\n';
      str += indent + 'baseBound: ' + this.baseBound + '\n';
      str += indent + 'looseBound: ' + this.looseBound + '\n';

      if (this.children === null) {
        str += indent + 'element: \n';

        var _iterator = _createForOfIteratorHelper$1(this.elements),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var element = _step.value;
            str += indent + '  ' + element.aabb + ' data: ' + element.data + '\n';
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      } else {
        for (var _i2 = 0; _i2 < 4; _i2++) {
          str += indent + 'node' + _i2 + ':\n' + this.children[_i2].toString(indentNum + 2);
        }
      }

      return str;
    }
  }, {
    key: "toCanvasParameter",
    value: function toCanvasParameter(aabb) {
      return aabb.left + ', ' + aabb.bottom + ', ' + (aabb.right - aabb.left) + ', ' + (aabb.top - aabb.bottom);
    }
  }, {
    key: "toCanvasDraw",
    value: function toCanvasDraw() {
      var str = '';
      str += 'ctx.beginPath();';
      str += 'ctx.strokeStyle = "green";\n';
      str += 'ctx.rect(' + this.toCanvasParameter(this.baseBound) + ');\n';
      str += 'ctx.stroke();\n';

      if (this.count > 0) {
        str += 'ctx.beginPath();';
        str += 'ctx.strokeStyle = "blue";\n';
        str += 'ctx.rect(' + this.toCanvasParameter(this.looseBound) + ');\n';
        str += 'ctx.stroke();\n';
      }

      if (this.children === null) {
        str += 'ctx.beginPath();';
        str += 'ctx.strokeStyle = "red";\n';

        var _iterator2 = _createForOfIteratorHelper$1(this.elements),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var element = _step2.value;
            str += 'ctx.rect(' + this.toCanvasParameter(element.aabb) + ');\n';
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }

        str += 'ctx.stroke();\n';
      } else {
        for (var i = 0; i < 4; i++) {
          str += this.children[i].toCanvasDraw();
        }
      }

      return str;
    }
  }, {
    key: "elementCount",
    get: function get() {
      return this.elements.length;
    }
  }]);

  return LQTreeNode;
}();
/**
 * Loose QuadTree
 */


var LQTree = /*#__PURE__*/function () {
  // public for testing
  function LQTree(width, height) {
    var maxChildren = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 4;
    var maxLayer = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 10;

    classCallCheck(this, LQTree);

    defineProperty(this, "maxChildren", void 0);

    defineProperty(this, "maxLayer", void 0);

    defineProperty(this, "root", void 0);

    defineProperty(this, "idGenerator", void 0);

    defineProperty(this, "elementMap", void 0);

    this.root = new LQTreeNode(0, 0, width, height);
    this.elementMap = new Map();
    this.maxChildren = maxChildren;
    this.maxLayer = maxLayer;
    this.idGenerator = 1;
  }

  createClass(LQTree, [{
    key: "insert",
    value: function insert(aabb, data) {
      var element = new LQTreeElement(aabb, data);
      this.insertNode(this.root, element, 0);
      this.elementMap.set(this.idGenerator, element);
      this.idGenerator++;
      return this.idGenerator - 1;
    }
  }, {
    key: "insertNode",
    value: function insertNode(node, element, layer) {
      if (node.children === null) {
        node.addElement(element);
        if (node.elementCount > this.maxChildren && layer < this.maxLayer) this.split(node, layer + 1);
      } else {
        var index = node.getRegion(element.aabb);
        this.insertNode(node.children[index], element, layer + 1);
        node.looseBound.merge(element.aabb);
      }

      node.count++;
    }
  }, {
    key: "split",
    value: function split(node, layer) {
      node.children = [new LQTreeNode(node.baseBound.left, node.baseBound.bottom, node.baseBound.centerX, node.baseBound.centerY), new LQTreeNode(node.baseBound.left, node.baseBound.centerY, node.baseBound.centerX, node.baseBound.top), new LQTreeNode(node.baseBound.centerX, node.baseBound.bottom, node.baseBound.right, node.baseBound.centerY), new LQTreeNode(node.baseBound.centerX, node.baseBound.centerY, node.baseBound.right, node.baseBound.top)];

      var _iterator3 = _createForOfIteratorHelper$1(node.getElements()),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var element = _step3.value;
          var index = node.getRegion(element.aabb);
          node.children[index].addElement(element);
          node.children[index].count++;

          if (node.children[index].elementCount > this.maxChildren && layer < this.maxLayer) {
            this.split(node.children[index], layer + 1);
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      node.clearElements();
    }
  }, {
    key: "delete",
    value: function _delete(id) {
      var element = this.elementMap.get(id);

      if (element !== undefined) {
        if (this.deleteInNode(this.root, element)) {
          this.elementMap["delete"](id);
          return true;
        }

        return false;
      }

      return false;
    }
  }, {
    key: "deleteInNode",
    value: function deleteInNode(node, element) {
      if (node.children === null) {
        // leaf
        if (node.removeElement(element)) {
          node.count--;
          node.recalcBound();
          return true;
        }

        return false;
      } else {
        // branch
        var index = node.getRegion(element.aabb);
        var succeed = this.deleteInNode(node.children[index], element);

        if (succeed) {
          node.count--;
          if (node.count > 0) node.recalcBound();else {
            // no node in children, convert to leaf
            node.children = null;
          }
        }

        return succeed;
      }
    }
  }, {
    key: "getAll",
    value: function getAll(query, result) {
      this.searchNode(this.root, query, function (data) {
        result.push(data);
        return false;
      });
      return result;
    } // callBack if return true stop search

  }, {
    key: "search",
    value: function search(query, callBack) {
      this.searchNode(this.root, query, callBack);
    }
  }, {
    key: "searchNode",
    value: function searchNode(node, query, callBack) {
      if (node.children === null) {
        var _iterator4 = _createForOfIteratorHelper$1(node.getElements()),
            _step4;

        try {
          for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
            var element = _step4.value;

            if (query.intersects(element.aabb)) {
              if (callBack(element.data)) {
                return true;
              }
            }
          }
        } catch (err) {
          _iterator4.e(err);
        } finally {
          _iterator4.f();
        }
      } else {
        for (var i = 0; i < 4; i++) {
          if (node.children[i].intersects(query)) {
            var stop = this.searchNode(node.children[i], query, callBack);

            if (stop) {
              return true;
            }
          }
        }
      }

      return false;
    }
  }, {
    key: "toString",
    value: function toString() {
      return this.root.toString(0);
    }
  }, {
    key: "toCanvasDraw",
    value: function toCanvasDraw() {
      var str = '';
      str += 'const canvas = document.getElementById("canvas")\n';
      str += 'const ctx = canvas.getContext("2d");\n';
      return str + this.root.toCanvasDraw();
    }
  }]);

  return LQTree;
}();

/**
 * Determine whether a simple polygon is a convex polygon
 * @param points points buffer
 * @param base start index of the polygon on points
 * @param n end index of the polygon on points
 * @param tolerance tolerance
 */

function isConvex(points) {
  var base = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var n = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : points.length - base;
  var tolerance = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0.00001;
  if (n < 4) return true;
  var sign = undefined;
  if (points[base].x === points[n - 1].x && points[base].y === points[n - 1].y) // if its a closed polygon, ignore last vertex
    n--;

  for (var i = 0; i < n; i++) {
    var i1 = base + (i + 1) % n;
    var i2 = base + (i + 2) % n;
    var crossproduct = crossProduct3(points[i], points[i1], points[i2]);

    if (Math.abs(crossproduct) > tolerance) {
      if (sign === undefined) sign = crossproduct > 0;else if (sign != crossproduct > 0) {
        return false;
      }
    }
  }

  return true;
} // Returns a new array of points representing the convex hull of
// the given set of points. The convex hull excludes collinear points.
// This algorithm runs in O(n log n) time.

function makeHull(points) {
  var newPoints = points.slice();
  newPoints.sort(POINT_COMPARATOR);
  return makeHullPresorted(newPoints);
} // Returns the convex hull, assuming that each points[i] <= points[i + 1]. Runs in O(n) time.

function makeHullPresorted(points) {
  if (points.length <= 1) return points.slice(); // Andrew's monotone chain algorithm. Positive y coordinates correspond to "up"
  // as per the mathematical convention, instead of "down" as per the computer
  // graphics convention. This doesn't affect the correctness of the result.

  var upperHull = [];

  for (var i = 0; i < points.length; i++) {
    var p = points[i];

    while (upperHull.length >= 2) {
      var q = upperHull[upperHull.length - 1];
      var r = upperHull[upperHull.length - 2];
      if ((q.x - r.x) * (p.y - r.y) >= (q.y - r.y) * (p.x - r.x)) upperHull.pop();else break;
    }

    upperHull.push(p);
  }

  upperHull.pop();
  var lowerHull = [];

  for (var _i = points.length - 1; _i >= 0; _i--) {
    var _p = points[_i];

    while (lowerHull.length >= 2) {
      var _q = lowerHull[lowerHull.length - 1];
      var _r = lowerHull[lowerHull.length - 2];
      if ((_q.x - _r.x) * (_p.y - _r.y) >= (_q.y - _r.y) * (_p.x - _r.x)) lowerHull.pop();else break;
    }

    lowerHull.push(_p);
  }

  lowerHull.pop();
  if (upperHull.length == 1 && lowerHull.length == 1 && upperHull[0].x == lowerHull[0].x && upperHull[0].y == lowerHull[0].y) return upperHull;else return upperHull.concat(lowerHull);
}

function POINT_COMPARATOR(a, b) {
  if (a.x < b.x) return -1;else if (a.x > b.x) return +1;else if (a.y < b.y) return -1;else if (a.y > b.y) return +1;else return 0;
}

/**
 * Randomly generate convex polygon
 * https://cglab.ca/~sander/misc/ConvexGeneration/convex.html
 * @param  {Array} n the vertex num of polygon
 * @param  {Number} maxSize the maxSize of polygon
 * @return {Polygon} the random convex polygon
 */

function generateRandomConvexPolygon(n, maxSize) {
  if (maxSize === undefined) {
    maxSize = 1;
  }

  var xPool = [];
  var yPool = [];

  for (var i = 0; i < n; i++) {
    xPool.push(Math.random());
    yPool.push(Math.random());
  }

  xPool.sort();
  yPool.sort(); // Isolate the extreme points

  var minX = xPool[0];
  var maxX = xPool[n - 1];
  var minY = yPool[0];
  var maxY = yPool[n - 1]; // Divide the interior points into two chains & Extract the vector components

  var xVec = [];
  var yVec = [];
  var lastTop = minX,
      lastBot = minX;

  for (var _i = 1; _i < n - 1; _i++) {
    var _x = xPool[_i];

    if (Math.random() < 0.5) {
      xVec.push(_x - lastTop);
      lastTop = _x;
    } else {
      xVec.push(lastBot - _x);
      lastBot = _x;
    }
  }

  xVec.push(maxX - lastTop);
  xVec.push(lastBot - maxX);
  var lastLeft = minY,
      lastRight = minY;

  for (var _i2 = 1; _i2 < n - 1; _i2++) {
    var _y = yPool[_i2];

    if (Math.random() < 0.5) {
      yVec.push(_y - lastLeft);
      lastLeft = _y;
    } else {
      yVec.push(lastRight - _y);
      lastRight = _y;
    }
  }

  yVec.push(maxY - lastLeft);
  yVec.push(lastRight - maxY); // Randomly pair up the X- and Y-components

  shuffle(yVec); // Combine the paired up components into vectors

  var vec = [];

  for (var _i3 = 0; _i3 < n; _i3++) {
    vec.push(new Vector(xVec[_i3], yVec[_i3]));
  } // Sort the vectors by angle


  vec.sort(function (v1, v2) {
    return Math.atan2(v1.y, v1.x) - Math.atan2(v2.y, v2.x);
  }); // Lay them end-to-end

  var x = 0,
      y = 0;
  var minPolygonX = 0;
  var minPolygonY = 0;
  var points = [];

  for (var _i4 = 0; _i4 < n; _i4++) {
    points.push(new Vector(x, y));
    x += vec[_i4].x;
    y += vec[_i4].y;
    minPolygonX = Math.min(minPolygonX, x);
    minPolygonY = Math.min(minPolygonY, y);
  } // Move the polygon to the original min and max coordinates


  var xShift = minX - minPolygonX;
  var yShift = minY - minPolygonY;
  points.forEach(function (p) {
    p.x += xShift - 0.5;
    p.y += yShift - 0.5;
    p.x *= maxSize;
    p.y *= maxSize;
  });
  var polygon = new Polygon(new Vector(), points);
  var aabb = polygon.getAABB();
  polygon.translate(-aabb.centerX, -aabb.centerY);
  return polygon;
}

function _createForOfIteratorHelper$2(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$2(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray$2(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$2(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$2(o, minLen); }

function _arrayLikeToArray$2(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function applyImpulse(material, state, impulse, contactVector) {
  state.velocity.addMul(impulse, material.invMass);
  state.angularVelocity += material.invInertia * contactVector.cross(impulse);
} // https://gamedevelopment.tutsplus.com/tutorials/how-to-create-a-custom-2d-physics-engine-the-basics-and-impulse-resolution--gamedev-6331

function resolveContact(aMat, aState, bMat, bState, result) {
  var rv = new Vector();
  var impulse = new Vector();
  var e = Math.min(aMat.restitution, bMat.restitution); // Calculate static and dynamic friction

  var sf = Math.sqrt(aMat.staticFriction * bMat.staticFriction);
  var df = Math.sqrt(aMat.dynamicFriction * bMat.dynamicFriction);
  var aStateVelocity = aState.velocity.clone();
  var bStateVelocity = bState.velocity.clone();
  var aStateAngularVelocity = aState.angularVelocity;
  var bStateAngularVelocity = bState.angularVelocity;

  var _iterator = _createForOfIteratorHelper$2(result.contacts),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var contact = _step.value;
      // Calculate radii from COM to contact
      var ra = contact.clone().sub(aState.position);
      var rb = contact.clone().sub(bState.position); // Relative velocity

      rv.set(bStateVelocity).addMul(rb, bStateAngularVelocity).sub(aStateVelocity).subMul(ra, aStateAngularVelocity); // Relative velocity along the normal

      var contactVel = rv.dot(result.normal); // Do not resolve if velocities are separating

      if (contactVel > 0) continue;
      var raCrossN = ra.cross(result.normal);
      var rbCrossN = rb.cross(result.normal);
      var invMassSum = aMat.invMass + bMat.invMass + raCrossN * raCrossN * aMat.invInertia + rbCrossN * rbCrossN * bMat.invInertia; // Calculate impulse scalar

      var j = -(1.0 + e) * contactVel;
      j /= invMassSum;
      j /= result.contacts.length; // apply impulse

      impulse.set(result.normal).scl(j);
      applyImpulse(bMat, bState, impulse, rb);
      applyImpulse(aMat, aState, impulse.reverse(), ra); // Friction impulse

      rv.set(bStateVelocity).addMul(rb, bStateAngularVelocity).sub(aStateVelocity).subMul(ra, aStateAngularVelocity);
      var t = rv.clone().subMul(result.normal, rv.dot(result.normal));
      t.normalize(); // j tangent magnitude

      var jt = -rv.dot(t);
      jt /= invMassSum;
      jt /= result.contacts.length; // Don't apply tiny friction impulses

      if (Comparator.EQ(jt, 0.0)) continue; // Coulumb's law tangent impulse

      if (Math.abs(jt) < j * sf) impulse.set(t).scl(jt);else impulse.set(t).scl(-j * df); // aMatpply friction impulse

      applyImpulse(bMat, bState, impulse, rb);
      applyImpulse(aMat, aState, impulse.reverse(), ra);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
} // https://gamedevelopment.tutsplus.com/tutorials/how-to-create-a-custom-2d-physics-engine-the-basics-and-impulse-resolution--gamedev-6331

function positionalCorrection(aMat, bMat, result) {
  var percent = 0.2; // usually 20% to 80%

  var slop = 0.01; // usually 0.01 to 0.1

  var correction = result.normal.clone();
  correction.scl(Math.max(result.depth - slop, 0.0) / (aMat.invMass + bMat.invMass) * percent);
  aMat.position.subMul(correction, aMat.invMass);
  bMat.position.addMul(correction, bMat.invMass);
}

exports.AABB = AABB;
exports.Arc = Arc;
exports.Circle = Circle;
exports.CollisionResult = CollisionResult;
exports.Comparator = Comparator;
exports.ComposedShape = ComposedShape;
exports.Geom2Const = Geom2Const;
exports.LQTree = LQTree;
exports.Polygon = Polygon;
exports.Segment = Segment;
exports.Transform = Transform;
exports.Vector = Vector;
exports.angleDiff = angleDiff;
exports.angleDiffPI2 = angleDiffPI2;
exports.angleNormalize = angleNormalize;
exports.angleNormalizePI2 = angleNormalizePI2;
exports.applyImpulse = applyImpulse;
exports.clip = clip;
exports.crossProduct3 = crossProduct3;
exports.epa = epa;
exports.generateRandomConvexPolygon = generateRandomConvexPolygon;
exports.gjk = gjk;
exports.isConvex = isConvex;
exports.lineHasPoint = lineHasPoint;
exports.lineIntersection = lineIntersection;
exports.makeHull = makeHull;
exports.onSegment = onSegment;
exports.orientation = orientation;
exports.originDistance = originDistance;
exports.pMod = pMod;
exports.point2polygon = point2polygon;
exports.point2segment = point2segment;
exports.positionalCorrection = positionalCorrection;
exports.resolveContact = resolveContact;
exports.resolvePointsOfContact = resolvePointsOfContact;
exports.resolvePointsOfContact2 = resolvePointsOfContact2;
exports.sameSign = sameSign;
exports.shuffle = shuffle;
exports.support = support;
exports.testCircleCircle = testCircleCircle;
exports.testPolygonCircle = testPolygonCircle;
exports.testSegmentSegment = testSegmentSegment;
exports.tripleProduct = tripleProduct;
