import { Vector } from "./vector";
export declare class AABB {
    left: number;
    right: number;
    top: number;
    bottom: number;
    static fromVector(v: Vector): AABB;
    constructor(left: number, bottom: number, right?: number, top?: number);
    static fromCenter(center: Vector, width: number, height?: number): AABB;
    set(other: AABB): void;
    getCenter(): Vector;
    get centerX(): number;
    get centerY(): number;
    get width(): number;
    get height(): number;
    intersects(aabb: AABB): boolean;
    contains(aabb: AABB): boolean;
    merge(other: AABB): this;
    includes(v: Vector): this;
    isPointIn(vector: Vector): boolean;
    getAABB(): this;
    getArea(): number;
    getOrigin(): Vector;
    getCentroid(): Vector;
    toString(): string;
}
