import { Vector } from './vector';
import { ConvexShape } from './convex-shape';
import { AABB } from "./aabb";
import { CollisionResult } from "./collision/collision-result";
import { Segment } from "./segment";
import { Transform } from './transform';
export declare class Circle implements ConvexShape {
    transform: Transform;
    r: number;
    get center(): Vector;
    constructor(c: Vector, r: number);
    rotate(angle: number, center?: Vector): this;
    translate(x: number, y: number): this;
    intersectsSegment(ray: Segment, result?: CollisionResult): boolean;
    intersects(shape: ConvexShape, result?: CollisionResult): boolean;
    getAABB(): AABB;
    isPointIn(v: Vector): boolean;
    getArea(): number;
    getOrigin(): Vector;
    getCentroid(): Vector;
    getFarthestPointInDirection(d: Vector): Vector;
    getFarthestEdgeInDirection(d: Vector): Segment;
    toString(): string;
}
