/**
GJK stands for gilbert-johnson-keerthi

it can be used to find collision and compute minimum distance between shapes.

Reference: https://github.com/kroitor/gjk.c
           http://www.dyn4j.org/2010/04/gjk-gilbert-johnson-keerthi/
 **/
import { Vector } from "../vector";
import { ConvexShape } from "../convex-shape";
import { CollisionResult } from "./collision-result";
export declare function support(shape1: ConvexShape, shape2: ConvexShape, d: Vector): Vector;
export declare function gjk(A: ConvexShape, B: ConvexShape, simplex?: Vector[]): boolean;
export declare function tripleProduct(a: Vector, b: Vector, c: Vector, r: Vector): Vector;
export declare function originDistance(a: Vector, b: Vector): number;
export declare function epa(A: ConvexShape, B: ConvexShape, simplex: [Vector, Vector, Vector], result: CollisionResult): void;
