import { Vector } from "../vector";
import { CollisionResult } from "./collision-result";
import { Polygon } from "../polygon";
/**
 * Check whether two convex polygons are separated by the specified
 * axis (must be a unit vector).
 * @param aPos
 * @param bPos
 * @param aPoints The points in the first polygon.
 * @param bPoints The points in the second polygon.
 * @param axis The axis (unit sized) to test against.  The points of both polygons
 *   will be projected onto this axis.
 * @param testResult A Response object (optional) which will be populated
 *   if the axis is not a separating axis.
 * @return true if it is a separating axis, false otherwise.  If false,
 *   and a response is passed in, information about how much overlap and
 *   the direction of the overlap will be populated.
 */
export declare function isSeparatingAxis(aPos: Vector, bPos: Vector, aPoints: Array<Vector>, bPoints: Array<Vector>, axis: Vector, testResult: CollisionResult): boolean;
export declare function testPolygonPolygon(a: Polygon, b: Polygon, testResult: CollisionResult): boolean;
