import { Shape } from "./shape";
import { Vector } from "./vector";
import { AABB } from "./aabb";
import { Polygon } from "./polygon";
import { Circle } from "./circle";
import { Transform } from "./transform";
export declare class ComposedShape implements Shape {
    shapes: Array<Polygon | Circle>;
    transform: Transform;
    private localTransforms;
    constructor(shapes: Array<Polygon | Circle>, transform?: Transform);
    recalc(): void;
    rotate(angle: number, center?: Vector): this;
    translate(x: number, y: number): this;
    rotateLocal(angle: number): this;
    translateLocal(x: number, y: number): this;
    isPointIn(vector: Vector): boolean;
    getArea(): number;
    getCentroid(): Vector;
    getOrigin(): Vector;
    getAABB(): AABB;
}
