'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

var classCallCheck = _classCallCheck;

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var createClass = _createClass;

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var defineProperty = _defineProperty;

var TL = 0.00001;

function EQ_0(num) {
  return num < TL && num > -TL;
}

function EQ(a, b) {
  return a - b < TL && a - b > -TL;
}

function LE(a, b) {
  return a - b <= TL;
}

function GE(a, b) {
  return a - b >= TL;
}

var Comparator = {
  EQ_0: EQ_0,
  EQ: EQ,
  LE: LE,
  GE: GE
};

var Vector = /*#__PURE__*/function () {
  function Vector() {
    var x = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

    classCallCheck(this, Vector);

    defineProperty(this, "x", void 0);

    defineProperty(this, "y", void 0);

    this.x = x;
    this.y = y;
  } // set this value of this one to another vector.


  createClass(Vector, [{
    key: "set",
    value: function set(x) {
      var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      if (x instanceof Vector) {
        this.x = x.x;
        this.y = x.y;
      } else {
        this.x = x;
        this.y = y;
      }

      return this;
    } // scale another vector first then add to this vector

  }, {
    key: "addMul",
    value: function addMul(v, scl) {
      this.x += v.x * scl;
      this.y += v.y * scl;
      return this;
    } // scale a vector first then subtract the vector

  }, {
    key: "subMul",
    value: function subMul(v, scl) {
      this.x -= v.x * scl;
      this.y -= v.y * scl;
      return this;
    } // Scale this vector. An independent scaling factor can be provided
    // for each axis, or a single scaling factor that will scale both `x` and `y`.

  }, {
    key: "scl",
    value: function scl(x) {
      var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : x;
      this.x *= x;
      this.y *= y;
      return this;
    } // Add another vector to this one.

  }, {
    key: "add",
    value: function add(v) {
      this.x += v.x;
      this.y += v.y;
      return this;
    } // Add (x,y) to this one.

  }, {
    key: "translate",
    value: function translate(x, y) {
      this.x += x;
      this.y += y;
      return this;
    } // Subtract another vector from this one.

  }, {
    key: "sub",
    value: function sub(v) {
      this.x -= v.x;
      this.y -= v.y;
      return this;
    } // Change this vector to be perpendicular to what it was before. (Effectively
    // rotates it 90 degrees in a clockwise direction)

  }, {
    key: "perp",
    value: function perp() {
      var x = this.x;
      this.x = this.y;
      this.y = -x;
      return this;
    } // Rotate this vector (counter-clockwise) by the specified angle (in radians).

  }, {
    key: "rotate",
    value: function rotate(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Vector.ZERO;
      var x = this.x;
      var y = this.y;
      this.x = center.x + (x - center.x) * Math.cos(angle) - (y - center.y) * Math.sin(angle);
      this.y = center.y + (x - center.x) * Math.sin(angle) + (y - center.y) * Math.cos(angle);
      return this;
    } //  the angle v looks at this

  }, {
    key: "angle",
    value: function angle(v) {
      return Math.atan2(this.y - v.y, this.x - v.x);
    }
  }, {
    key: "reverse",
    value: function reverse() {
      this.x = -this.x;
      this.y = -this.y;
      return this;
    } // Get the dot product of this vector and another.

  }, {
    key: "dot",
    value: function dot(v) {
      return this.x * v.x + this.y * v.y;
    }
    /**
     * @param v the other vector
     * @param ref reference vector
     * @return dot product of (this - ref), (v - ref)
     * result > 0 the angle between (this - ref), (v - ref) < 90
     * result < 0 the angle between (this - ref), (v - ref) > 90
     */

  }, {
    key: "dotRef",
    value: function dotRef(v, ref) {
      return (this.x - ref.x) * (v.x - ref.x) + (this.y - ref.y) * (v.y - ref.y);
    }
    /**
     * @param v
     * @return cross product
     */

  }, {
    key: "cross",
    value: function cross(v) {
      return this.x * v.y - this.y * v.x;
    }
    /**
     * @param v the other vector
     * @param ref reference vector
     * @return cross product of (this - ref), (v - ref)
     * result < 0 if (v - ref) is on the right side of (this - ref)
     * result > 0 if (v - ref) is on the left side of (this - ref)
     */

  }, {
    key: "crossRef",
    value: function crossRef(v, ref) {
      return (this.x - ref.x) * (v.y - ref.y) - (this.y - ref.y) * (v.x - ref.x);
    } // Project this vector on to another vector.

  }, {
    key: "project",
    value: function project(v) {
      var amt = this.dot(v) / v.len2();
      this.x = amt * v.x;
      this.y = amt * v.y;
      return this;
    } // Project this vector onto a vector of unit length. This is slightly more efficient
    // than `project` when dealing with unit vectors.

  }, {
    key: "projectN",
    value: function projectN(v) {
      var amt = this.dot(v);
      this.x = amt * v.x;
      this.y = amt * v.y;
      return this;
    }
  }, {
    key: "reflect",
    // Reflect this vector on an arbitrary axis.
    value: function reflect(axis) {
      var x = this.x;
      var y = this.y;
      this.project(axis).scl(2);
      this.x -= x;
      this.y -= y;
      return this;
    }
  }, {
    key: "reflectN",
    // Reflect this vector on an arbitrary axis (represented by a unit vector). This is
    // slightly more efficient than `reflect` when dealing with an axis that is a unit vector.
    value: function reflectN(axis) {
      var x = this.x;
      var y = this.y;
      this.projectN(axis).scl(2);
      this.x -= x;
      this.y -= y;
      return this;
    }
  }, {
    key: "normalize",
    // Normalize this vector.  (make it have length of `1`)
    value: function normalize() {
      var d = this.len();

      if (d > 0) {
        this.x = this.x / d;
        this.y = this.y / d;
      }

      return this;
    } // Get the squared length of this vector.

  }, {
    key: "len2",
    value: function len2() {
      return this.x * this.x + this.y * this.y;
    } // Get the length of this vector.

  }, {
    key: "len",
    value: function len() {
      return Math.sqrt(this.len2());
    }
  }, {
    key: "setLen",
    value: function setLen(len) {
      return this.normalize().scl(len);
    } // Create a new vector with the same coordinates as this on.

  }, {
    key: "clone",
    value: function clone() {
      return new Vector(this.x, this.y);
    }
  }, {
    key: "dist2",
    value: function dist2(v) {
      return (v.x - this.x) * (v.x - this.x) + (v.y - this.y) * (v.y - this.y);
    }
  }, {
    key: "dist",
    value: function dist(v) {
      return Math.sqrt(this.dist2(v));
    }
  }, {
    key: "equalsTo",
    value: function equalsTo(v) {
      return Comparator.EQ(this.x, v.x) && Comparator.EQ(this.y, v.y);
    }
  }, {
    key: "toString",
    value: function toString() {
      return "[".concat(this.x, ", ").concat(this.y, "]");
    }
  }, {
    key: "angleTo",
    value: function angleTo(v) {
      var res = Math.acos(this.dot(v) / v.len() / this.len());
      return (this.cross(v) < 0 ? -1 : 1) * res;
    }
  }], [{
    key: "lerp",
    value: function lerp(start, end, t) {
      return new Vector(t * (end.x - start.x) + start.x, t * (end.y - start.y) + start.y);
    }
  }]);

  return Vector;
}();

defineProperty(Vector, "ZERO", new Vector());

var AABB = /*#__PURE__*/function () {
  createClass(AABB, null, [{
    key: "fromVector",
    value: function fromVector(v) {
      return new AABB(v.x, v.y);
    }
  }]);

  function AABB(left, bottom) {
    var right = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : left;
    var top = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : bottom;

    classCallCheck(this, AABB);

    defineProperty(this, "left", void 0);

    defineProperty(this, "right", void 0);

    defineProperty(this, "top", void 0);

    defineProperty(this, "bottom", void 0);

    this.left = left;
    this.bottom = bottom;
    this.right = right;
    this.top = top;
  }

  createClass(AABB, [{
    key: "set",
    value: function set(other) {
      this.left = other.left;
      this.bottom = other.bottom;
      this.right = other.right;
      this.top = other.top;
    }
  }, {
    key: "getCenter",
    value: function getCenter() {
      return new Vector((this.left + this.right) / 2, (this.top + this.bottom) / 2);
    }
  }, {
    key: "intersects",
    value: function intersects(aabb) {
      return this.left <= aabb.right && this.right >= aabb.left && this.bottom <= aabb.top && this.top >= aabb.bottom;
    }
  }, {
    key: "contains",
    value: function contains(aabb) {
      return this.left <= aabb.left && this.right >= aabb.right && this.bottom <= aabb.bottom && this.top >= aabb.top;
    }
  }, {
    key: "merge",
    value: function merge(other) {
      this.left = Math.min(this.left, other.left);
      this.bottom = Math.min(this.bottom, other.bottom);
      this.right = Math.max(this.right, other.right);
      this.top = Math.max(this.top, other.top);
      return this;
    }
  }, {
    key: "includes",
    value: function includes(v) {
      this.left = Math.min(this.left, v.x);
      this.bottom = Math.min(this.bottom, v.y);
      this.right = Math.max(this.right, v.x);
      this.top = Math.max(this.top, v.y);
      return this;
    }
  }, {
    key: "isPointIn",
    value: function isPointIn(vector) {
      return false;
    }
  }, {
    key: "getAABB",
    value: function getAABB() {
      return this;
    }
  }, {
    key: "getArea",
    value: function getArea() {
      return (this.top - this.bottom) * (this.right - this.left);
    }
  }, {
    key: "getOrigin",
    value: function getOrigin() {
      return this.getCenter();
    }
  }, {
    key: "getCentroid",
    value: function getCentroid() {
      return this.getCenter();
    }
  }, {
    key: "toString",
    value: function toString() {
      return "[l:".concat(this.left, ", b:").concat(this.bottom, ", r:").concat(this.right, ", t:").concat(this.top, "]");
    }
  }, {
    key: "centerX",
    get: function get() {
      return (this.left + this.right) / 2;
    }
  }, {
    key: "centerY",
    get: function get() {
      return (this.bottom + this.top) / 2;
    }
  }, {
    key: "width",
    get: function get() {
      return this.right - this.left;
    }
  }, {
    key: "height",
    get: function get() {
      return this.top - this.bottom;
    }
  }], [{
    key: "fromCenter",
    value: function fromCenter(center, width) {
      var height = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : width;
      return new AABB(center.x - width / 2, center.y - height / 2, center.x + width / 2, center.y + height / 2);
    }
  }]);

  return AABB;
}();

var CollisionResult = function CollisionResult() {
  var normal = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Vector();
  var depth = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var contacts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Array();

  classCallCheck(this, CollisionResult);

  defineProperty(this, "normal", void 0);

  defineProperty(this, "depth", void 0);

  defineProperty(this, "contacts", void 0);

  this.normal = normal;
  this.depth = depth;
  this.contacts = contacts;
};

var PI = Math.PI;
var PI2 = Math.PI * 2;
var Geom2Const = {
  PI: PI,
  PI2: PI2
}; // ## Object Pools
// A pool of `Vector` objects that are used in calculations to avoid
// allocating memory.

var T_VECTORS = [];

for (var i = 0; i < 10; i++) {
  T_VECTORS.push(new Vector());
} // A pool of arrays of numbers used in calculations to avoid allocating


var T_TESTRESULT = new CollisionResult();
/*****               Array                        *******/

/**
 * Randomly shuffle an array
 * https://stackoverflow.com/a/2450976/1293256
 * @param  {Array} array The array to shuffle
 * @return {String}      The first item in the shuffled array
 */

function shuffle(array) {
  var currentIndex = array.length;
  var temporaryValue, randomIndex; // While there remain elements to shuffle...

  while (0 !== currentIndex) {
    // Pick a remaining element...
    randomIndex = Math.floor(Math.random() * currentIndex);
    currentIndex -= 1; // And swap it with the current element.

    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }

  return array;
}
/******              number                            *****/
// value

function sameSign(num1, num2) {
  return num1 >= 0 && num2 >= 0 || num1 < 0 && num2 < 0;
}
function pMod(a, n) {
  return (a % n + n) % n;
}
function angleNormalize(a) {
  return pMod(a + PI, PI2) - PI;
}
function angleNormalizePI2(a) {
  return pMod(a, PI2);
}
function angleDiff(angle1, angle2) {
  var a = angle1 - angle2;
  return angleNormalize(a);
}
function angleDiffPI2(angle1, angle2) {
  var a = angle1 - angle2;
  return angleNormalizePI2(a);
}
/******              Vector                            *****/
// Given three colinear points p, q, r, the function checks if
// point q lies on line segment 'pr'

function onSegment(s1, s2, v) {
  return v.x <= Math.max(s1.x, s2.x) && v.x >= Math.min(s1.x, s2.x) && v.y <= Math.max(s1.y, s2.y) && v.y >= Math.min(s1.y, s2.y);
} // To find orientation of ordered triplet (v1, ref, v2).

function crossProduct3(v1, v2, v3) {
  return (v2.x - v1.x) * (v3.y - v2.y) - (v2.y - v1.y) * (v3.x - v2.x);
}
function triarea2(a, b, c) {
  var ax = b.x - a.x;
  var ay = b.y - a.y;
  var bx = c.x - a.x;
  var by = c.y - a.y;
  return bx * ay - ax * by;
}
function sgn(x) {
  return x < -0.0001 ? -1 : x > 0.0001 ? 1 : 0;
} // To find orientation of ordered triplet (v1, ref, v2).

function orientation(s, v) {
  return sgn(crossProduct3(s.v1, s.v2, v));
}
function intersectingVertex(v1, v2, v3, v4) {
  var s213 = triarea2(v2, v1, v3);
  var s214 = triarea2(v2, v1, v4);
  var s431 = triarea2(v4, v3, v1);
  var s432 = triarea2(v4, v3, v2); // two segments have no intersecting vertex.

  if (sgn(s213) === sgn(s214) && sgn(s213) !== 0 || sgn(s431) === sgn(s432) && sgn(s431) !== 0) return null; // colinear

  if (sgn(s213) === sgn(s214) && sgn(s213) === 0) {
    if (!segmentHasPoint(v1, v2, v3) && !segmentHasPoint(v1, v2, v4)) return null; // for coincident case, use starting vertex.

    return v3.clone();
  }

  s213 = Math.abs(s213);
  s214 = Math.abs(s214);
  var s = s213 + s214;
  return new Vector((v3.x * s214 + v4.x * s213) / s, (v3.y * s214 + v4.y * s213) / s);
}
function testSegmentSegment(s1p1, s1p2, s2p1, s2p2) {
  // Find the four orientations needed for general and
  // special cases
  var o1 = crossProduct3(s1p1, s1p2, s2p1);
  var o2 = crossProduct3(s1p1, s1p2, s2p2);
  var o3 = crossProduct3(s2p1, s2p2, s1p1);
  var o4 = crossProduct3(s2p1, s2p2, s1p2); // General case

  if (!sameSign(o1, o2) && !sameSign(o3, o4)) return true; // Special Cases
  // s1p1, s1p2 and s2p1 are colinear and s2p1 lies on segment p1q1

  if (o1 == 0 && onSegment(s1p1, s2p1, s1p2)) return true; // s1p1, s1p2 and s2p2 are colinear and s2p2 lies on segment p1q1

  if (o2 == 0 && onSegment(s1p1, s2p2, s1p2)) return true; // s2p1, s2p2 and s1p1 are colinear and s1p1 lies on segment p2q2

  if (o3 == 0 && onSegment(s2p1, s1p1, s2p2)) return true; // s2p1, s2p2 and s1p2 are colinear and s1p2 lies on segment p2q2

  if (o4 == 0 && onSegment(s2p1, s1p2, s2p2)) return true;
  return false; // Doesn't fall in any of the above cases
}
/*
export function lineIntersection(p1:Vector, p2:Vector, p3:Vector, p4:Vector):Vector {
    // From http://paulbourke.net/geometry/lineline2d/
    var s = ((p4.x - p3.x) * (p1.y - p3.y) - (p4.y - p3.y) * (p1.x - p3.x))
        / ((p4.y - p3.y) * (p2.x - p1.x) - (p4.x - p3.x) * (p2.y - p1.y));
    return new Vector(p1.x + s * (p2.x - p1.x), p1.y + s * (p2.y - p1.y));
}*/

/******              Polygon                            *****/
// Check if two circles collide.

/**
 * @param {Circle} a The first circle.
 * @param {Circle} b The second circle.
 * @param {TestResult} testResult Response object (optional) that will be populated if
 *   the circles intersects.
 * @return {boolean} true if the circles intersects, false if they don't.
 */

function testCircleCircle(a, b, testResult) {
  // Check if the distance between the centers of the two
  // circles is greater than their combined radius.
  var differenceV = T_VECTORS.pop();
  if (differenceV === undefined) throw new Error('memory allocation error');
  differenceV.set(b.transform.position).sub(a.transform.position);
  var totalRadius = a.r + b.r;
  var totalRadiusSq = totalRadius * totalRadius;
  var distanceSq = differenceV.len2(); // If the distance is bigger than the combined radius, they don't intersects.

  if (distanceSq > totalRadiusSq) {
    T_VECTORS.push(differenceV);
    return false;
  } // They intersects.  If we're calculating a testResult, calculate the overlap.


  if (testResult) {
    var dist = Math.sqrt(distanceSq);
    testResult.depth = totalRadius - dist;
    testResult.normal.set(differenceV.normalize());

    if (a.r <= b.r) {
      testResult.contacts.push(testResult.normal.clone().scl(a.r).add(a.transform.position));
    } else {
      testResult.contacts.push(testResult.normal.clone().scl(-b.r).add(b.transform.position));
    }
  }

  T_VECTORS.push(differenceV);
  return true;
}
var VORONOI_REGION; // Calculates which Voronoi region a point is on a line segment.
// It is assumed that both the line and the point are relative to `(0,0)`
//
//            |       (0)      |
//     (-1)  [S]--------------[E]  (1)
//            |       (0)      |

/**
 * @param {Vector} line The line segment.
 * @param {Vector} point The point.
 * @return  {number} LEFT_VORONOI_REGION (-1) if it is the left region,
 *          MIDDLE_VORONOI_REGION (0) if it is the middle region,
 *          RIGHT_VORONOI_REGION (1) if it is the right region.
 */

(function (VORONOI_REGION) {
  VORONOI_REGION[VORONOI_REGION["LEFT"] = -1] = "LEFT";
  VORONOI_REGION[VORONOI_REGION["MIDDLE"] = 0] = "MIDDLE";
  VORONOI_REGION[VORONOI_REGION["RIGHT"] = 1] = "RIGHT";
})(VORONOI_REGION || (VORONOI_REGION = {}));

function voronoiRegion(line, point) {
  var len2 = line.len2();
  var dp = point.dot(line); // If the point is beyond the start of the line, it is in the
  // left voronoi region.

  if (dp < 0) {
    return VORONOI_REGION.LEFT;
  } // If the point is beyond the end of the line, it is in the
  // right voronoi region.
  else if (dp > len2) {
      return VORONOI_REGION.RIGHT;
    } // Otherwise, it's in the middle one.
    else {
        return VORONOI_REGION.MIDDLE;
      }
}
/**
 * Check if a polygon and a circle collide.
 * @param {Polygon} polygon The polygon.
 * @param {Circle} circle The circle.
 * @param {TestResult} response Response object (optional) that will be populated if
 *   they interset.
 * @return {boolean} true if they intersects, false if they don't.
 */


function testPolygonCircle(polygon, circle, response) {
  var circlePos = T_VECTORS.pop();
  if (circlePos === undefined) throw new Error('memory allocation error'); // Get the position of the circle relative to the polygon.

  circlePos.set(circle.transform.position);
  var radius = circle.r;
  var radius2 = radius * radius;
  var points = polygon.calcPoints;
  var len = points.length;
  var edge = T_VECTORS.pop();
  var point = T_VECTORS.pop();
  if (point === undefined || edge === undefined) throw new Error('memory allocation error'); // For each edge in the polygon:

  for (var _i2 = 0; _i2 < len; _i2++) {
    var next = (_i2 + 1) % len;
    var prev = (_i2 - 1 + len) % len;
    var overlap = 0;
    var overlapN = null; // Get the edge.

    edge.set(polygon.calcPoints[next]).sub(polygon.calcPoints[_i2]); // Calculate the center of the circle relative to the starting point of the edge.

    point.set(circlePos).sub(points[_i2]); // If the distance between the center of the circle and the point
    // is bigger than the radius, the polygon is definitely not fully in
    // the circle.

    if (response && point.len2() > radius2) ; // Calculate which Voronoi region the center of the circle is in.


    var region = voronoiRegion(edge, point); // If it's the left region:

    if (region === VORONOI_REGION.LEFT) {
      // We need to make sure we're in the RIGHT_VORONOI_REGION of the previous edge.
      edge.set(polygon.calcPoints[_i2]).sub(polygon.calcPoints[prev]); // Calculate the center of the circle relative the starting point of the previous edge

      var point2 = T_VECTORS.pop();
      if (point2 === undefined) throw new Error('memory allocation error');
      point2.set(circlePos).sub(points[prev]);
      region = voronoiRegion(edge, point2);

      if (region === VORONOI_REGION.RIGHT) {
        // It's in the region we want.  Check if the circle intersects the point.
        var dist = point.len();

        if (dist > radius) {
          // No intersection
          T_VECTORS.push(circlePos);
          T_VECTORS.push(edge);
          T_VECTORS.push(point);
          T_VECTORS.push(point2);
          return false;
        } else if (response) {
          // It intersects, calculate the overlap.
          //response.bInA = false;
          overlapN = point.normalize();
          overlap = radius - dist;
        }
      }

      T_VECTORS.push(point2); // If it's the right region:
    } else if (region === VORONOI_REGION.RIGHT) {
      // We need to make sure we're in the left region on the next edge
      edge.set(polygon.calcPoints[(next + 1) % len]).sub(polygon.calcPoints[next]); // Calculate the center of the circle relative to the starting point of the next edge.

      point.set(circlePos).sub(points[next]);
      region = voronoiRegion(edge, point);

      if (region === VORONOI_REGION.LEFT) {
        // It's in the region we want.  Check if the circle intersects the point.
        var _dist = point.len();

        if (_dist > radius) {
          // No intersection
          T_VECTORS.push(circlePos);
          T_VECTORS.push(edge);
          T_VECTORS.push(point);
          return false;
        } else if (response) {
          // It intersects, calculate the overlap.
          //response.bInA = false;
          overlapN = point.normalize();
          overlap = radius - _dist;
        }
      } // Otherwise, it's the middle region:

    } else {
      // Need to check if the circle is intersecting the edge,
      // Change the edge into its "edge normal".
      var normal = edge.perp().normalize(); // Find the perpendicular distance between the center of the
      // circle and the edge.

      var _dist2 = point.dot(normal);

      var distAbs = Math.abs(_dist2); // If the circle is on the outside of the edge, there is no intersection.

      if (_dist2 > 0 && distAbs > radius) {
        // No intersection
        T_VECTORS.push(circlePos);
        T_VECTORS.push(normal);
        T_VECTORS.push(point);
        return false;
      } else if (response) {
        // It intersects, calculate the overlap.
        overlapN = normal;
        overlap = radius - _dist2; // If the center of the circle is on the outside of the edge, or part of the
      }
    } // If this is the smallest overlap we've seen, keep it.
    // (overlapN may be null if the circle was in the wrong Voronoi region).


    if (overlapN && response && Math.abs(overlap) < Math.abs(response.depth)) {
      response.depth = overlap;
      response.normal.set(overlapN);
    }
  } // Calculate the final overlap vector - based on the smallest overlap.

  T_VECTORS.push(circlePos);
  T_VECTORS.push(edge);
  T_VECTORS.push(point);
  return true;
}
function segmentHasPoint(v1, v2, p) {
  var tolerance = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0.01;
  return Math.abs(v1.dist(v2) - (v1.dist(p) + v2.dist(p))) <= tolerance;
}
/**
 * Calculate distance and closest point between point and segment
 * @param pt the point
 * @param seg1 the start of segment
 * @param seg2 the end of segment
 * @param cp the closest point
 * @returns distance
 */

function point2segment(pt, seg1, seg2, cp) {
  /* Degenerated case of zero-length segment */
  if (seg1.equalsTo(seg2)) {
    if (cp !== undefined) cp.set(seg1);
    return pt.dist(seg1);
  }

  var vSeg = T_VECTORS.pop();
  var vSeg1 = T_VECTORS.pop();
  var vSeg2 = T_VECTORS.pop();

  if (vSeg === undefined || vSeg1 === undefined || vSeg2 === undefined) {
    throw new Error('temp variable memory allocation error');
  }

  vSeg.set(seg1).sub(seg2);
  vSeg1.set(seg1).sub(pt);
  vSeg2.set(seg2).sub(pt);
  var start_sp = vSeg.dot(vSeg1);
  var end_sp = -vSeg.dot(vSeg2);
  var dist;

  if (start_sp >= 0 && end_sp >= 0) {
    /* point inside segment scope */
    // get unit vector
    vSeg.normalize();

    if (cp !== undefined) {
      /*console.log(seg1);
      console.log(vSeg);
      console.log(vSeg2);
      vSeg2.projectN()*/
      cp.set(seg2).addMul(vSeg, vSeg.dot(vSeg2.reverse()));
    }

    dist = Math.abs(vSeg.cross(vSeg2));
  } else if (start_sp < 0) {
    /* point is out of scope closer to ps */
    if (cp !== undefined) cp.set(seg1);
    dist = pt.dist(seg1);
  } else {
    /* point is out of scope closer to pe */
    if (cp !== undefined) cp.set(seg2);
    dist = pt.dist(seg2);
  }

  T_VECTORS.push(vSeg);
  T_VECTORS.push(vSeg1);
  T_VECTORS.push(vSeg2);
  return dist;
}
function point2polygon(pt, points, cp) {
  var n = points.length;
  var local_cp = T_VECTORS.pop();
  var min_dist = Number.POSITIVE_INFINITY;

  if (local_cp === undefined) {
    throw new Error('temp variable memory allocation error');
  }

  for (var _i3 = 0; _i3 < n; _i3++) {
    var next = (_i3 + 1) % n;
    var dist = point2segment(pt, points[_i3], points[next], local_cp);

    if (min_dist > dist) {
      min_dist = dist;

      if (cp !== undefined) {
        cp.set(local_cp);
      }
    }
  }

  T_VECTORS.push(local_cp);
  return min_dist;
}
function lineLineIntersection(A, B, C, D) {
  // Line AB represented as a1x + b1y = c1
  var a1 = B.y - A.y;
  var b1 = A.x - B.x;
  var c1 = a1 * A.x + b1 * A.y; // Line CD represented as a2x + b2y = c2

  var a2 = D.y - C.y;
  var b2 = C.x - D.x;
  var c2 = a2 * C.x + b2 * C.y;
  var determinant = a1 * b2 - a2 * b1;

  if (determinant == 0) {
    // The lines are parallel. This is simplified
    // by returning a pair of FLT_MAX
    return new Vector(Number.MAX_VALUE, Number.MAX_VALUE);
  } else {
    var x = (b2 * c1 - b1 * c2) / determinant;
    var y = (a1 * c2 - a2 * c1) / determinant;
    return new Vector(x, y);
  }
}
function clamp(value, min, max) {
  if (value < min) value = min;
  if (value > max) value = max;
  return value;
}

var Arc = /*#__PURE__*/function () {
  function Arc(center, r) {
    var startAngle = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    var endAngle = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : Geom2Const.PI2;

    classCallCheck(this, Arc);

    defineProperty(this, "c", void 0);

    defineProperty(this, "r", void 0);

    defineProperty(this, "startAngle", void 0);

    defineProperty(this, "endAngle", void 0);

    this.c = center.clone();
    this.r = r;
    this.startAngle = angleNormalizePI2(startAngle);
    this.endAngle = angleNormalizePI2(endAngle);
  }

  createClass(Arc, [{
    key: "clone",
    value: function clone() {
      return new Arc(this.c.clone(), this.r, this.startAngle, this.endAngle);
    }
    /**
     * Returns true if arc contains point, false otherwise
     * @param {Point} pt - point to test
     * @returns {boolean}
     */

  }, {
    key: "contains",
    value: function contains(pt) {
      // first check if  point on circle (pc,r)
      if (!Comparator.EQ(this.c.dist(pt), this.r)) return false;
      var angle = pt.angle(this.c);
      return Comparator.LE(this.startAngle, angle) && Comparator.LE(angle, this.endAngle);
    }
    /**
     * Get bounding box of the arc
     * @returns {AABB}
     */

  }, {
    key: "getAABB",
    value: function getAABB() {
      var func_arcs = this.breakToFunctional();
      var box = func_arcs.reduce(function (acc, arc) {
        return acc.includes(arc.start);
      }, new AABB(this.start.x, this.start.y));
      box = box.includes(this.end);
      return box;
    }
    /**
     * Breaks arc in extreme point 0, pi/2, pi, 3*pi/2 and returns array of sub-arcs
     * @returns {Arcs[]}
     */

  }, {
    key: "breakToFunctional",
    value: function breakToFunctional() {
      var func_arcs_array = [];
      var angles = [0, Math.PI / 2, 2 * Math.PI / 2, 3 * Math.PI / 2];
      var pts = [this.c.clone().translate(this.r, 0), this.c.clone().translate(0, this.r), this.c.clone().translate(-this.r, 0), this.c.clone().translate(0, -this.r)]; // If arc contains extreme point,
      // create test arc started at start point and ended at this extreme point

      var test_arcs = [];

      for (var i = 0; i < 4; i++) {
        if (this.contains(pts[i])) {
          test_arcs.push(new Arc(this.c, this.r, this.startAngle, angles[i]));
        }
      }

      if (test_arcs.length == 0) {
        // arc does contain any extreme point
        func_arcs_array.push(this.clone());
      } else {
        // arc passes extreme point
        // sort these arcs by length
        test_arcs.sort(function (arc1, arc2) {
          return arc1.length - arc2.length;
        });

        for (var _i = 0; _i < test_arcs.length; _i++) {
          var _prev_arc = func_arcs_array.length > 0 ? func_arcs_array[func_arcs_array.length - 1] : undefined;

          var _new_arc = void 0;

          if (_prev_arc) {
            _new_arc = new Arc(this.c, this.r, _prev_arc.endAngle, test_arcs[_i].endAngle);
          } else {
            _new_arc = new Arc(this.c, this.r, this.startAngle, test_arcs[_i].endAngle);
          }

          if (!Comparator.EQ_0(_new_arc.length)) {
            func_arcs_array.push(_new_arc.clone());
          }
        } // add last sub arc


        var prev_arc = func_arcs_array.length > 0 ? func_arcs_array[func_arcs_array.length - 1] : undefined;
        var new_arc;

        if (prev_arc) {
          new_arc = new Arc(this.c, this.r, prev_arc.endAngle, this.endAngle);
        } else {
          new_arc = new Arc(this.c, this.r, this.startAngle, this.endAngle);
        } // It could be 2*PI when occasionally start = 0 and end = 2*PI but this is not valid for breakToFunctional


        if (!Comparator.EQ_0(new_arc.length) && !Comparator.EQ(new_arc.sweep, 2 * Math.PI)) {
          func_arcs_array.push(new_arc.clone());
        }
      }

      return func_arcs_array;
    }
  }, {
    key: "sweep",
    get: function get() {
      return angleDiffPI2(this.endAngle, this.startAngle);
    }
    /**
     * Get start point of arc
     * @returns {Point}
     */

  }, {
    key: "start",
    get: function get() {
      var p0 = new Vector(this.c.x + this.r, this.c.y);
      return p0.rotate(this.startAngle, this.c);
    }
    /**
     * Get end point of arc
     * @returns {Point}
     */

  }, {
    key: "end",
    get: function get() {
      var p0 = new Vector(this.c.x + this.r, this.c.y);
      return p0.rotate(this.endAngle, this.c);
    }
  }, {
    key: "vertices",
    get: function get() {
      return [this.start, this.end];
    }
    /**
     * Get arc length
     * @returns {number}
     */

  }, {
    key: "length",
    get: function get() {
      return Math.abs(this.sweep * this.r);
    }
  }]);

  return Arc;
}();

// implement using
var PriorityQueue = /*#__PURE__*/function () {
  function PriorityQueue() {
    classCallCheck(this, PriorityQueue);

    defineProperty(this, "items", void 0);

    defineProperty(this, "size", void 0);

    this.items = [];
    this.size = 0;
  }

  createClass(PriorityQueue, [{
    key: "enqueue",
    value: function enqueue(item) {
      this.items.push(item);
      this.sink(this.items.length - 1);
    }
  }, {
    key: "sink",
    value: function sink(index) {
      var item = this.items[index]; // sink the current node to base

      while (index > 0 && item.compare(this.items[Math.floor((index - 1) / 2)])) {
        this.items[index] = this.items[Math.floor((index - 1) / 2)];
        index = Math.floor((index - 1) / 2);
      }

      this.items[index] = item;
    }
  }, {
    key: "dequeue",
    value: function dequeue() {
      var result = this.items[0];
      var cur = 0; // fill the bottom
      // does the current node has child

      while (cur * 2 + 1 < this.items.length) {
        if (cur * 2 + 2 >= this.items.length || this.items[cur * 2 + 1].compare(this.items[cur * 2 + 2])) {
          this.items[cur] = this.items[cur * 2 + 1];
          cur = cur * 2 + 1;
        } else {
          this.items[cur] = this.items[cur * 2 + 2];
          cur = cur * 2 + 2;
        }
      }

      if (cur < this.items.length - 1) {
        this.items[cur] = this.items[this.items.length - 1];
        this.sink(cur);
      }

      this.items.pop();
      return result;
    }
  }]);

  return PriorityQueue;
}();

function createCommonjsModule(fn, basedir, module) {
	return module = {
	  path: basedir,
	  exports: {},
	  require: function (path, base) {
      return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
    }
	}, fn(module, module.exports), module.exports;
}

function commonjsRequire () {
	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}
});

var regenerator = runtime_1;

var LinkedListNode = /*#__PURE__*/function () {
  function LinkedListNode(data) {
    classCallCheck(this, LinkedListNode);

    defineProperty(this, "data", void 0);

    defineProperty(this, "next", void 0);

    defineProperty(this, "prev", void 0);

    this.data = data;
    this.next = null;
    this.prev = null;
  }

  createClass(LinkedListNode, [{
    key: "hasPrev",
    value: function hasPrev() {
      return this.prev !== null;
    }
  }, {
    key: "hasNext",
    value: function hasNext() {
      return this.next !== null;
    }
  }]);

  return LinkedListNode;
}();
var CircularLinkedList = /*#__PURE__*/function () {
  function CircularLinkedList() {
    classCallCheck(this, CircularLinkedList);

    defineProperty(this, "length", void 0);

    defineProperty(this, "head", void 0);

    this.length = 0;
    this.head = null;
  }

  createClass(CircularLinkedList, [{
    key: "isEmpty",
    value: function isEmpty() {
      return this.head === null;
    }
  }, {
    key: "start",
    value: function start() {
      if (this.head === null) return null;
      return this.head.data;
    }
  }, {
    key: "push",
    value: function push(data) {
      var node = new LinkedListNode(data);

      if (!this.head) {
        this.head = node;
        node.prev = node;
        node.next = node;
      } else {
        node.prev = this.head.prev;
        node.next = this.head;
        this.head.prev.next = node;
        this.head.prev = node;
      }

      this.length++;
      return node;
    }
  }, {
    key: "insertAfter",
    value: function insertAfter(prevNode, data) {
      var node = new LinkedListNode(data);
      node.prev = prevNode;
      node.next = prevNode.next;
      prevNode.next.prev = node;
      prevNode.next = node;
      this.length++;
      return node;
    }
  }, {
    key: "last",
    value: function last() {
      if (this.head) {
        return this.head.prev;
      } else return undefined;
    }
    /**
     * Returns an iterator over the values
     */

  }, {
    key: "values",
    value: /*#__PURE__*/regenerator.mark(function values() {
      var current;
      return regenerator.wrap(function values$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              current = this.head;

              if (!(current !== null)) {
                _context.next = 10;
                break;
              }

              _context.next = 4;
              return current.data;

            case 4:
              if (!(current.next !== this.head)) {
                _context.next = 10;
                break;
              }

              current = current.next;
              _context.next = 8;
              return current.data;

            case 8:
              _context.next = 4;
              break;

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, values, this);
    })
  }]);

  return CircularLinkedList;
}();

var tempSupport = new Vector(); //-----------------------------------------------------------------------------
// Minkowski sum support function for GJK

function support(shape1, shape2, d) {
  // d is a vector direction (doesn't have to be normalized)
  // get points on the edge of the shapes in opposite directions
  var p1 = shape1.getFarthestPointInDirection(d);
  var p2 = shape2.getFarthestPointInDirection(tempSupport.set(d).reverse()); // perform the Minkowski Difference
  // p3 is now a point in Minkowski space on the edge of the Minkowski Difference

  return p1.sub(p2);
}
function gjk(A, B) {
  var simplex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [new Vector(), new Vector(), new Vector()];
  var index = 0; // index of current vertex of simplex

  var ao = new Vector(),
      ab = new Vector(),
      ac = new Vector();
  var abperp = new Vector(),
      acperp = new Vector();
  var d = new Vector(); // pointers

  var a, b, c; // choose a search direction
  // we use the difference of the center of the two shapes

  d.set(A.getOrigin()).sub(B.getOrigin()); // if initial direction is zero – set it to any arbitrary axis (we choose X)

  if (d.x == 0 && d.y == 0) d.x = 1; // set the first support as initial point of the new simplex

  a = simplex[0].set(support(A, B, d));
  if (a.dot(d) <= 0) return false; // no collision
  // The next search direction is always towards the origin, so the next search direction is negate(a)

  d.set(a).reverse(); // start looping

  while (true) {

    a = simplex[++index].set(support(A, B, d)); // make sure that the last point we added actually passed the origin

    if (a.dot(d) <= 0) {
      // if the point added last was not past the origin in the direction of d
      // then the Minkowski Sum cannot possibly contain the origin since
      // the last point added is on the edge of the Minkowski Difference
      return false;
    } // get direction and test simplex


    ao.set(a).reverse(); // from point A to Origin is just negative A
    // simplex has 2 points (a line segment, not a triangle yet)

    if (index < 2) {
      b = simplex[0];
      ab.set(b).sub(a); // from point A to B

      tripleProduct(ab, ao, ab, d); // normal to AB towards Origin

      if (d.len2() == 0) d.set(ab).perp();
    } else {
      b = simplex[1];
      c = simplex[0];
      ab.set(b).sub(a); // from point A to B

      ac.set(c).sub(a); // from point A to C

      tripleProduct(ab, ac, ac, acperp);

      if (acperp.dot(ao) >= 0) {
        d.set(acperp); // new direction is normal to AC towards Origin
      } else {
        tripleProduct(ac, ab, ab, abperp);

        if (abperp.dot(ao) < 0) {
          //console.log("iteration: " + iter_count);
          return true; // collision
        }

        simplex[0].set(simplex[1]); // swap first element (point C)

        d.set(abperp); // new direction is normal to AB towards Origin
      }

      simplex[1].set(simplex[2]); // swap element in the middle (point B)

      --index;
    }
  }
} // http://www.fen.bilkent.edu.tr/~ercelebi/Ax(BxC).pdf

function tripleProduct(a, b, c, r) {
  var ac = a.x * c.x + a.y * c.y; // perform a.dot(c)

  var bc = b.x * c.x + b.y * c.y; // perform b.dot(c)
  // perform b * a.dot(c) - a * b.dot(c)

  r.x = b.x * ac - a.x * bc;
  r.y = b.y * ac - a.y * bc;
  return r;
}

var Edge = /*#__PURE__*/function () {
  function Edge(startVertex, distance) {
    classCallCheck(this, Edge);

    this.startVertex = startVertex;
    this.distance = distance;
  }

  createClass(Edge, [{
    key: "compare",
    value: function compare(other) {
      return this.distance < other.distance;
    }
  }]);

  return Edge;
}();

function originDistance(a, b) {
  return -a.cross(a.clone().sub(b)) / Math.sqrt(a.dist2(b));
}
function epa(A, B, simplex, result) {
  var polytope = new CircularLinkedList();
  var edges = new PriorityQueue(); // queue

  var d = new Vector();

  if (simplex[1].crossRef(simplex[2], simplex[0]) < 0) {
    var swap = simplex[1];
    simplex[1] = simplex[2];
    simplex[2] = swap;
  }

  for (var i = 0; i < simplex.length; i++) {
    var node = polytope.push(simplex[i]);
    var dist = originDistance(simplex[i], simplex[(i + 1) % 3]);
    edges.enqueue(new Edge(node, dist));
  }

  while (true) {
    //console.log(item.distance);
    //console.log(item.startVertex.data);
    //}
    //console.log(Array.from(polytope.values()));

    var _edges$dequeue = edges.dequeue(),
        _startVertex = _edges$dequeue.startVertex,
        _distance = _edges$dequeue.distance;

    var a = _startVertex.data;
    var b = _startVertex.next.data;
    var ab = b.clone().sub(a);

    var ap = _startVertex.prev.data.clone().sub(a);

    tripleProduct(ap, ab, ab, d); //console.log(d);

    var p = support(A, B, d);

    if (p.cross(ab) / ab.len() - _distance > 0.0001) {
      // add p to polytope;
      // update distance
      var _node = polytope.insertAfter(_startVertex, p);

      edges.enqueue(new Edge(_node.prev, originDistance(_node.prev.data, _node.data)));
      edges.enqueue(new Edge(_node, originDistance(_node.data, _node.next.data)));
    } else {
      // ab is the on the boundary
      result.normal = d.normalize();
      result.depth = _distance; //console.log("iteration: " + iter_count);

      return;
    }
  }
} // http://www.fen.bilkent.edu.tr/~ercelebi/Ax(BxC).pdf

/*
function tripleProduct(a:Vector,  b:Vector,  c:Vector,  r: Vector) {
    let ac = a.x * c.x + a.y * c.y; // perform a.dot(c)
    let bc = b.x * c.x + b.y * c.y; // perform b.dot(c)

    // perform b * a.dot(c) - a * b.dot(c)
    r.x = b.x * ac - a.x * bc;
    r.y = b.y * ac - a.y * bc;
    return r;
}

//-----------------------------------------------------------------------------
// This is to compute average center (roughly). It might be different from
// Center of Gravity, especially for bodies with nonuniform density,
// but this is ok as initial direction of simplex search in GJK.

function averagePoint (vertices: Array<Vector>) {
    let avg = new Vector();
    for (let i = 0; i < vertices.length; i++) {
        avg.x += vertices[i].x;
        avg.y += vertices[i].y;
    }
    avg.x /= vertices.length;
    avg.y /= vertices.length;
    return avg;
}

//-----------------------------------------------------------------------------
// Get furthest vertex along a certain direction

function indexOfFurthestPoint (vertices: Array<Vector>, d: Vector) {

    let maxProduct = d.dot(vertices[0]);
    let index = 0;
    for (let i = 1; i < vertices.length; i++) {
        let product = d.dot(vertices[i]);
        if (product > maxProduct) {
            maxProduct = product;
            index = i;
        }
    }
    return index;
}*/
//-----------------------------------------------------------------------------
// Minkowski sum support function for GJK

/*
function support (vertices1: Array<Vector>, vertices2: Array<Vector>, d: Vector) {

    // get furthest point of first body along an arbitrary direction
    let i = indexOfFurthestPoint (vertices1, d);

    // get furthest point of second body along the opposite direction
    let j = indexOfFurthestPoint (vertices2, d.clone().reverse());

    // subtract (Minkowski sum) the two points to see if bodies 'overlap'
    return vertices1[i].clone().sub(vertices2[j]);
}*/
//-----------------------------------------------------------------------------
// The GJK yes/no test

/*
function gjk (vertices1: Array<Vector>, vertices2: Array<Vector>) {
    let iter_count = 0;
    let index = 0; // index of current vertex of simplex
    let a: Vector = new Vector(), b: Vector = new Vector(), c: Vector = new Vector(), d: Vector = new Vector();
    let ao: Vector = new Vector(), ab: Vector = new Vector(), ac: Vector = new Vector();
    let abperp: Vector = new Vector(), acperp: Vector = new Vector();
    let simplex: [Vector, Vector, Vector] = [new Vector(), new Vector(), new Vector()];

    let position1 = averagePoint (vertices1); // not a CoG but
    let position2 = averagePoint (vertices2); // it's ok for GJK )

    // initial direction from the center of 1st body to the center of 2nd body

    d.set(position1).sub(position2);

    // if initial direction is zero – set it to any arbitrary axis (we choose X)
    if ((d.x == 0) && (d.y == 0))
        d.x = 1;

    // set the first support as initial point of the new simplex
    a.set(simplex[0].set(support (vertices1, vertices2, d)));

    if (a.dot(d) <= 0)
        return 0; // no collision

    d.set(a).reverse(); // The next search direction is always towards the origin, so the next search direction is negate(a)

    while (1) {
        iter_count++;

        a.set(simplex[++index].set(support (vertices1, vertices2, d)));

        if (a.dot(d) <= 0)
            return 0; // no collision

        ao.set(a).reverse(); // from point A to Origin is just negative A

        // simplex has 2 points (a line segment, not a triangle yet)
        if (index < 2) {
            b.set(simplex[0]);
            ab.set(b).sub(a); // from point A to B
            tripleProduct (ab, ao, ab, d); // normal to AB towards Origin
            if (d.len2() == 0)
                d.set(ab).perp();
            continue; // skip to next iteration
        }

        b = simplex[1];
        c = simplex[0];
        ab.set(b).sub(a); // from point A to B
        ac.set(c).sub(a); // from point A to C
        tripleProduct(ab, ac, ac, acperp);

        if (acperp.dot(ao) >= 0) {
            d.set(acperp); // new direction is normal to AC towards Origin
        } else {

            tripleProduct (ac, ab, ab, abperp );
            if (abperp.dot(ao) < 0)
                return 1; // collision
            simplex[0].set(simplex[1]); // swap first element (point C)
            d.set(abperp); // new direction is normal to AB towards Origin
        }

        simplex[1].set(simplex[2]); // swap element in the middle (point B)
        --index;
    }
    return 0;
}*/

/* test
function Perturbation()
{
    return Math.random() * FLT_EPSILON * 100.0 * (Math.random() > 0.5 ? 1.0 : -1.0);
}

function Jostle(vec2 a)
{
    vec2 b;
    b.x = a.x + Perturbation();
    b.y = a.y + Perturbation();
    return b;
}
int main(int argc, const char * argv[]) {

    // test case from dyn4j

    vec2 vertices1[] = {
    { 4.0f, 11.0f },
    { 5.0f, 5.0f },
    { 9.0f, 9.0f },
};

    vec2 vertices2[] = {
    { 4.0f, 11.0f },
    { 5.0f, 5.0f },
    { 9.0f, 9.0f },
};

    size_t count1 = sizeof (vertices1) / sizeof (vec2); // == 3
    size_t count2 = sizeof (vertices2) / sizeof (vec2); // == 4

    while (1)
    {
        vec2 a[sizeof (vertices1) / sizeof (vec2)];
        vec2 b[sizeof (vertices2) / sizeof (vec2)];

        for (size_t i = 0; i < count1; ++i) a[i] = Jostle(vertices1[i]);
        for (size_t i = 0; i < count2; ++i) b[i] = Jostle(vertices2[i]);

        int collisionDetected = gjk (a, count1, b, count2);
        if (!collisionDetected)
        {
            printf("Found failing case:\n\t{%f, %f}, {%f, %f}, {%f, %f}\n\t{%f, %f}, {%f, %f}, {%f, %f}\n\n",
                a[0].x, a[0].y, a[1].x, a[1].y, a[2].x, a[2].y,
                b[0].x, b[0].y, b[1].x, b[1].y, b[2].x, b[2].y
            );
        }
        else
        {
            printf("Collision correctly detected\n");
        }
        iter_count = 0;
    }

    return 0;
}*/

var MAX_POC_COUNT = 5;
function resolvePointsOfContact(A, B, result) {
  var normal = result.normal;
  var depth = result.depth;
  var segmentA, segmentB;
  segmentA = A.getFarthestEdgeInDirection(normal);
  segmentB = B.getFarthestEdgeInDirection(normal.clone().reverse());
  var segmentRef, segmentInc;

  if (Math.abs(segmentA.dot(normal)) <= Math.abs(segmentB.dot(normal))) {
    segmentRef = segmentA;
    segmentInc = segmentB;
  } else {
    segmentInc = segmentA;
    segmentRef = segmentB;
  }

  var refv = segmentRef.v2.clone().sub(segmentRef.v1);
  refv.normalize();
  var o1 = refv.dot(segmentRef.v1); // clip the incident edge by the first
  // vertex of the reference edge

  var cp = clip(segmentInc.v1, segmentInc.v2, refv, o1); // if we dont have 2 points left then fail

  if (cp.length < 2) {
    console.log("error: impossible poc situation");
    return;
  } // clip whats left of the incident edge by the
  // second vertex of the reference edge
  // but we need to clip in the opposite direction
  // so we flip the direction and offset


  var o2 = refv.dot(segmentRef.v2);
  cp = clip(cp[0], cp[1], refv.clone().scl(-1), -o2); // if we dont have 2 points left then fail

  if (cp.length < 2) {
    console.log("error: impossible poc situation");
    return;
  }

  for (var i = 0; i < 2; i++) {
    var vcp = cp[i].crossRef(segmentRef.v2, segmentRef.v1);
    if (vcp < 0.01) result.contacts.push(cp[i]);
  }

  if (result.contacts.length < 1) {
    console.log(A);
    console.log(B);
    console.log(result);
    console.log(cp[0]);
    console.log(cp[1]);
    console.log(segmentRef.v2);
    console.log(segmentRef.v1);
    console.log(cp[0].crossRef(segmentRef.v2, segmentRef.v1));
    console.log(cp[1].crossRef(segmentRef.v2, segmentRef.v1));
    console.log("error: impossible poc situation");
  }
}
function clip(v1, v2, n, o) {
  var cp = new Array();
  var d1 = n.dot(v1) - o;
  var d2 = n.dot(v2) - o; // if either point is past o along n
  // then we can keep the point

  if (d1 >= 0.0) cp.push(v1);
  if (d2 >= 0.0) cp.push(v2); // finally we need to check if they
  // are on opposing sides so that we can
  // compute the correct point

  if (d1 * d2 < 0.0) {
    // if they are on different sides of the
    // offset, d1 and d2 will be a (+) * (-)
    // and will yield a (-) and therefore be
    // less than zero
    // get the vector for the edge we are clipping
    var e = v2.clone().sub(v1); // compute the location along e

    var u = d1 / (d1 - d2);
    e.scl(u);
    e.add(v1); // add the point

    cp.push(e);
  }

  return cp;
}
function resolvePointsOfContact2(A, B, result) {
  var normal = result.normal;
  var depth = result.depth;
  var segmentA, segmentB;
  segmentA = A.getFarthestEdgeInDirection(normal);
  segmentB = B.getFarthestEdgeInDirection(normal.clone().reverse());
  var segmentRef, segmentInc;

  if (Math.abs(segmentA.dot(normal)) <= Math.abs(segmentB.dot(normal))) {
    segmentRef = segmentA;
    segmentInc = segmentB;
  } else {
    segmentInc = segmentA;
    segmentRef = segmentB;
  }

  var d1 = segmentInc.v1.dotRef(segmentRef.v2, segmentRef.v1);
  var d2 = segmentInc.v2.dotRef(segmentRef.v2, segmentRef.v1);

  if (d1 > d2) {
    var swap = d1;
    d1 = d2;
    d2 = swap;
    var swapP = segmentInc.v1;
    segmentInc.v1 = segmentInc.v2;
    segmentInc.v2 = swapP;
  }

  var u1 = -d1 / (d2 - d1);
  var u2 = (segmentRef.len2() - d1) / (d2 - d1);
  var v1, v2;

  if (u1 > 0 && u1 < 1) {
    v1 = segmentInc.lerp(u1);
  } else {
    v1 = segmentInc.v1.clone();
  }

  if (u2 > 0 && u2 < 1) {
    v2 = segmentInc.lerp(u2);
  } else {
    v2 = segmentInc.v2.clone();
  }

  console.log(v1);
  console.log(v2);
  var v1c = v1.crossRef(segmentRef.v2, segmentRef.v1);
  var v2c = v2.crossRef(segmentRef.v2, segmentRef.v1);
  var startV, endV;

  if (v1c <= 0.01) {
    if (v2c <= 0.01) {
      startV = v1;
      endV = v2;
    } else {
      startV = v1;
      endV = v1;
    }
  } else {
    if (v2c <= 0.01) {
      startV = v2;
      endV = v2;
    } else {
      // TODO: replace with logger
      console.log(A);
      console.log(B);
      console.log(result);
      console.log("error: impossible poc situation");
      return;
    }
  } //console.log(startV);
  //console.log(endV);


  if (startV === endV) {
    result.contacts.push(startV);
  } else {
    for (var i = 0; i < 1 - 0.001; i += 1 / (MAX_POC_COUNT - 1)) {
      result.contacts.push(Vector.lerp(startV, endV, i));
    }

    result.contacts.push(endV);
  }
}

(function (VORONOI_REGION) {
  VORONOI_REGION[VORONOI_REGION["LEFT"] = 0] = "LEFT";
  VORONOI_REGION[VORONOI_REGION["UP"] = 1] = "UP";
  VORONOI_REGION[VORONOI_REGION["DOWN"] = 2] = "DOWN";
  VORONOI_REGION[VORONOI_REGION["RIGHT"] = 3] = "RIGHT";
})(exports.VORONOI_REGION || (exports.VORONOI_REGION = {}));

var Segment = /*#__PURE__*/function () {
  function Segment(v1, v2) {
    classCallCheck(this, Segment);

    defineProperty(this, "v1", void 0);

    defineProperty(this, "v2", void 0);

    this.v1 = v1;
    this.v2 = v2;
  }

  createClass(Segment, [{
    key: "getAABB",
    value: function getAABB() {
      return new AABB(Math.min(this.v1.x, this.v2.x), Math.min(this.v1.y, this.v2.y), Math.max(this.v1.x, this.v2.x), Math.max(this.v1.y, this.v2.y));
    }
  }, {
    key: "contains",
    value: function contains(v) {
      return segmentHasPoint(this.v1, this.v2, v);
    }
  }, {
    key: "isPointOnLine",
    value: function isPointOnLine(p) {
      var tolerance = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0.01;
      return Math.abs(this.cross(p)) < tolerance;
    }
  }, {
    key: "cross",
    value: function cross(p) {
      return (p.x - this.v1.x) * (this.v2.y - this.v1.y) - (this.v2.x - this.v1.x) * (p.y - this.v1.y);
    }
  }, {
    key: "dot",
    value: function dot(dir) {
      return (this.v2.x - this.v1.x) * dir.x + (this.v2.y - this.v1.y) * dir.y;
    }
    /**
    * Calculates which Voronoi region a point is on a line segment.
    * It is assumed that both the line and the point are relative to `(0,0)`
    *
    *            |       (1)      |
    *     (0)  [S]--------------[E]  (3)
    *            |       (2)      |
    * @param {Vector} point The point.
    * @return  {VORONOI_REGION} VORONOI_REGION.LEFT (0) if it is the left region,
    *          VORONOI_REGION.UP (1) if it is the up region,
    *          VORONOI_REGION.DOWN (2) if it is the down region.
    *          VORONOI_REGION.RIGHT (3) if it is the right region.
    */

  }, {
    key: "voronoiRegion",
    value: function voronoiRegion(point) {
      var len2 = this.len2();
      var dp = point.dotRef(this.v2, this.v1); // If the point is beyond the start of the line, it is in the
      // left voronoi region.

      if (dp < 0) {
        return exports.VORONOI_REGION.LEFT;
      } // If the point is beyond the end of the line, it is in the
      // right voronoi region.
      else if (dp > len2) {
          return exports.VORONOI_REGION.RIGHT;
        } // Otherwise, it's in the middle one.
        else {
            if (point.crossRef(this.v2, this.v1) < 0) return exports.VORONOI_REGION.UP;else return exports.VORONOI_REGION.DOWN;
          }
    }
  }, {
    key: "len2",
    value: function len2() {
      return this.v2.dist2(this.v1);
    }
  }, {
    key: "len",
    value: function len() {
      return this.v2.dist(this.v1);
    }
  }, {
    key: "lerp",
    value: function lerp(t) {
      return Vector.lerp(this.v1, this.v2, t);
    }
  }, {
    key: "intersects",
    value: function intersects(segment) {
      var o1 = orientation(this, segment.v1);
      var o2 = orientation(this, segment.v2);
      var o3 = orientation(segment, this.v1);
      var o4 = orientation(segment, this.v2);
      if (o1 != o2 && o3 != o4) return true;
      return false;
    }
  }]);

  return Segment;
}();

var Transform = /*#__PURE__*/function () {
  /** the cosine of the rotation angle */

  /** the sine of the rotation angle */

  /** The x,y translation */
  function Transform(transform) {
    classCallCheck(this, Transform);

    defineProperty(this, "cost", 1.0);

    defineProperty(this, "sint", 0.0);

    defineProperty(this, "_pos", new Vector());

    if (transform instanceof Transform) {
      this.cost = transform.cost;
      this.sint = transform.sint;
      this._pos.x = transform._pos.x;
      this._pos.y = transform._pos.y;
    } else if (transform instanceof Vector) {
      this.cost = 1;
      this.sint = 0;
      this._pos.x = transform.x;
      this._pos.y = transform.y;
    } else {
      this.cost = 1;
      this.sint = 0;
      this._pos.x = 0;
      this._pos.y = 0;
    }
  }
  /**
   * Internal helper method to rotate this {@link Transform} by an angle &thetasym; around a point
   * @param theta theta
   * @param x the x coordinate of the point
   * @param y the y coordinate of the point
   * @since 3.3.1
   */


  createClass(Transform, [{
    key: "rotate",
    value: function rotate(theta, x, y) {
      // pre-compute cos/sin of the given angle
      var cos = Math.cos(theta);
      var sin = Math.sin(theta); // perform an optimized version of the matrix multiplication:
      // M(new) = inverse(T) * R * T * M(old)

      var cost = cos * this.cost - sin * this.sint;
      var sint = sin * this.cost + cos * this.sint;
      this.cost = cost;
      this.sint = sint;
      var cx = this._pos.x - x;
      var cy = this._pos.y - y;
      this._pos.x = cos * cx - sin * cy + x;
      this._pos.y = sin * cx + cos * cy + y;
    }
  }, {
    key: "translate",
    value: function translate(x, y) {
      this._pos.x += x;
      this._pos.y += y;
    }
  }, {
    key: "transform",
    value: function transform(vector, tv) {
      var x = vector.x;
      var y = vector.y;
      tv.x = this.cost * x - this.sint * y + this._pos.x;
      tv.y = this.sint * x + this.cost * y + this._pos.y;
      return tv;
    }
  }, {
    key: "inverseTransform",
    value: function inverseTransform(vector, tv) {
      var tx = vector.x - this._pos.x;
      var ty = vector.y - this._pos.y;
      tv.x = this.cost * tx + this.sint * ty;
      tv.y = -this.sint * tx + this.cost * ty;
      return tv;
    }
    /**
     * Sets this transform to the given transform.
     * @param transform the transform to copy
     */

  }, {
    key: "set",
    value: function set(transform) {
      this.cost = transform.cost;
      this.sint = transform.sint;
      this._pos.x = transform._pos.x;
      this._pos.y = transform._pos.y;
      return this;
    }
  }, {
    key: "mulTransform",
    value: function mulTransform(transform) {
      transform.transform(this._pos, this._pos);
      var cost = transform.cost * this.cost - transform.sint * this.sint;
      var sint = transform.sint * this.cost + transform.cost * this.sint;
      this.cost = cost;
      this.sint = sint;
      return this;
    }
  }, {
    key: "inverse",
    value: function inverse() {
      var sint = this.sint;
      var cost = this.cost;
      var x = this._pos.x;
      var y = this._pos.y;
      this._pos.x = -sint * y - cost * x;
      this._pos.y = sint * x - cost * y;
      this.sint = -sint;
      return this;
    }
    /* A * B = C
       C * B^(-1) = A
        [cost, -sint, x] [x] = [cost * x - sint * y + x]
        [sint, cost,  y] [y]   [sint * x + cost * y + x]
        [0,    0,     1] [1]   [1]
         [cost, -sint, x] [x] = [cost * x - sint * y + x]
        [sint, cost,  y] [y]   [sint * x + cost * y + x]
        [0,    0,     1] [1]   [1]
         [cost, -sint, x] [coss, -sins, x] = [cost * coss - sint * sins, , cost * x - sint * y + x]
        [sint, cost,  y] [sins, coss,  y]   [sint * coss + cost * sins, , sint * x + cost * y + x]
        [0,    0,     1] [0,    0,     1]   [0, 0, 1]
         [cost, -sint, x] ^1 = [cost,  sint, -sint * y - cost * x]
        [sint, cost,  y]      [-sint, cost, sint * x - cost * y]
        [0,    0,     1]      [0,     0,     1]
      */

  }, {
    key: "mulInverseTransform",
    value: function mulInverseTransform(transform) {
      return this.mulTransform(transform.clone().inverse());
    }
  }, {
    key: "clone",
    value: function clone() {
      return new Transform(this);
    }
    /**
     * Interpolates linearly by alpha towards the given end transform placing
     * the result in the given transform.
     * <p>
     * Interpolating from one angle to another can have two results depending on the
     * direction of the rotation.  If a rotation was from 30 to 200 the rotation could
     * be 170 or -190.  This interpolation method will always choose the smallest
     * rotation (regardless of sign) as the rotation direction.
     * @param end the end transform
     * @param alpha the amount to interpolate
     * @param result the transform to place the result
     * @since 1.2.0
     */

  }, {
    key: "lerp",
    value: function lerp(end, alpha, result) {
      // interpolate the position
      var x = this.x + alpha * (end.x - this.x);
      var y = this.y + alpha * (end.y - this.y); // compute the angle
      // get the start and end rotations
      // its key that these methods use atan2 because
      // it ensures that the angles are always within
      // the range -pi < theta < pi therefore no
      // normalization has to be done

      var rs = this.angle;
      var re = end.angle; // make sure we use the smallest rotation
      // as described in the comments above, there
      // are two possible rotations depending on the
      // direction, we always choose the smaller

      var diff = re - rs;
      if (diff < -Math.PI) diff += Geom2Const.PI2;
      if (diff > Math.PI) diff -= Geom2Const.PI2; // interpolate
      // its ok if this method produces an angle
      // outside the range of -pi < theta < pi
      // since the rotate method uses sin and cos
      // which are not bounded

      var a = diff * alpha + rs; // set the result transform to the interpolated transform
      // the following performs the following calculations:
      // result.identity();
      // result.rotate(a);
      // result.translate(x, y);

      result.cost = Math.cos(a);
      result.sint = Math.sin(a);
      result.position.x = x;
      result.position.y = y;
    }
  }, {
    key: "toString",
    value: function toString() {
      return "[x:".concat(this.position.x, ", y:").concat(this.position.y, ", a:").concat(this.angle / Math.PI * 180, "]");
    }
  }, {
    key: "angle",
    set: function set(theta) {
      this.cost = Math.cos(theta);
      this.sint = Math.sin(theta);
    }
    /**
     * Returns the rotation.
     * @return double angle in the range [-&pi;, &pi;]
     */
    ,
    get: function get() {
      return Math.atan2(this.sint, this.cost);
    }
  }, {
    key: "position",
    set: function set(pos) {
      this._pos.set(pos);
    },
    get: function get() {
      return this._pos;
    }
  }, {
    key: "x",
    get: function get() {
      return this._pos.x;
    }
  }, {
    key: "y",
    get: function get() {
      return this._pos.y;
    }
  }]);

  return Transform;
}();

var TEMP = new Vector();
var Circle = /*#__PURE__*/function () {
  createClass(Circle, [{
    key: "center",
    get: function get() {
      return this.transform.position;
    }
  }]);

  function Circle(c, r) {
    classCallCheck(this, Circle);

    defineProperty(this, "transform", void 0);

    defineProperty(this, "r", void 0);

    this.transform = new Transform(c);
    this.r = r;
  } // Rotates this polygon counter-clockwise around the origin of *its local coordinate system* (i.e. `pos`).


  createClass(Circle, [{
    key: "rotate",
    value: function rotate(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Vector.ZERO;
      this.transform.rotate(angle, center.x, center.y);
      return this;
    } // Translates the points of this polygon by a specified amount relative to the origin of *its own coordinate

  }, {
    key: "translate",
    value: function translate(x, y) {
      this.transform.translate(x, y);
      return this;
    }
  }, {
    key: "intersectsSegment",
    //(ray.v2.x * t + ray.v1.x * (1 - t) - this.center.x) ^ 2 +
    //(ray.v2.y * t + ray.v1.y * (1 - t) - this.center.y) ^ 2 = this.r ^ 2
    value: function intersectsSegment(ray, result) {
      var a = ray.v2.x;
      var b = ray.v1.x;
      var c = this.center.x;
      var d = ray.v2.y;
      var e = ray.v1.y;
      var f = this.center.y;
      var aa = (a - b) * (a - b) + (d - e) * (d - e);
      var bb = (a * b - b * b - a * c + b * c - e * e + e * d - d * f + e * f) * 2;
      var cc = (b - c) * (b - c) + (e - f) * (e - f) - this.r * this.r;
      var det = bb * bb - 4 * aa * cc;

      if (det >= 0) {
        var t1 = (-bb - Math.sqrt(det)) / (2 * aa);
        var t2 = (-bb + Math.sqrt(det)) / (2 * aa);
        var t = NaN;

        if (t1 >= 0 && t1 <= 1) {
          t = t1;
        }

        if (t2 >= 0 && t2 <= 1 && t2 < t) {
          t = t2;
        }

        if (!isNaN(t)) {
          if (result) {
            result.contacts = [new Vector(a * t + b * (1 - t), d * t + e * (1 - t))];
            result.depth = result.contacts[0].dist(ray.v1);
            result.normal = result.contacts[0].clone().sub(this.center).normalize();
          }

          return true;
        }
      }

      return false;
    }
  }, {
    key: "intersects",
    value: function intersects(shape, result) {
      var simplex = [new Vector(), new Vector(), new Vector()];
      var collided = gjk(this, shape, simplex);

      if (result && collided) {
        epa(this, shape, simplex, result);
        resolvePointsOfContact(this, shape, result); //throw new Error("shape intersects unavailable");

        return true;
      }

      return collided;
    }
  }, {
    key: "getAABB",
    value: function getAABB() {
      return new AABB(this.center.x - this.r, this.center.y - this.r, this.center.x + this.r, this.center.y + this.r);
    }
  }, {
    key: "isPointIn",
    value: function isPointIn(v) {
      return v.dist(this.center) <= this.r;
    }
  }, {
    key: "getArea",
    value: function getArea() {
      return this.r * this.r * Math.PI;
    }
  }, {
    key: "getOrigin",
    value: function getOrigin() {
      return this.center;
    }
  }, {
    key: "getCentroid",
    value: function getCentroid() {
      return this.center;
    }
  }, {
    key: "getFarthestPointInDirection",
    value: function getFarthestPointInDirection(d) {
      return d.clone().setLen(this.r).add(this.center);
    }
  }, {
    key: "getFarthestEdgeInDirection",
    value: function getFarthestEdgeInDirection(d) {
      TEMP.set(d).normalize();
      return new Segment(TEMP.clone().perp().scl(this.r * 0.01).addMul(TEMP, this.r).add(this.center), TEMP.clone().perp().scl(-this.r * 0.01).addMul(TEMP, this.r).add(this.center));
    }
  }, {
    key: "toString",
    value: function toString() {
      return "{p:".concat(this.transform.position, ", rot:").concat(this.transform.angle, ", rad:").concat(this.r, "}");
    }
  }]);

  return Circle;
}();

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
var TEMP$1 = new Vector();
/**
 * Polygon in this class satisfies:
 * 1. It must be a simple polygon.
 * 2. It contain the point (0, 0).
 * 3. Points are sorted in counter-clockwise order from it's center.
 */

var Polygon = /*#__PURE__*/function () {
  //public pos: Vector;
  function Polygon(pos, points) {
    classCallCheck(this, Polygon);

    defineProperty(this, "transform", void 0);

    defineProperty(this, "points", void 0);

    defineProperty(this, "calcPoints", void 0);

    defineProperty(this, "centroid", void 0);

    this.transform = new Transform(pos);
    this.points = points;
    this.calcPoints = new Array();
    this.centroid = new Vector();
    this.recalc();
  }

  createClass(Polygon, [{
    key: "rotate",
    // Rotates this polygon counter-clockwise around the origin of *its local coordinate system* (i.e. `pos`).
    value: function rotate(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Vector.ZERO;
      this.transform.rotate(angle, center.x, center.y);
      return this;
    } // Translates the points of this polygon by a specified amount relative to the origin of *its own coordinate

  }, {
    key: "translate",
    value: function translate(x, y) {
      this.transform.translate(x, y);
      return this;
    }
  }, {
    key: "rotateLocal",
    // Rotates this polygon counter-clockwise around the origin of *its local coordinate system* (i.e. `pos`).
    value: function rotateLocal(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Vector.ZERO;

      for (var i = 0; i < this.points.length; i++) {
        this.points[i].rotate(angle, center);
      }
    } // Translates the points of this polygon by a specified amount relative to the origin of *its own coordinate

  }, {
    key: "translateLocal",
    value: function translateLocal(x, y) {
      var points = this.points;
      var len = points.length;

      for (var i = 0; i < len; i++) {
        points[i].x += x;
        points[i].y += y;
      }

      return this;
    }
  }, {
    key: "recalc",
    // Calculated points - this is what is used for underlying collisions and takes into account
    // the angle/offset set on the polygon.
    value: function recalc() {
      var lengthChanged = this.points.length !== this.calcPoints.length;

      if (lengthChanged) {
        while (this.points.length < this.calcPoints.length) {
          this.calcPoints.pop();
        }

        while (this.points.length > this.calcPoints.length) {
          this.calcPoints.push(new Vector());
        }
      } // Copy the original points array and apply the offset/angle


      var points = this.points;
      var len = points.length;
      var i;

      for (i = 0; i < len; i++) {
        this.transform.transform(points[i], this.calcPoints[i]);
      }

      this.centroid.set(this.getCentroid());
      return this;
    }
  }, {
    key: "getOrigin",
    value: function getOrigin() {
      return this.transform.position;
    }
  }, {
    key: "getCentroid",
    value: function getCentroid() {
      var points = this.calcPoints;
      var len = points.length;
      var cx = 0;
      var cy = 0;
      var ar = 0;

      for (var i = 0; i < len; i++) {
        var p1 = points[i];
        var p2 = i === len - 1 ? points[0] : points[i + 1]; // Loop around if last point

        var a = p1.x * p2.y - p2.x * p1.y;
        cx += (p1.x + p2.x) * a;
        cy += (p1.y + p2.y) * a;
        ar += a;
      }

      ar = ar * 3; // we want 1 / 6 the area and we currently have 2*area

      cx = cx / ar;
      cy = cy / ar;
      return new Vector(cx, cy);
    }
  }, {
    key: "intersectsSegment",
    value: function intersectsSegment(line, result) {
      var points = this.calcPoints;
      var segment = new Segment(new Vector(), new Vector());

      if (result) {
        result.depth = Number.MAX_VALUE;
      }

      for (var i = 0; i < points.length; i++) {
        segment.v1 = points[i];
        segment.v2 = points[(i + 1) % points.length];

        if (line.intersects(segment)) {
          if (result) {
            var p = lineLineIntersection(segment.v1, segment.v2, line.v1, line.v2);
            var dist = p.dist(line.v1);

            if (dist < result.depth) {
              result.contacts = [p];
              result.depth = dist;
              result.normal.set(segment.v2).sub(segment.v1).normalize().perp();
            }
          } else {
            return true;
          }
        }
      }

      if (result) {
        return result.depth !== Number.MAX_VALUE;
      }

      return false;
    }
  }, {
    key: "intersects",
    value: function intersects(shape, result) {
      var simplex = [new Vector(), new Vector(), new Vector()];
      var collided = gjk(this, shape, simplex);

      if (result && collided) {
        epa(this, shape, simplex, result);
        resolvePointsOfContact(this, shape, result); //throw new Error("shape intersects unavailable");

        return true;
      }

      return collided;
    }
  }, {
    key: "isPointIn",
    value: function isPointIn(v) {
      var points = this.calcPoints;
      var length = points.length;
      var c = false;

      for (var i = 0; i < length; i++) {
        if (points[i].y > v.y !== points[(i + 1) % length].y > v.y && v.x < (points[(i + 1) % length].x - points[i].x) * (v.y - points[i].y) / (points[(i + 1) % length].y - points[i].y) + points[i].x) {
          c = !c;
        }
      }

      if (c) {
        return true;
      }

      return this.isPointOn(v);
    }
  }, {
    key: "isPointOn",
    value: function isPointOn(v) {
      var points = this.calcPoints;
      var length = points.length;

      for (var i = 0; i < length; i++) {
        var p1 = points[i];
        var p2 = points[(i + 1) % length];

        if (segmentHasPoint(p1, p2, v)) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: "getAABB",
    value: function getAABB() {
      return Polygon.getAABBFromPoints(this.calcPoints);
    }
  }, {
    key: "getOriginAABB",
    value: function getOriginAABB() {
      return Polygon.getAABBFromPoints(this.calcPoints);
    }
  }, {
    key: "getArea",
    value: function getArea() {
      var points = this.points;
      var len = points.length;
      var ar = 0;

      for (var i = 0; i < len; i++) {
        var p1 = points[i];
        var p2 = i === len - 1 ? points[0] : points[i + 1]; // Loop around if last point

        var a = p1.x * p2.y - p2.x * p1.y;
        ar += a;
      }

      return ar / 2;
    }
  }, {
    key: "toCanvasDraw",
    value: function toCanvasDraw() {
      var scale = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      var points = this.points;
      var len = points.length;
      var str = 'ctx.beginPath();\n';
      str += 'ctx.strokeStyle = "black";\n';
      str += 'ctx.moveTo(' + (points[0].x + this.transform.x) * scale + ',' + (points[0].y + this.transform.y) * scale + ');\n';

      for (var i = 1; i < len; i++) {
        str += 'ctx.lineTo(' + (points[i].x + this.transform.x) * scale + ',' + (points[i].y + this.transform.y) * scale + ');\n';
      }

      str += 'ctx.lineTo(' + (points[0].x + this.transform.x) * scale + ',' + (points[0].y + this.transform.y) * scale + ');\n';
      str += 'ctx.stroke();';
      return str;
    }
  }, {
    key: "getFarthestIndexInDirection",
    value: function getFarthestIndexInDirection(d) {
      var vertices = this.calcPoints;
      TEMP$1.set(vertices[0]).sub(this.transform.position);
      var maxProduct = d.dot(TEMP$1);
      var index = 0;

      for (var i = 1; i < vertices.length; i++) {
        TEMP$1.set(vertices[i]).sub(this.transform.position);
        var product = d.dot(TEMP$1);

        if (product > maxProduct) {
          maxProduct = product;
          index = i;
        }
      }

      return index;
    }
  }, {
    key: "getFarthestPointInDirection",
    value: function getFarthestPointInDirection(d) {
      return this.calcPoints[this.getFarthestIndexInDirection(d)].clone();
    }
  }, {
    key: "getFarthestEdgeInDirection",
    value: function getFarthestEdgeInDirection(d) {
      var vertices = this.calcPoints;
      var index = this.getFarthestIndexInDirection(d);
      var p0 = vertices[(index - 1 + vertices.length) % vertices.length];
      var p1 = vertices[index];
      var p2 = vertices[(index + 1) % vertices.length];
      var l = p1.clone().sub(p0).normalize();
      var r = p1.clone().sub(p2).normalize();

      if (r.dot(d) < l.dot(d)) {
        return new Segment(p1, p2);
      } else {
        return new Segment(p0, p1);
      }
    }
  }, {
    key: "validate",
    value: function validate() {
      var points = this.calcPoints;
      var length = points.length;
      var temp = new Vector();
      var temp2 = new Vector();

      for (var i = 0; i < length; i++) {
        var p1 = points[i];
        var p2 = points[(i + 1) % length];
        var p3 = points[(i + 2) % length];
        temp2.set(p3).sub(p2);

        if (temp.set(p2).sub(p1).cross(temp2) <= 0) {
          return false;
        }
      }

      return true;
    }
  }, {
    key: "recenter",
    value: function recenter() {
      var c = this.getCentroid();

      var _iterator = _createForOfIteratorHelper(this.points),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var p = _step.value;
          p.sub(c);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      this.transform.translate(c.x, c.y);
      this.recalc();
    }
  }, {
    key: "originPoints",
    get: function get() {
      return this.points;
    }
  }], [{
    key: "fromAABB",
    value: function fromAABB(aabb) {
      return new Polygon(aabb.getCenter(), [new Vector(-aabb.width / 2, -aabb.height / 2), new Vector(aabb.width / 2, -aabb.height / 2), new Vector(aabb.width / 2, aabb.height / 2), new Vector(-aabb.width / 2, aabb.height / 2)]);
    }
  }, {
    key: "getAABBFromPoints",
    value: function getAABBFromPoints(points) {
      var len = points.length;
      var xMin = points[0].x;
      var yMin = points[0].y;
      var xMax = points[0].x;
      var yMax = points[0].y;

      for (var i = 1; i < len; i++) {
        var point = points[i];

        if (point.x < xMin) {
          xMin = point.x;
        } else if (point.x > xMax) {
          xMax = point.x;
        }

        if (point.y < yMin) {
          yMin = point.y;
        } else if (point.y > yMax) {
          yMax = point.y;
        }
      }

      return new AABB(xMin, yMin, xMax, yMax);
    }
  }]);

  return Polygon;
}();

var ComposedShape = /*#__PURE__*/function () {
  function ComposedShape(shapes, transform) {
    classCallCheck(this, ComposedShape);

    this.shapes = shapes;

    defineProperty(this, "transform", void 0);

    defineProperty(this, "localTransforms", []);

    if (transform == null) {
      var centroid = this.getCentroid();
      this.transform = new Transform(centroid);
    } else {
      this.transform = transform;
    }

    for (var i = 0; i < shapes.length; i++) {
      this.localTransforms.push(shapes[i].transform.clone().mulInverseTransform(this.transform));
    }
  }

  createClass(ComposedShape, [{
    key: "recalc",
    value: function recalc() {
      for (var k = 0; k < this.shapes.length; k++) {
        this.shapes[k].transform.set(this.localTransforms[k]).mulTransform(this.transform);

        if (this.shapes[k] instanceof Polygon) {
          this.shapes[k].recalc();
        }
      }
    } // Rotates this polygon counter-clockwise around the center

  }, {
    key: "rotate",
    value: function rotate(angle) {
      var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.transform.position;
      this.transform.rotate(angle, center.x, center.y);

      for (var k = 0; k < this.shapes.length; k++) {
        this.shapes[k].transform.set(this.localTransforms[k]).mulTransform(this.transform); //.rotate(angle, center);
      }

      return this;
    } // Translates this shape by a specified amount

  }, {
    key: "translate",
    value: function translate(x, y) {
      this.transform.translate(x, y);

      for (var k = 0; k < this.shapes.length; k++) {
        this.shapes[k].transform.set(this.localTransforms[k]).mulTransform(this.transform);
      }

      return this;
    }
  }, {
    key: "rotateLocal",
    value: function rotateLocal(angle) {
      return this;
    }
  }, {
    key: "translateLocal",
    value: function translateLocal(x, y) {
      return this;
    }
  }, {
    key: "isPointIn",
    value: function isPointIn(vector) {
      for (var k = 0; k < this.shapes.length; k++) {
        if (this.shapes[k].isPointIn(vector)) return true;
      }

      return false;
    }
  }, {
    key: "getArea",
    value: function getArea() {
      var area = 0;

      for (var k = 0; k < this.shapes.length; k++) {
        area += this.shapes[k].getArea();
      }

      return area;
    }
  }, {
    key: "getCentroid",
    value: function getCentroid() {
      var v = new Vector();
      var c = 0;

      for (var k = 0; k < this.shapes.length; k++) {
        var area = this.shapes[k].getArea();
        v.addMul(this.shapes[k].getCentroid(), area);
        c += area;
      }

      v.scl(1.0 / c);
      return v;
    }
  }, {
    key: "getOrigin",
    value: function getOrigin() {
      return this.transform.position;
    }
  }, {
    key: "getAABB",
    value: function getAABB() {
      if (this.shapes.length === 0) return new AABB(this.transform.position.x, this.transform.position.y, this.transform.position.x, this.transform.position.y);
      var aabb = this.shapes[0].getAABB();

      for (var k = 1; k < this.shapes.length; k++) {
        aabb.merge(this.shapes[k].getAABB());
      }

      return aabb;
    }
  }]);

  return ComposedShape;
}();

function _createForOfIteratorHelper$1(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$1(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray$1(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$1(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$1(o, minLen); }

function _arrayLikeToArray$1(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var LQTreeElement = function LQTreeElement(aabb, data) {
  classCallCheck(this, LQTreeElement);

  defineProperty(this, "aabb", void 0);

  defineProperty(this, "data", void 0);

  this.aabb = aabb;
  this.data = data;
};

var LQTreeNode = /*#__PURE__*/function () {
  // only if the count > 0, looseBound has meaning.
  function LQTreeNode(minX, minY, maxX, maxY) {
    classCallCheck(this, LQTreeNode);

    defineProperty(this, "children", void 0);

    defineProperty(this, "baseBound", void 0);

    defineProperty(this, "count", void 0);

    defineProperty(this, "looseBound", void 0);

    defineProperty(this, "elements", void 0);

    this.children = null;
    this.baseBound = new AABB(minX, minY, maxX, maxY);
    this.looseBound = new AABB(0, 0, 0, 0);
    this.elements = [];
    this.count = 0;
  }

  createClass(LQTreeNode, [{
    key: "extendLooseBound",
    value: function extendLooseBound(result) {
      if (this.count > 0) result.merge(this.looseBound);
    }
  }, {
    key: "contains",
    value: function contains(aabb) {
      if (this.count > 0) return this.looseBound.contains(aabb);
      return false;
    }
  }, {
    key: "intersects",
    value: function intersects(aabb) {
      if (this.count > 0) return aabb.intersects(this.looseBound);
      return false;
    }
  }, {
    key: "getRegion",
    value: function getRegion(aabb) {
      var index = 0;
      if (aabb.centerX > this.baseBound.centerX) index += 2;
      if (aabb.centerY > this.baseBound.centerY) index += 1;
      return index;
    }
  }, {
    key: "addElement",
    value: function addElement(element) {
      this.elements.push(element);
      if (this.elements.length == 1) this.looseBound.set(element.aabb);
      this.looseBound.merge(element.aabb);
    }
  }, {
    key: "recalcBound",
    value: function recalcBound() {
      if (this.children === null) {
        // leaf
        if (this.elementCount > 0) {
          this.looseBound.set(this.elements[0].aabb);

          for (var i = 1; i < this.elements.length; i++) {
            this.looseBound.merge(this.elements[i].aabb);
          }
        }
      } else {
        // branch
        for (var _i = 0; _i < 3; _i++) {
          this.children[_i].extendLooseBound(this.looseBound);
        }
      }
    }
  }, {
    key: "getElements",
    value: function getElements() {
      return this.elements;
    }
  }, {
    key: "removeElement",
    value: function removeElement(element) {
      for (var i = 0; i < this.elements.length; i++) {
        if (element === this.elements[i]) {
          this.elements.splice(i, 1);
          return true;
        }
      }

      return false;
    }
  }, {
    key: "clearElements",
    value: function clearElements() {
      this.elements.length = 0;
    }
  }, {
    key: "toString",
    value: function toString() {
      var indentNum = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var str = '';
      var indent = '';

      for (var i = 0; i < indentNum; i++) {
        indent += ' ';
      }

      str += indent + 'count: ' + this.count + '\n';
      str += indent + 'baseBound: ' + this.baseBound + '\n';
      str += indent + 'looseBound: ' + this.looseBound + '\n';

      if (this.children === null) {
        str += indent + 'element: \n';

        var _iterator = _createForOfIteratorHelper$1(this.elements),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var element = _step.value;
            str += indent + '  ' + element.aabb + ' data: ' + element.data + '\n';
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      } else {
        for (var _i2 = 0; _i2 < 4; _i2++) {
          str += indent + 'node' + _i2 + ':\n' + this.children[_i2].toString(indentNum + 2);
        }
      }

      return str;
    }
  }, {
    key: "toCanvasParameter",
    value: function toCanvasParameter(aabb) {
      return aabb.left + ', ' + aabb.bottom + ', ' + (aabb.right - aabb.left) + ', ' + (aabb.top - aabb.bottom);
    }
  }, {
    key: "toCanvasDraw",
    value: function toCanvasDraw() {
      var str = '';
      str += 'ctx.beginPath();';
      str += 'ctx.strokeStyle = "green";\n';
      str += 'ctx.rect(' + this.toCanvasParameter(this.baseBound) + ');\n';
      str += 'ctx.stroke();\n';

      if (this.count > 0) {
        str += 'ctx.beginPath();';
        str += 'ctx.strokeStyle = "blue";\n';
        str += 'ctx.rect(' + this.toCanvasParameter(this.looseBound) + ');\n';
        str += 'ctx.stroke();\n';
      }

      if (this.children === null) {
        str += 'ctx.beginPath();';
        str += 'ctx.strokeStyle = "red";\n';

        var _iterator2 = _createForOfIteratorHelper$1(this.elements),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var element = _step2.value;
            str += 'ctx.rect(' + this.toCanvasParameter(element.aabb) + ');\n';
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }

        str += 'ctx.stroke();\n';
      } else {
        for (var i = 0; i < 4; i++) {
          str += this.children[i].toCanvasDraw();
        }
      }

      return str;
    }
  }, {
    key: "elementCount",
    get: function get() {
      return this.elements.length;
    }
  }]);

  return LQTreeNode;
}();
/**
 * Loose QuadTree
 */


var LQTree = /*#__PURE__*/function () {
  // public for testing
  function LQTree(width, height) {
    var maxChildren = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 4;
    var maxLayer = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 10;

    classCallCheck(this, LQTree);

    defineProperty(this, "maxChildren", void 0);

    defineProperty(this, "maxLayer", void 0);

    defineProperty(this, "root", void 0);

    defineProperty(this, "idGenerator", void 0);

    defineProperty(this, "elementMap", void 0);

    this.root = new LQTreeNode(0, 0, width, height);
    this.elementMap = new Map();
    this.maxChildren = maxChildren;
    this.maxLayer = maxLayer;
    this.idGenerator = 1;
  }

  createClass(LQTree, [{
    key: "insert",
    value: function insert(aabb, data) {
      var element = new LQTreeElement(aabb, data);
      this.insertNode(this.root, element, 0);
      this.elementMap.set(this.idGenerator, element);
      this.idGenerator++;
      return this.idGenerator - 1;
    }
  }, {
    key: "insertNode",
    value: function insertNode(node, element, layer) {
      if (node.children === null) {
        node.addElement(element);
        if (node.elementCount > this.maxChildren && layer < this.maxLayer) this.split(node, layer + 1);
      } else {
        var index = node.getRegion(element.aabb);
        this.insertNode(node.children[index], element, layer + 1);
        node.looseBound.merge(element.aabb);
      }

      node.count++;
    }
  }, {
    key: "split",
    value: function split(node, layer) {
      node.children = [new LQTreeNode(node.baseBound.left, node.baseBound.bottom, node.baseBound.centerX, node.baseBound.centerY), new LQTreeNode(node.baseBound.left, node.baseBound.centerY, node.baseBound.centerX, node.baseBound.top), new LQTreeNode(node.baseBound.centerX, node.baseBound.bottom, node.baseBound.right, node.baseBound.centerY), new LQTreeNode(node.baseBound.centerX, node.baseBound.centerY, node.baseBound.right, node.baseBound.top)];

      var _iterator3 = _createForOfIteratorHelper$1(node.getElements()),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var element = _step3.value;
          var index = node.getRegion(element.aabb);
          node.children[index].addElement(element);
          node.children[index].count++;

          if (node.children[index].elementCount > this.maxChildren && layer < this.maxLayer) {
            this.split(node.children[index], layer + 1);
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      node.clearElements();
    }
  }, {
    key: "delete",
    value: function _delete(id) {
      var element = this.elementMap.get(id);

      if (element !== undefined) {
        if (this.deleteInNode(this.root, element)) {
          this.elementMap["delete"](id);
          return true;
        }

        return false;
      }

      return false;
    }
  }, {
    key: "deleteInNode",
    value: function deleteInNode(node, element) {
      if (node.children === null) {
        // leaf
        if (node.removeElement(element)) {
          node.count--;
          node.recalcBound();
          return true;
        }

        return false;
      } else {
        // branch
        var index = node.getRegion(element.aabb);
        var succeed = this.deleteInNode(node.children[index], element);

        if (succeed) {
          node.count--;
          if (node.count > 0) node.recalcBound();else {
            // no node in children, convert to leaf
            node.children = null;
          }
        }

        return succeed;
      }
    }
  }, {
    key: "getAll",
    value: function getAll(query, result) {
      this.searchNode(this.root, query, function (data) {
        result.push(data);
        return false;
      });
      return result;
    } // callBack if return true stop search

  }, {
    key: "search",
    value: function search(query, callBack) {
      this.searchNode(this.root, query, callBack);
    }
  }, {
    key: "searchNode",
    value: function searchNode(node, query, callBack) {
      if (node.children === null) {
        var _iterator4 = _createForOfIteratorHelper$1(node.getElements()),
            _step4;

        try {
          for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
            var element = _step4.value;

            if (query.intersects(element.aabb)) {
              if (callBack(element.data)) {
                return true;
              }
            }
          }
        } catch (err) {
          _iterator4.e(err);
        } finally {
          _iterator4.f();
        }
      } else {
        for (var i = 0; i < 4; i++) {
          if (node.children[i].intersects(query)) {
            var stop = this.searchNode(node.children[i], query, callBack);

            if (stop) {
              return true;
            }
          }
        }
      }

      return false;
    }
  }, {
    key: "toString",
    value: function toString() {
      return this.root.toString(0);
    }
  }, {
    key: "toCanvasDraw",
    value: function toCanvasDraw() {
      var str = '';
      str += 'const canvas = document.getElementById("canvas")\n';
      str += 'const ctx = canvas.getContext("2d");\n';
      return str + this.root.toCanvasDraw();
    }
  }]);

  return LQTree;
}();

/**
 * Determine whether a simple polygon is a convex polygon
 * @param points points buffer
 * @param base start index of the polygon on points
 * @param n end index of the polygon on points
 * @param tolerance tolerance
 * @param checkCounterClockwise whether to consider order of vertices.
 */

function isConvex(points) {
  var base = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var n = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : points.length - base;
  var tolerance = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0.00001;
  var checkCounterClockwise = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  if (n < 4 && !checkCounterClockwise) return true;
  var sign = undefined;
  if (points[base].x === points[n - 1].x && points[base].y === points[n - 1].y) // if its a closed polygon, ignore last vertex
    n--;

  for (var i = 0; i < n; i++) {
    var i1 = base + (i + 1) % n;
    var i2 = base + (i + 2) % n;
    var crossproduct = crossProduct3(points[i], points[i1], points[i2]);

    if (Math.abs(crossproduct) >= tolerance) {
      if (sign === undefined) sign = checkCounterClockwise ? true : crossproduct > 0;else if (sign != crossproduct > 0) {
        return false;
      }
    }
  }

  return true;
} // Returns a new array of points representing the convex hull of
// the given set of points. The convex hull excludes collinear points.
// This algorithm runs in O(n log n) time.

function makeHull(points) {
  var newPoints = points.slice();
  newPoints.sort(POINT_COMPARATOR);
  return makeHullPresorted(newPoints);
} // Returns the convex hull, assuming that each points[i] <= points[i + 1]. Runs in O(n) time.

function makeHullPresorted(points) {
  if (points.length <= 1) return points.slice(); // Andrew's monotone chain algorithm. Positive y coordinates correspond to "up"
  // as per the mathematical convention, instead of "down" as per the computer
  // graphics convention. This doesn't affect the correctness of the result.

  var upperHull = [];

  for (var i = 0; i < points.length; i++) {
    var p = points[i];

    while (upperHull.length >= 2) {
      var q = upperHull[upperHull.length - 1];
      var r = upperHull[upperHull.length - 2];
      if ((q.x - r.x) * (p.y - r.y) >= (q.y - r.y) * (p.x - r.x)) upperHull.pop();else break;
    }

    upperHull.push(p);
  }

  upperHull.pop();
  var lowerHull = [];

  for (var _i = points.length - 1; _i >= 0; _i--) {
    var _p = points[_i];

    while (lowerHull.length >= 2) {
      var _q = lowerHull[lowerHull.length - 1];
      var _r = lowerHull[lowerHull.length - 2];
      if ((_q.x - _r.x) * (_p.y - _r.y) >= (_q.y - _r.y) * (_p.x - _r.x)) lowerHull.pop();else break;
    }

    lowerHull.push(_p);
  }

  lowerHull.pop();
  if (upperHull.length == 1 && lowerHull.length == 1 && upperHull[0].x == lowerHull[0].x && upperHull[0].y == lowerHull[0].y) return upperHull;else return upperHull.concat(lowerHull);
}

function POINT_COMPARATOR(a, b) {
  if (a.x < b.x) return -1;else if (a.x > b.x) return +1;else if (a.y < b.y) return -1;else if (a.y > b.y) return +1;else return 0;
}

/**
 * Randomly generate convex polygon
 * https://cglab.ca/~sander/misc/ConvexGeneration/convex.html
 * @param  {Array} n the vertex num of polygon
 * @param  {Number} maxSize the maxSize of polygon
 * @return {Polygon} the random convex polygon
 */

function generateRandomConvexPolygon(n, maxSize) {
  if (maxSize === undefined) {
    maxSize = 1;
  }

  var xPool = [];
  var yPool = [];

  for (var i = 0; i < n; i++) {
    xPool.push(Math.random());
    yPool.push(Math.random());
  }

  xPool.sort();
  yPool.sort(); // Isolate the extreme points

  var minX = xPool[0];
  var maxX = xPool[n - 1];
  var minY = yPool[0];
  var maxY = yPool[n - 1]; // Divide the interior points into two chains & Extract the vector components

  var xVec = [];
  var yVec = [];
  var lastTop = minX,
      lastBot = minX;

  for (var _i = 1; _i < n - 1; _i++) {
    var _x = xPool[_i];

    if (Math.random() < 0.5) {
      xVec.push(_x - lastTop);
      lastTop = _x;
    } else {
      xVec.push(lastBot - _x);
      lastBot = _x;
    }
  }

  xVec.push(maxX - lastTop);
  xVec.push(lastBot - maxX);
  var lastLeft = minY,
      lastRight = minY;

  for (var _i2 = 1; _i2 < n - 1; _i2++) {
    var _y = yPool[_i2];

    if (Math.random() < 0.5) {
      yVec.push(_y - lastLeft);
      lastLeft = _y;
    } else {
      yVec.push(lastRight - _y);
      lastRight = _y;
    }
  }

  yVec.push(maxY - lastLeft);
  yVec.push(lastRight - maxY); // Randomly pair up the X- and Y-components

  shuffle(yVec); // Combine the paired up components into vectors

  var vec = [];

  for (var _i3 = 0; _i3 < n; _i3++) {
    vec.push(new Vector(xVec[_i3], yVec[_i3]));
  } // Sort the vectors by angle


  vec.sort(function (v1, v2) {
    return Math.atan2(v1.y, v1.x) - Math.atan2(v2.y, v2.x);
  }); // Lay them end-to-end

  var x = 0,
      y = 0;
  var minPolygonX = 0;
  var minPolygonY = 0;
  var points = [];

  for (var _i4 = 0; _i4 < n; _i4++) {
    points.push(new Vector(x, y));
    x += vec[_i4].x;
    y += vec[_i4].y;
    minPolygonX = Math.min(minPolygonX, x);
    minPolygonY = Math.min(minPolygonY, y);
  } // Move the polygon to the original min and max coordinates


  var xShift = minX - minPolygonX;
  var yShift = minY - minPolygonY;
  points.forEach(function (p) {
    p.x += xShift - 0.5;
    p.y += yShift - 0.5;
    p.x *= maxSize;
    p.y *= maxSize;
  });
  var polygon = new Polygon(new Vector(), points);
  var aabb = polygon.getAABB();
  polygon.translate(-aabb.centerX, -aabb.centerY);
  return polygon;
}

function _arrayLikeToArray$2(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

var arrayLikeToArray = _arrayLikeToArray$2;

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return arrayLikeToArray(arr);
}

var arrayWithoutHoles = _arrayWithoutHoles;

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

var iterableToArray = _iterableToArray;

function _unsupportedIterableToArray$2(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return arrayLikeToArray(o, minLen);
}

var unsupportedIterableToArray = _unsupportedIterableToArray$2;

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var nonIterableSpread = _nonIterableSpread;

function _toConsumableArray(arr) {
  return arrayWithoutHoles(arr) || iterableToArray(arr) || unsupportedIterableToArray(arr) || nonIterableSpread();
}

var toConsumableArray = _toConsumableArray;

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var assertThisInitialized = _assertThisInitialized;

var setPrototypeOf = createCommonjsModule(function (module) {
function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

module.exports = _setPrototypeOf;
});

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}

var inherits = _inherits;

var _typeof_1 = createCommonjsModule(function (module) {
function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    module.exports = _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    module.exports = _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

module.exports = _typeof;
});

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
    return call;
  }

  return assertThisInitialized(self);
}

var possibleConstructorReturn = _possibleConstructorReturn;

var getPrototypeOf = createCommonjsModule(function (module) {
function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

module.exports = _getPrototypeOf;
});

function _createForOfIteratorHelper$2(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$3(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray$3(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$3(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$3(o, minLen); }

function _arrayLikeToArray$3(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

(function (Orientation) {
  Orientation[Orientation["CCW"] = 1] = "CCW";
  Orientation[Orientation["CW"] = -1] = "CW";
  Orientation[Orientation["UNORDERED"] = 0] = "UNORDERED";
})(exports.Orientation || (exports.Orientation = {}));
/**
 * Polygon used in poly partition.
 * 1. It is a polygon.
 * 2. Can be either a normal polygon or a hole in outer polygon.
 * 3. Points are sorted in counter-clockwise order from it's center when it's a normal polygon, or clockwise if it's a hole.
 */

(function (UnionStatus) {
  UnionStatus[UnionStatus["isDead"] = 1] = "isDead";
  UnionStatus[UnionStatus["isActive"] = -1] = "isActive";
  UnionStatus[UnionStatus["isAlive"] = 0] = "isAlive";
})(exports.UnionStatus || (exports.UnionStatus = {}));

var PartitionPolygon = /*#__PURE__*/function (_Polygon) {
  inherits(PartitionPolygon, _Polygon);

  var _super = _createSuper(PartitionPolygon);

  function PartitionPolygon(pos, points) {
    var _this;

    var isHole = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    classCallCheck(this, PartitionPolygon);

    _this = _super.call(this, pos, points);

    defineProperty(assertThisInitialized(_this), "isHole", void 0);

    _this.isHole = isHole;

    _this.setOrientation(isHole ? exports.Orientation.CW : exports.Orientation.CCW);

    return _this;
  }

  createClass(PartitionPolygon, [{
    key: "getOrientation",
    value: function getOrientation() {
      var self = this;
      var area = 0;
      self.calcPoints.forEach(function (v, i) {
        var nexti = i === self.calcPoints.length - 1 ? 0 : i + 1;
        area += self.calcPoints[i].x * self.calcPoints[nexti].y - self.calcPoints[i].y * self.calcPoints[nexti].x;
      });
      if (area > 0) return exports.Orientation.CCW;
      if (area < 0) return exports.Orientation.CW;
      return exports.Orientation.UNORDERED;
    }
  }, {
    key: "setOrientation",
    value: function setOrientation(orientation) {
      var polyOrientation = this.getOrientation();

      if (polyOrientation && polyOrientation != orientation) {
        this.invert();
      }
    }
  }, {
    key: "invert",
    value: function invert() {
      this.points.reverse();
      this.recalc();
    }
  }, {
    key: "isValid",
    value: function isValid() {
      return this.calcPoints.length >= 3;
    }
  }]);

  return PartitionPolygon;
}(Polygon);
var UnionPolygon = /*#__PURE__*/function (_Polygon2) {
  inherits(UnionPolygon, _Polygon2);

  var _super2 = _createSuper(UnionPolygon);

  // used in partition union algorithm.
  // top left vertex
  function UnionPolygon(pos, points) {
    var _this2;

    classCallCheck(this, UnionPolygon);

    _this2 = _super2.call(this, pos, points);

    defineProperty(assertThisInitialized(_this2), "unionStatus", void 0);

    defineProperty(assertThisInitialized(_this2), "startingVertex", null);

    defineProperty(assertThisInitialized(_this2), "vertices", void 0);

    var minx, miny;
    _this2.vertices = [];

    _this2.calcPoints.forEach(function (p, i) {
      var newV = new PolyVertex(p.x, p.y);
      newV.parent = assertThisInitialized(_this2);
      newV.indexInPolygon = i;

      _this2.vertices.push(newV);

      if (_this2.startingVertex === null || newV.x < minx || newV.x === minx && newV.y < miny) {
        _this2.startingVertex = newV;
        minx = newV.x;
        miny = newV.y;
      }
    });

    _this2.vertices.forEach(function (v, i) {
      v.next = _this2.vertices[(i + 1) % _this2.vertices.length];
      v.normal = v.next.clone().sub(v).normalize();
      v.segmentLength = v.next.dist(v);
    });

    _this2.unionStatus = exports.UnionStatus.isAlive;
    return _this2;
  }

  return UnionPolygon;
}(Polygon); // Vertex in PartitionPolygon for Polygon Union. Since we don't consider holes, order is fixed as counter clockwise.
// So it also represents the segment starting from this Vertex.

var PolyVertex = /*#__PURE__*/function (_Vector) {
  inherits(PolyVertex, _Vector);

  var _super3 = _createSuper(PolyVertex);

  // The length of segment this vertex formed with next vertex.
  // Segments this segment intersects with.
  function PolyVertex() {
    var _this3;

    var x = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

    classCallCheck(this, PolyVertex);

    _this3 = _super3.call(this, x, y);

    defineProperty(assertThisInitialized(_this3), "segmentLength", 0.0);

    defineProperty(assertThisInitialized(_this3), "intersectingVertex", []);

    defineProperty(assertThisInitialized(_this3), "intersections", []);

    defineProperty(assertThisInitialized(_this3), "parent", null);

    defineProperty(assertThisInitialized(_this3), "next", null);

    defineProperty(assertThisInitialized(_this3), "normal", null);

    defineProperty(assertThisInitialized(_this3), "indexInPolygon", 0);

    return _this3;
  }

  return PolyVertex;
}(Vector);
function preprocessIntersection(polys) {
  /*let tree = new LQTree(8000, 8000);
  for (let p1 = 0; p1 < polys.length; p1++) {
      tree.insert(polys[p1].getAABB(), p1);
  }*/
  for (var p1 = 0; p1 < polys.length; p1++) {
    var _loop = function _loop(p2) {
      if (p1 === p2) return "continue";
      polys[p1].vertices.forEach(function (p1v) {
        polys[p2].vertices.forEach(function (p2v) {
          var intersection = intersectingVertex(p1v, p1v.next, p2v, p2v.next);

          if (intersection !== null) {
            p1v.intersectingVertex.push(p2v); //p2v.intersectingVertex.push(p1v);

            p1v.intersections.push(intersection); //p2v.intersections.push(intersectingVertex(p2v, p2v.next!, p1v, p1v.next!)!);
          }
        });
      });

      if (polys[p1].startingVertex !== null && polys[p2].startingVertex !== null && polys[p2].isPointIn(polys[p1].startingVertex)) {
        polys[p1].startingVertex = null;
      }
    };

    for (var p2 = 0; p2 < polys.length; p2++) {
      var _ret = _loop(p2);

      if (_ret === "continue") continue;
    }
  }
}
function unionPolygons(polys) {
  preprocessIntersection(polys);
  console.log("preprocess ok");
  var polysLeft = polys.length;
  var res = [];

  while (polysLeft > 0) {
    var start = null;

    for (var i = polysLeft - 1; i >= 0; i--) {
      if (polys[i].unionStatus !== exports.UnionStatus.isAlive) {
        polys[i].unionStatus = exports.UnionStatus.isDead;
        polys.splice(i, 1);
        polysLeft--;
        continue;
      }

      if (polys[i].startingVertex === null) continue;
      var polyStart = polys[i].startingVertex;

      if (start === null || polyStart.x < start.x || polyStart.x === start.x && polyStart.y < start.y || polyStart.x === start.x && polyStart.y === start.y && polyStart.segmentLength > start.segmentLength) {
        start = polyStart;
      }
    }

    if (start === null) return res; // Start

    var curr = start,
        onSeg = start,
        points = [new Vector(curr.x, curr.y)];

    while (!curr.equalsTo(start) || points.length === 1) {
      var next = onSeg.next,
          nextSeg = onSeg.next;

      for (var _i = 0; _i < onSeg.intersections.length; _i++) {
        // Cases we should filter out
        var iSeg = onSeg.intersectingVertex[_i];
        var iInt = onSeg.intersections[_i];

        if (iSeg.parent.unionStatus === exports.UnionStatus.isDead || // Intersection before curr
        iInt.dist(onSeg) < curr.dist(onSeg) || // Go inward and not end.
        !iInt.equalsTo(onSeg.next) && onSeg.normal.angleTo(iSeg.normal) > 0 || // End on intersection
        iInt.equalsTo(iSeg.next) || // Same direction but shorter
        iSeg.normal.equalsTo(onSeg.normal) && iSeg.next.dist(onSeg) <= onSeg.segmentLength || // Reverse direction
        iSeg.normal.equalsTo(onSeg.normal.clone().reverse())) {
          // console.log("from seg ", onSeg.toString(), " norm ", onSeg.normal!.toString(),
          //     " skipped seg ", iSeg.toString(), " norm ", iSeg.normal!.toString(), " on ", iInt);
          continue;
        }

        if (iInt.dist(curr) < next.dist(curr) || iInt.dist(curr) === next.dist(curr) && onSeg.normal.angleTo(iSeg.normal) < onSeg.normal.angleTo(nextSeg.normal) || iInt.dist(curr) === next.dist(curr) && onSeg.normal.angleTo(iSeg.normal) === onSeg.normal.angleTo(nextSeg.normal) && iSeg.segmentLength > nextSeg.segmentLength) {
          next = iInt;
          nextSeg = iSeg;
        }
      }

      if (!nextSeg.normal.equalsTo(onSeg.normal) && !next.equalsTo(start)) {
        points.push(new Vector(next.x, next.y)); // console.log("from seg ", onSeg.toString(), " norm ", onSeg.normal!.toString(),
        //     " to seg ", nextSeg.toString(), " norm ", nextSeg.normal!.toString(), " adding ", points[points.length-1]);
      }

      curr = next;
      onSeg = nextSeg; // console.log("length ", points.length, " point: ", points[points.length-1]);
      //console.log("curr ", curr.toString(), " onSeg: ", onSeg.toString());

      onSeg.parent.unionStatus = exports.UnionStatus.isActive;
    }

    res.push(points);
  }

  return res;
}
var PartitionVertex = function PartitionVertex() {
  classCallCheck(this, PartitionVertex);

  defineProperty(this, "isActive", void 0);

  defineProperty(this, "isConvex", void 0);

  defineProperty(this, "isEar", void 0);

  defineProperty(this, "p", void 0);

  defineProperty(this, "angle", void 0);

  defineProperty(this, "prev", void 0);

  defineProperty(this, "next", void 0);

  this.isActive = false;
  this.isConvex = false;
  this.isEar = false;
  this.p = new Vector();
  this.angle = 0.0;
  this.prev = null;
  this.next = null;
};
function inCone(p1, p2, p3, p) {
  var convex = isConvexAndNotHole([p1, p2, p3]);

  if (convex) {
    if (!isConvexAndNotHole([p1, p2, p])) return false;
    if (!isConvexAndNotHole([p2, p3, p])) return false;
    return true;
  } else {
    if (isConvexAndNotHole([p1, p2, p])) return true;
    if (isConvexAndNotHole([p2, p3, p])) return true;
    return false;
  }
} //checks if two lines intersect.

function intersects(p11, p12, p21, p22) {
  if (p11.x == p21.x && p11.y == p21.y) return false;
  if (p11.x == p22.x && p11.y == p22.y) return false;
  if (p12.x == p21.x && p12.y == p21.y) return false;
  if (p12.x == p22.x && p12.y == p22.y) return false;
  var v1ort = new Vector();
  var v2ort = new Vector();
  var v = new Vector();
  v1ort.x = p12.y - p11.y;
  v1ort.y = p11.x - p12.x;
  v2ort.x = p22.y - p21.y;
  v2ort.y = p21.x - p22.x;
  v = p21.clone().sub(p11);
  var dot21 = v.x * v1ort.x + v.y * v1ort.y;
  v = p22.clone().sub(p11);
  var dot22 = v.x * v1ort.x + v.y * v1ort.y;
  v = p11.clone().sub(p21);
  var dot11 = v.x * v2ort.x + v.y * v2ort.y;
  v = p12.clone().sub(p21);
  var dot12 = v.x * v2ort.x + v.y * v2ort.y;
  if (dot11 * dot12 > 0) return false;
  if (dot21 * dot22 > 0) return false;
  return true;
}
/**
 * Remove holes from a list of PartitionPolygon.
 * Creates a diagonal from the rightmost hole vertex to some visible vertex.
 * Time complexity: O(h*(n^2)), h is the number of holes, n is the number of vertices.
 * space complexity: O(n)
 * @param {Array} inpolys a list of polygons that can contain holes
 *  vertices of all non-hole polys have to be in counter-clockwise order
 *  vertices of all hole polys have to be in clockwise order
 * @return {boolean} if removing is successful.
 */

function removeHoles(polys) {
  var hasHoles = false;

  var _iterator = _createForOfIteratorHelper$2(polys),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var _poly = _step.value;

      if (_poly.isHole) {
        hasHoles = true;
        break;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  if (!hasHoles) {
    return true;
  }

  var holeIndex = 0;
  var holePointIndex = 0;
  var holePoint;
  var polyPoint;
  var bestPolyPoint = new Vector();
  var pointVisible = false;
  var polyIndex = 0;
  var polyPointIndex = 0;

  while (1) {
    //find the hole point with the largest x
    hasHoles = false;

    var _loop2 = function _loop2(_polyIndex) {
      var poly = polys[_polyIndex];
      if (!poly.isHole) return "continue";

      if (!hasHoles) {
        hasHoles = true;
        holeIndex = _polyIndex;
        holePointIndex = 0;
      }

      poly.calcPoints.forEach(function (point, index) {
        if (point.x > polys[holeIndex].calcPoints[holePointIndex].x) {
          holeIndex = _polyIndex;
          holePointIndex = index;
        }
      });
    };

    for (var _polyIndex = 0; _polyIndex < polys.length; _polyIndex++) {
      var _ret2 = _loop2(_polyIndex);

      if (_ret2 === "continue") continue;
    }

    if (!hasHoles) break;
    holePoint = polys[holeIndex].calcPoints[holePointIndex];
    var pointFound = false;

    for (var index = 0; index < polys.length; index++) {
      var poly = polys[index];
      if (poly.isHole) continue; // If candidate point in cone of previous, this, next.

      for (var pointIndex = 0; pointIndex < poly.calcPoints.length; pointIndex++) {
        var point = poly.calcPoints[pointIndex]; //if (index === 2 && (pointIndex ===7 || pointIndex ===8)) console.log(point);

        if (point.x <= holePoint.x) continue; //if (index === 2 && (pointIndex ===7 || pointIndex ===8)) console.log(holePoint.x);
        // if (index === 2 && (pointIndex ===7 || pointIndex ===8)) {
        //     console.log(poly.calcPoints[(pointIndex + poly.calcPoints.length - 1) % poly.calcPoints.length]);
        //     console.log(point);
        //     console.log(poly.calcPoints[(pointIndex + 1) % poly.calcPoints.length]);
        //     console.log(holePoint);
        // }

        if (!inCone(poly.calcPoints[(pointIndex + poly.calcPoints.length - 1) % poly.calcPoints.length], point, poly.calcPoints[(pointIndex + 1) % poly.calcPoints.length], holePoint)) continue; //if (index === 2 && (pointIndex ===7 || pointIndex ===8)) console.log(pointIndex, "incone");

        polyPoint = point;

        if (pointFound) {
          // if (index === 2 && (pointIndex ===7 || pointIndex ===8)) {
          //     console.log("polypoint", polyPoint);
          //     console.log("bestPolyPoint", bestPolyPoint);
          //     console.log("holePoint", holePoint);
          // }
          var v1 = polyPoint.clone().sub(holePoint).normalize();
          var v2 = bestPolyPoint.clone().sub(holePoint).normalize();
          if (v2.x > v1.x) continue;
        } //if (index === 2 && (pointIndex ===7 || pointIndex ===8)) console.log("found");


        pointVisible = true;

        var _iterator2 = _createForOfIteratorHelper$2(polys),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var poly2 = _step2.value;
            if (poly2.isHole) continue;

            for (var pointIndex2 = 0; pointIndex2 < poly2.calcPoints.length; pointIndex2++) {
              var lineP1 = poly2.calcPoints[pointIndex2];
              var lineP2 = poly2.calcPoints[(pointIndex2 + 1) % poly2.calcPoints.length];

              if (intersects(holePoint, polyPoint, lineP1, lineP2)) {
                pointVisible = false;
                break;
              }
            }

            if (!pointVisible) break;
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }

        if (pointVisible) {
          pointFound = true;
          bestPolyPoint = polyPoint;
          polyIndex = index;
          polyPointIndex = pointIndex;
        }
      }
    }

    if (!pointFound) return false; // Number of points = points of hole + points of poly + 2

    var points = []; // console.log(polyIndex, polyPointIndex);
    // console.log(holeIndex, holePointIndex);

    for (var i = 0; i <= polyPointIndex; i++) {
      points.push(polys[polyIndex].calcPoints[i]);
    }

    for (var _i2 = 0; _i2 <= polys[holeIndex].calcPoints.length; _i2++) {
      points.push(polys[holeIndex].calcPoints[(_i2 + holePointIndex) % polys[holeIndex].calcPoints.length]);
    }

    for (var _i3 = polyPointIndex; _i3 < polys[polyIndex].calcPoints.length; _i3++) {
      points.push(polys[polyIndex].calcPoints[_i3]);
    }

    polys.splice(Math.max(polyIndex, holeIndex), 1);
    polys.splice(Math.min(polyIndex, holeIndex), 1);
    polys.push(new PartitionPolygon(new Vector(), points)); //console.log("pushed ", polys.push(new PartitionPolygon(new Vector(), points)), " length of ", polys[polys.length-1].calcPoints.length);
  }

  return true;
}

function isReflex(p1, p2, p3) {
  var tmp = (p3.y - p1.y) * (p2.x - p1.x) - (p3.x - p1.x) * (p2.y - p1.y);
  if (tmp < 0) return 1;else return 0;
}

function isInside(p1, p2, p3, p) {
  if (isConvexAndNotHole([p1, p, p2])) return false;
  if (isConvexAndNotHole([p2, p, p3])) return false;
  if (isConvexAndNotHole([p3, p, p1])) return false;
  return true;
}

function updateVertex(vertices, v) {
  var v1 = v.prev,
      v3 = v.next;
  v.isConvex = isConvexAndNotHole([v1.p, v.p, v3.p]);
  var vec1 = v1.p.clone().sub(v.p).normalize();
  var vec3 = v3.p.clone().sub(v.p).normalize();
  v.angle = vec1.x * vec3.x + vec1.y * vec3.y;

  if (v.isConvex) {
    v.isEar = true;

    for (var i = 0; i < vertices.length; i++) {
      if (vertices[i].p.x === v.p.x && vertices[i].p.y === v.p.y) continue;
      if (vertices[i].p.x === v1.p.x && vertices[i].p.y === v1.p.y) continue;
      if (vertices[i].p.x === v3.p.x && vertices[i].p.y === v3.p.y) continue;

      if (isInside(v1.p, v.p, v3.p, vertices[i].p)) {
        v.isEar = false;
        break;
      }
    }
  } else {
    v.isEar = false;
  }
}
/**
 * Triangulates a polygon by ear clipping
 * Time complexity: O(n^2), n is the number of vertices
 * space complexity: O(n)
 * @param {PartitionPolygon} poly an input polygon to be triangulated
 *  vertices have to be in counter-clockwise order
 * @return {Array} an array of triangles or empty array when failed
 */


function triangulateEC(poly) {
  if (!poly.isValid()) return [];
  var triangles = [];

  if (poly.calcPoints.length === 3) {
    return [new PartitionPolygon(new Vector(), poly.calcPoints)];
  } //let vertices = Array(poly.calcPoints.length).fill(new PartitionVertex());


  var vertices = [];

  for (var i = 0; i < poly.calcPoints.length; i++) {
    vertices.push(new PartitionVertex());
  }

  for (var _i4 = 0; _i4 < poly.calcPoints.length; _i4++) {
    vertices[_i4].isActive = true;
    vertices[_i4].p = poly.calcPoints[_i4];
    vertices[_i4].next = vertices[(_i4 + 1) % poly.calcPoints.length];
    vertices[_i4].prev = vertices[(_i4 - 1 + poly.calcPoints.length) % poly.calcPoints.length];
  }

  for (var _i5 = 0; _i5 < poly.calcPoints.length; _i5++) {
    updateVertex(vertices, vertices[_i5]);
  }

  var earIndex = 0;

  for (var _i6 = 0; _i6 < poly.calcPoints.length - 3; _i6++) {
    var earFound = false; //find the most extruded ear

    for (var j = 0; j < poly.calcPoints.length; j++) {
      if (!vertices[j].isActive) continue;
      if (!vertices[j].isEar) continue;

      if (!earFound) {
        earFound = true;
        earIndex = j;
      } else {
        if (vertices[j].angle > vertices[earIndex].angle) {
          earIndex = j;
        }
      }
    }

    if (!earFound) {
      return [];
    }

    triangles.push(new PartitionPolygon(new Vector(), [vertices[earIndex].prev.p, vertices[earIndex].p, vertices[earIndex].next.p]));
    vertices[earIndex].isActive = false;
    vertices[earIndex].prev.next = vertices[earIndex].next;
    vertices[earIndex].next.prev = vertices[earIndex].prev;
    if (_i6 == poly.calcPoints.length - 4) break;
    updateVertex(vertices, vertices[earIndex].prev);
    updateVertex(vertices, vertices[earIndex].next);
  }

  for (var _i7 = 0; _i7 < poly.calcPoints.length; _i7++) {
    if (vertices[_i7].isActive) {
      triangles.push(new PartitionPolygon(new Vector(), [vertices[_i7].prev.p, vertices[_i7].p, vertices[_i7].next.p]));
      break;
    }
  }

  return triangles;
}

function isConvexAndNotHole(points) {
  return isConvex(points, 0, points.length, 0, true);
}
/**
 * Partitions a polygon into convex polygons by using Hertel-Mehlhorn algorithm
 * The algorithm gives at most four times the number of parts as the optimal algorithm.
 * However, in practice it works much better than that and often gives optimal partition.
 * Uses triangulation obtained by ear clipping as intermediate result
 * Time complexity O(n^2), n is the number of vertices
 * space complexity: O(n)
 * @param {PartitionPolygon} poly an input polygon to be partitioned
 *  vertices have to be in counter-clockwise order
 * @return {Array} an array convex polygons or empty array when failed
 */


function convexPartitionHM(poly) {
  if (!poly.isValid()) return [];
  var parts = []; //check if the poly is already convex

  var numreflex = 0,
      i11 = 0,
      i12 = 0,
      i21 = 0,
      i22 = 0,
      i13 = 0,
      i23 = 0,
      i = 0,
      j = 0,
      k = 0,
      l = 0;

  for (i11 = 0; i11 < poly.calcPoints.length; i11++) {
    if (i11 == 0) i12 = poly.calcPoints.length - 1;else i12 = i11 - 1;
    if (i11 === poly.calcPoints.length - 1) i13 = 0;else i13 = i11 + 1;

    if (isReflex(poly.calcPoints[i12], poly.calcPoints[i11], poly.calcPoints[i13])) {
      numreflex = 1;
      break;
    }
  }

  if (numreflex == 0) {
    parts.push(new PartitionPolygon(new Vector(), poly.calcPoints));
    return parts;
  }

  var triangles = triangulateEC(poly);
  if (triangles.length === 0) return triangles;

  for (i = 0; i < triangles.length; i++) {
    var poly1 = triangles[i];

    for (i11 = 0; i11 < poly1.calcPoints.length; i11++) {
      var d1 = poly1.calcPoints[i11];
      i12 = (i11 + 1) % poly1.calcPoints.length;
      var d2 = poly1.calcPoints[i12];
      var isDiagonal = false;
      var poly2 = triangles[i];

      for (j = i; j < triangles.length; j++) {
        if (i == j) continue;
        poly2 = triangles[j];

        for (i21 = 0; i21 < poly2.calcPoints.length; i21++) {
          if (d2.x !== poly2.calcPoints[i21].x || d2.y !== poly2.calcPoints[i21].y) continue;
          i22 = (i21 + 1) % poly2.calcPoints.length;
          if (d1.x !== poly2.calcPoints[i22].x || d1.y !== poly2.calcPoints[i22].y) continue;
          isDiagonal = true;
          break;
        }

        if (isDiagonal) break;
      }

      if (!isDiagonal) continue;
      var p2 = poly1.calcPoints[i11];
      if (i11 == 0) i13 = poly1.calcPoints.length - 1;else i13 = i11 - 1;
      var p1 = poly1.calcPoints[i13];
      if (i22 == poly2.calcPoints.length - 1) i23 = 0;else i23 = i22 + 1;
      var p3 = poly2.calcPoints[i23];
      if (!isConvexAndNotHole([p1, p2, p3])) continue;
      p2 = poly1.calcPoints[i12];
      if (i12 == poly1.calcPoints.length - 1) i13 = 0;else i13 = i12 + 1;
      p3 = poly1.calcPoints[i13];
      if (i21 == 0) i23 = poly2.calcPoints.length - 1;else i23 = i21 - 1;
      p1 = poly2.calcPoints[i23];
      if (!isConvexAndNotHole([p1, p2, p3])) continue;
      var newPolyPoints = [];
      k = 0;

      for (l = i12; l != i11; l = (l + 1) % poly1.calcPoints.length) {
        newPolyPoints[k] = poly1.calcPoints[l];
        k++;
      }

      for (l = i22; l != i21; l = (l + 1) % poly2.calcPoints.length) {
        newPolyPoints[k] = poly2.calcPoints[l];
        k++;
      }

      triangles.splice(j, 1);
      triangles[i] = new PartitionPolygon(new Vector(), newPolyPoints);
      poly1 = triangles[i];
      i11 = -1;
      continue;
    }
  }

  var _iterator3 = _createForOfIteratorHelper$2(triangles),
      _step3;

  try {
    for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
      var part = _step3.value;
      parts.push(part);
    }
  } catch (err) {
    _iterator3.e(err);
  } finally {
    _iterator3.f();
  }

  return parts;
}
/**
 * Partitions a polygon into convex polygons by using Hertel-Mehlhorn algorithm
 * The algorithm gives at most four times the number of parts as the optimal algorithm.
 * However, in practice it works much better than that and often gives optimal partition.
 * Uses triangulation obtained by ear clipping as intermediate result
 * Time complexity O(n^2), n is the number of vertices
 * space complexity: O(n)
 * @param {PartitionPolygon} inpolys a list of polygons to be partitioned
 *  vertices of all non-hole polys have to be in counter-clockwise order
 *  vertices of all hole polys have to be in clockwise order
 * @return {Array} an array convex polygons or empty array when failed
 */

function convexPartitionHMList(inpolys) {
  var outPolys = [];
  if (!removeHoles(inpolys)) return [];

  var _iterator4 = _createForOfIteratorHelper$2(inpolys),
      _step4;

  try {
    for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
      var poly = _step4.value;
      var polyResult = convexPartitionHM(poly);
      if (polyResult.length === 0) return [];
      outPolys.push.apply(outPolys, toConsumableArray(polyResult));
    }
  } catch (err) {
    _iterator4.e(err);
  } finally {
    _iterator4.f();
  }

  return outPolys;
}
/**
 * Triangulates a list of polygons that may contain holes by ear clipping algorithm
 * first calls RemoveHoles to get rid of the holes, and then Triangulate_EC for each resulting polygon
 * Time complexity: O(h*(n^2)), h is the number of holes, n is the number of vertices
 * Space complexity: O(n)
 * @param {PartitionPolygon} inpolys a list of polygons to be partitioned
 *  vertices of all non-hole polys have to be in counter-clockwise order
 *  vertices of all hole polys have to be in clockwise order
 * @return {Array} an array triangles or empty array when failed
 */

function triangulateECList(inpolys) {
  var outPolys = [];
  if (!removeHoles(inpolys)) return [];

  var _iterator5 = _createForOfIteratorHelper$2(inpolys),
      _step5;

  try {
    for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
      var poly = _step5.value;
      var polyResult = triangulateEC(poly);
      if (polyResult.length === 0) return [];
      outPolys.push.apply(outPolys, toConsumableArray(polyResult));
    }
  } catch (err) {
    _iterator5.e(err);
  } finally {
    _iterator5.f();
  }

  return outPolys;
}
/**
 * Offset Polygon by offsetting edges without rounding. Assuming old_points is counter-clockwise. Shrink by 'offset' if otherwise.
 * @param {Array} old_points a list of points
 * @param {number} offset distance to edges
 * @return {Array} an array of points of resulting Polygon.
 */

function getEnlargedPolygon(old_points, offset) {
  var enlarged_points = [];
  var num_points = old_points.length;

  for (var j = 0; j < num_points; j++) {
    // Find the new location for point j.
    // Find the points before and after j.
    var i = j - 1;
    if (i < 0) i += num_points;
    var k = (j + 1) % num_points; // Move the points by the offset.

    var v1 = new Vector(old_points[j].x - old_points[i].x, old_points[j].y - old_points[i].y);
    v1.normalize();
    v1.scl(-offset);
    var n1 = new Vector(-v1.y, v1.x);
    var pij1 = new Vector(old_points[i].x + n1.x, old_points[i].y + n1.y);
    var pij2 = new Vector(old_points[j].x + n1.x, old_points[j].y + n1.y);
    var v2 = new Vector(old_points[k].x - old_points[j].x, old_points[k].y - old_points[j].y);
    v2.normalize();
    v2.scl(-offset);
    var n2 = new Vector(-v2.y, v2.x);
    var pjk1 = new Vector(old_points[j].x + n2.x, old_points[j].y + n2.y);
    var pjk2 = new Vector(old_points[k].x + n2.x, old_points[k].y + n2.y);
    var mid = old_points[i].clone().sub(old_points[j]).normalize().add(old_points[k].clone().sub(old_points[j]).normalize()).normalize();
    var rev_mid = mid.clone().scl(-offset).add(old_points[j]);
    var p = mid.clone().perp().add(rev_mid);
    enlarged_points.push(lineLineIntersection(pij1, pij2, rev_mid, p));
    enlarged_points.push(lineLineIntersection(rev_mid, p, pjk1, pjk2));
  }

  return enlarged_points;
} // export function getEnlargedPolygon2(old_points: Array<Vector>, offset: number) : Array<Vector>{
//
//     let enlarged_points = [];
//     const num_points = old_points.length;
//     for (let j = 0; j < num_points; j++) {
//         // Find the new location for point j.
//         // Find the points before and after j.
//         let i = (j - 1);
//         if (i < 0) i += num_points;
//         let k = (j + 1) % num_points;
//
//         // Move the points by the offset.
//         let v1 = new Vector(
//             old_points[j].x - old_points[i].x,
//             old_points[j].y - old_points[i].y);
//         v1.normalize();
//         v1.scl(-offset);
//         let n1 = new Vector(-v1.y, v1.x);
//
//         let pij1 = new Vector(
//             old_points[i].x + n1.x,
//             old_points[i].y + n1.y);
//         let pij2 = new Vector(
//             old_points[j].x + n1.x,
//             old_points[j].y + n1.y);
//
//         let v2 = new Vector(
//             old_points[k].x - old_points[j].x,
//             old_points[k].y - old_points[j].y);
//         v2.normalize();
//         v2.scl(-offset);
//         let n2 = new Vector(-v2.y, v2.x);
//
//         let pjk1 = new Vector(
//             old_points[j].x + n2.x,
//             old_points[j].y + n2.y);
//         let pjk2 = new Vector(
//             old_points[k].x + n2.x,
//             old_points[k].y + n2.y);
//
//         enlarged_points.push(lineIntersection(pij1, pij2, pjk1, pjk2));
//     }
//
//     return enlarged_points;
// }

function _createForOfIteratorHelper$3(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$4(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray$4(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$4(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$4(o, minLen); }

function _arrayLikeToArray$4(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function applyImpulse(material, state, impulse, contactVector) {
  state.velocity.addMul(impulse, material.invMass);
  state.angularVelocity += material.invInertia * contactVector.cross(impulse);
} // https://gamedevelopment.tutsplus.com/tutorials/how-to-create-a-custom-2d-physics-engine-the-basics-and-impulse-resolution--gamedev-6331

function resolveContact(aMat, aState, bMat, bState, result) {
  var rv = new Vector();
  var impulse = new Vector();
  var e = Math.min(aMat.restitution, bMat.restitution); // Calculate static and dynamic friction

  var sf = Math.sqrt(aMat.staticFriction * bMat.staticFriction);
  var df = Math.sqrt(aMat.dynamicFriction * bMat.dynamicFriction);
  var aStateVelocity = aState.velocity.clone();
  var bStateVelocity = bState.velocity.clone();
  var aStateAngularVelocity = aState.angularVelocity;
  var bStateAngularVelocity = bState.angularVelocity;

  var _iterator = _createForOfIteratorHelper$3(result.contacts),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var contact = _step.value;
      // Calculate radii from COM to contact
      var ra = contact.clone().sub(aState.position);
      var rb = contact.clone().sub(bState.position); // Relative velocity

      rv.set(bStateVelocity).addMul(rb, bStateAngularVelocity).sub(aStateVelocity).subMul(ra, aStateAngularVelocity); // Relative velocity along the normal

      var contactVel = rv.dot(result.normal); // Do not resolve if velocities are separating

      if (contactVel > 0) continue;
      var raCrossN = ra.cross(result.normal);
      var rbCrossN = rb.cross(result.normal);
      var invMassSum = aMat.invMass + bMat.invMass + raCrossN * raCrossN * aMat.invInertia + rbCrossN * rbCrossN * bMat.invInertia; // Calculate impulse scalar

      var j = -(1.0 + e) * contactVel;
      j /= invMassSum;
      j /= result.contacts.length; // apply impulse

      impulse.set(result.normal).scl(j);
      applyImpulse(bMat, bState, impulse, rb);
      applyImpulse(aMat, aState, impulse.reverse(), ra); // Friction impulse

      rv.set(bStateVelocity).addMul(rb, bStateAngularVelocity).sub(aStateVelocity).subMul(ra, aStateAngularVelocity);
      var t = rv.clone().subMul(result.normal, rv.dot(result.normal));
      t.normalize(); // j tangent magnitude

      var jt = -rv.dot(t);
      jt /= invMassSum;
      jt /= result.contacts.length; // Don't apply tiny friction impulses

      if (Comparator.EQ(jt, 0.0)) continue; // Coulumb's law tangent impulse

      if (Math.abs(jt) < j * sf) impulse.set(t).scl(jt);else impulse.set(t).scl(-j * df); // aMatpply friction impulse

      applyImpulse(bMat, bState, impulse, rb);
      applyImpulse(aMat, aState, impulse.reverse(), ra);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
} // https://gamedevelopment.tutsplus.com/tutorials/how-to-create-a-custom-2d-physics-engine-the-basics-and-impulse-resolution--gamedev-6331

function positionalCorrection(aMat, bMat, result) {
  var percent = 0.2; // usually 20% to 80%

  var slop = 0.01; // usually 0.01 to 0.1

  var correction = result.normal.clone();
  correction.scl(Math.max(result.depth - slop, 0.0) / (aMat.invMass + bMat.invMass) * percent);
  aMat.position.subMul(correction, aMat.invMass);
  bMat.position.addMul(correction, bMat.invMass);
}

var BinaryHeap = /*#__PURE__*/function () {
  function BinaryHeap(scoreFunction) {
    classCallCheck(this, BinaryHeap);

    defineProperty(this, "content", void 0);

    defineProperty(this, "scoreFunction", void 0);

    this.content = [];
    this.scoreFunction = scoreFunction;
  }

  createClass(BinaryHeap, [{
    key: "push",
    value: function push(element) {
      // Add the new element to the end of the array.
      this.content.push(element); // Allow it to sink down.

      this.sinkDown(this.content.length - 1);
    }
  }, {
    key: "pop",
    value: function pop() {
      // Store the first element so we can return it later.
      var result = this.content[0]; // Get the element at the end of the array.

      var end = this.content.pop();
      if (!end) throw new Error('Heap pop empty'); // If there are any elements left, put the end element at the
      // start, and let it bubble up.

      if (this.content.length > 0) {
        this.content[0] = end;
        this.bubbleUp(0);
      }

      return result;
    }
  }, {
    key: "remove",
    value: function remove(node) {
      var i = this.content.indexOf(node); // When it is found, the process seen in 'pop' is repeated
      // to fill up the hole.

      var end = this.content.pop();
      if (!end) throw new Error('Heap pop empty');

      if (i !== this.content.length - 1) {
        this.content[i] = end;

        if (this.scoreFunction(end) < this.scoreFunction(node)) {
          this.sinkDown(i);
        } else {
          this.bubbleUp(i);
        }
      }
    }
  }, {
    key: "size",
    value: function size() {
      return this.content.length;
    }
  }, {
    key: "rescoreElement",
    value: function rescoreElement(node) {
      this.sinkDown(this.content.indexOf(node));
    }
  }, {
    key: "sinkDown",
    value: function sinkDown(n) {
      // Fetch the element that has to be sunk.
      var element = this.content[n]; // When at 0, an element can not sink any further.

      while (n > 0) {
        // Compute the parent element's index, and fetch it.
        var parentN = (n + 1 >> 1) - 1;
        var parent = this.content[parentN]; // Swap the elements if the parent is greater.

        if (this.scoreFunction(element) < this.scoreFunction(parent)) {
          this.content[parentN] = element;
          this.content[n] = parent; // Update 'n' to continue at the new position.

          n = parentN;
        } // Found a parent that is less, no need to sink any further.
        else {
            break;
          }
      }
    }
  }, {
    key: "bubbleUp",
    value: function bubbleUp(n) {
      // Look up the target element and its score.
      var length = this.content.length;
      var element = this.content[n];
      var elemScore = this.scoreFunction(element);

      while (true) {
        // Compute the indices of the child elements.
        var child2N = n + 1 << 1;
        var child1N = child2N - 1; // This is used to store the new position of the element, if any.

        var swap = null;
        var child1Score = void 0; // If the first child exists (is inside the array)...

        if (child1N < length) {
          // Look it up and compute its score.
          var child1 = this.content[child1N];
          child1Score = this.scoreFunction(child1); // If the score is less than our element's, we need to swap.

          if (child1Score < elemScore) {
            swap = child1N;
          }
        } // Do the same checks for the other child.


        if (child2N < length) {
          var child2 = this.content[child2N];
          var child2Score = this.scoreFunction(child2); // @ts-ignore

          if (child2Score < (swap === null ? elemScore : child1Score)) {
            swap = child2N;
          }
        } // If the element needs to be moved, swap it, and continue.


        if (swap !== null) {
          this.content[n] = this.content[swap];
          this.content[swap] = element;
          n = swap;
        } // Otherwise, we are done.
        else {
            break;
          }
      }
    }
  }]);

  return BinaryHeap;
}();

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

var arrayWithHoles = _arrayWithHoles;

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

var iterableToArrayLimit = _iterableToArrayLimit;

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var nonIterableRest = _nonIterableRest;

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || unsupportedIterableToArray(arr, i) || nonIterableRest();
}

var slicedToArray = _slicedToArray;

function _createForOfIteratorHelper$4(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$5(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray$5(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$5(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$5(o, minLen); }

function _arrayLikeToArray$5(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
var NavPoly = /*#__PURE__*/function () {
  /**
   * Creates an instance of NavPoly.
   * @param {number} id
   * @param {Polygon} polygon
   *
   * @memberof NavPoly
   */
  function NavPoly(id, polygon) {
    classCallCheck(this, NavPoly);

    defineProperty(this, "id", void 0);

    defineProperty(this, "polygon", void 0);

    defineProperty(this, "boundingRadius", void 0);

    defineProperty(this, "centroid", void 0);

    defineProperty(this, "connected", void 0);

    defineProperty(this, "portals", void 0);

    defineProperty(this, "weight", void 0);

    defineProperty(this, "astar", void 0);

    defineProperty(this, "edges", void 0);

    this.id = id;
    this.polygon = polygon;
    this.connected = [];
    this.portals = [];
    this.boundingRadius = this.calculateRadius();
    this.weight = 1; // jsastar property

    this.centroid = polygon.getCentroid();
    this.edges = [];

    for (var i = 0; i < polygon.calcPoints.length; i++) {
      this.edges.push(new Segment(polygon.calcPoints[i], polygon.calcPoints[(i + 1) % polygon.calcPoints.length]));
    }
  }
  /**
   * Returns an array of points that form the polygon.
   *
   * @returns {Vector[]}
   * @memberof NavPoly
   */


  createClass(NavPoly, [{
    key: "getPoints",
    value: function getPoints() {
      return this.polygon.calcPoints;
    }
    /**
     * Check if the given point-like object is within the polygon
     *
     * @param {object} point Object of the form {x, y}
     * @returns {boolean}
     * @memberof NavPoly
     */

  }, {
    key: "contains",
    value: function contains(point) {
      // Phaser's polygon check doesn't handle when a point is on one of the edges of the line. Note:
      // check numerical stability here. It would also be good to optimize this for different shapes.
      return this.polygon.isPointIn(point);
    }
    /**
     * Calculate the radius of a circle that circumscribes the polygon.
     *
     * @returns {number}
     * @memberof NavPoly
     */

  }, {
    key: "calculateRadius",
    value: function calculateRadius() {
      var boundingRadius = 0;
      var centroid = this.polygon.getCentroid();

      var _iterator = _createForOfIteratorHelper$4(this.polygon.calcPoints),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var point = _step.value;
          var d = centroid.dist(point);
          if (d > boundingRadius) boundingRadius = d;
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return boundingRadius;
    }
    /**
     * Check if the given point-like object is on one of the edges of the polygon.
     *
     * @param {object} Point-like object in the form { x, y }
     * @returns {boolean}
     * @memberof NavPoly
     */

  }, {
    key: "isPointOnEdge",
    value: function isPointOnEdge(p) {
      return this.polygon.isPointOn(p);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.connected = [];
      this.portals = [];
    } // jsastar methods

  }, {
    key: "toString",
    value: function toString() {
      var centroid = this.polygon.getCentroid();
      return "NavPoly(id: ".concat(this.id, " at: ").concat(centroid, ")");
    }
  }, {
    key: "isWall",
    value: function isWall() {
      return this.weight === 0;
    }
  }, {
    key: "centroidDistance",
    value: function centroidDistance(navPolygon) {
      return this.centroid.dist(navPolygon.centroid);
    }
  }, {
    key: "getCost",
    value: function getCost(navPolygon) {
      return this.centroidDistance(navPolygon);
    }
  }, {
    key: "neighbors",
    value: function neighbors() {
      return this.connected;
    }
  }]);

  return NavPoly;
}();

var AStarNode = /*#__PURE__*/function () {
  function AStarNode(graphNode) {
    classCallCheck(this, AStarNode);

    defineProperty(this, "node", void 0);

    defineProperty(this, "f", 0);

    defineProperty(this, "g", 0);

    defineProperty(this, "h", 0);

    defineProperty(this, "visited", false);

    defineProperty(this, "closed", false);

    defineProperty(this, "parent", null);

    this.node = graphNode;
    this.node.astar = this;
  }

  createClass(AStarNode, [{
    key: "clean",
    value: function clean() {
      this.f = 0;
      this.g = 0;
      this.h = 0;
      this.visited = false;
      this.closed = false;
      this.parent = null;
    }
  }]);

  return AStarNode;
}();
/**
 * Graph for javascript-astar. It implements the functionality for astar. See GPS test from astar
 * repo for structure: https://github.com/bgrins/javascript-astar/blob/master/test/tests.js
 *
 * @class NavGraph
 * @private
 */

var NavGraph = /*#__PURE__*/function () {
  //return navPolygon1.centroidDistance(navPolygon2);
  function NavGraph(nodes, navHeuristic) {
    classCallCheck(this, NavGraph);

    defineProperty(this, "nodes", void 0);

    defineProperty(this, "dirtyNodes", void 0);

    defineProperty(this, "heuristic", void 0);

    this.dirtyNodes = [];
    this.nodes = [];
    this.heuristic = navHeuristic;

    for (var i = 0; i < nodes.length; i++) {
      this.nodes.push(new AStarNode(nodes[i]));
    }
  }

  createClass(NavGraph, [{
    key: "cleanDirty",
    value: function cleanDirty() {
      for (var i = 0; i < this.dirtyNodes.length; i++) {
        this.dirtyNodes[i].clean();
      }

      this.dirtyNodes = [];
    }
  }, {
    key: "markDirty",
    value: function markDirty(node) {
      this.dirtyNodes.push(node);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.cleanDirty();
      this.nodes = [];
    }
    /*toString() {
        let graphString = [];
        let nodes = this.nodes;
        for (let x = 0; x < nodes.length; x++) {
            let rowDebug = [];
            let row = nodes[x];
            for (let y = 0; y < row.length; y++) {
                rowDebug.push(row[y].weight);
            }
            graphString.push(rowDebug.join(" "));
        }
        return graphString.join("\n");
    }*/

  }, {
    key: "search",

    /**
     * Perform an A* Search on a graph given a start and end node.
     * @param {Graph} graph
     * @param {GridNode} start
     * @param {GridNode} end
     * @param {Object} [options]
     * @param {bool} [options.closest] Specifies whether to return the
     path to the closest node if the target is unreachable.
     * @param {Function} [options.heuristic] Heuristic function (see
     *          astar.heuristics).
     */
    value: function search(startNode, endNode) {
      var graph = this;
      graph.cleanDirty();
      var heuristic = this.heuristic;
      var openHeap = new BinaryHeap(function (node) {
        return node.f;
      });
      var start = new AStarNode(startNode);
      var end = new AStarNode(endNode);

      start.h = heuristic(start.node, end.node);
      graph.markDirty(start);
      openHeap.push(start);

      while (openHeap.size() > 0) {
        // Grab the lowest f(x) to process next.  Heap keeps this sorted for us.
        var currentNode = openHeap.pop(); // End case -- result has been found, return the traced path.

        if (currentNode === end) {
          return NavGraph.pathTo(currentNode);
        } // Normal case -- move currentNode from open to closed, process each of its neighbors.


        currentNode.closed = true; // Find all neighbors for the current node.

        var _neighbors = currentNode.node.neighbors();

        for (var i = 0, il = _neighbors.length; i < il; ++i) {
          var neighbor = _neighbors[i];
          var neighborStatus = neighbor.astar;

          if (neighborStatus.closed || neighbor.isWall()) {
            // Not a valid node to process, skip to next neighbor.
            continue;
          } // The g score is the shortest distance from start to current node.
          // We need to check if the path we have arrived at this neighbor is the shortest one we have seen yet.


          var gScore = currentNode.g + neighbor.getCost(currentNode.node);
          var beenVisited = neighborStatus.visited;

          if (!beenVisited || gScore < neighborStatus.g) {
            // Found an optimal (so far) path to this node.  Take score for node to see how good it is.
            neighborStatus.visited = true;
            neighborStatus.parent = currentNode;
            neighborStatus.h = neighborStatus.h || heuristic(neighbor, end.node);
            neighborStatus.g = gScore;
            neighborStatus.f = neighborStatus.g + neighborStatus.h;
            graph.markDirty(neighborStatus);

            if (!beenVisited) {
              // Pushing to heap will put it in proper place based on the 'f' value.
              openHeap.push(neighborStatus);
            } else {
              // Already seen the node, but since it has been rescored we need to reorder it in the heap
              openHeap.rescoreElement(neighborStatus);
            }
          }
        }
      }


      return [];
    }
  }], [{
    key: "pathTo",
    value: function pathTo(node) {
      var curr = node;
      var path = [];

      while (curr.parent) {
        path.unshift(curr);
        curr = curr.parent;
      }

      return path;
    }
  }]);

  return NavGraph;
}();

/**
 * @private
 */

var Channel = /*#__PURE__*/function () {
  function Channel() {
    classCallCheck(this, Channel);

    defineProperty(this, "portals", void 0);

    defineProperty(this, "path", void 0);

    this.portals = [];
    this.path = [];
  }

  createClass(Channel, [{
    key: "push",
    value: function push(p1) {
      var p2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      if (p2 === null) p2 = p1;
      this.portals.push(new Segment(p1, p2));

      if (!p2) {
        console.log(p1, p2);
        console.error(new Error());
      }
    }
  }, {
    key: "stringPull",
    value: function stringPull() {
      var portals = this.portals;
      var pts = []; // Init scan state

      var portalApex, portalLeft, portalRight;
      var apexIndex = 0,
          leftIndex = 0,
          rightIndex = 0;
      portalApex = portals[0].v1;
      portalLeft = portals[0].v1;
      portalRight = portals[0].v2; // Add start point.

      pts.push(portalApex);

      for (var i = 1; i < portals.length; i++) {
        // Find the next portal vertices
        var left = portals[i].v1;
        var right = portals[i].v2; // Update right vertex.

        if (triarea2(portalApex, portalRight, right) <= 0.0) {
          if (portalApex.equalsTo(portalRight) || triarea2(portalApex, portalLeft, right) > 0.0) {
            // Tighten the funnel.
            portalRight = right;
            rightIndex = i;
          } else {
            // Right vertex just crossed over the left vertex, so the left vertex should
            // now be part of the path.
            pts.push(portalLeft); // Restart scan from portal left point.
            // Make current left the new apex.

            portalApex = portalLeft;
            apexIndex = leftIndex; // Reset portal

            portalLeft = portalApex;
            portalRight = portalApex;
            leftIndex = apexIndex;
            rightIndex = apexIndex; // Restart scan

            i = apexIndex;
            continue;
          }
        } // Update left vertex.


        if (triarea2(portalApex, portalLeft, left) >= 0.0) {
          if (portalApex.equalsTo(portalLeft) || triarea2(portalApex, portalRight, left) < 0.0) {
            // Tighten the funnel.
            portalLeft = left;
            leftIndex = i;
          } else {
            // Left vertex just crossed over the right vertex, so the right vertex should
            // now be part of the path
            pts.push(portalRight); // Restart scan from portal right point.
            // Make current right the new apex.

            portalApex = portalRight;
            apexIndex = rightIndex; // Reset portal

            portalLeft = portalApex;
            portalRight = portalApex;
            leftIndex = apexIndex;
            rightIndex = apexIndex; // Restart scan

            i = apexIndex;
            continue;
          }
        }
      }

      if (pts.length === 0 || !pts[pts.length - 1].equalsTo(portals[portals.length - 1].v1)) {
        // Append last point to path.
        pts.push(portals[portals.length - 1].v1);
      }

      this.path = pts;
      return pts;
    }
  }]);

  return Channel;
}();

function _createForOfIteratorHelper$5(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray$6(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray$6(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$6(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$6(o, minLen); }

function _arrayLikeToArray$6(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
var NavMesh = /*#__PURE__*/function () {
  /**
   * Creates an instance of NavMesh.
   * @param {object[][]} meshPolygonPoints Array where each element is an array of point-like
   * objects that defines a polygon.
   * @param {number} [meshShrinkAmount=0] The amount (in pixels) that the navmesh has been
   * shrunk around obstacles (a.k.a the amount obstacles have been expanded)
   * @memberof NavMesh
   */
  function NavMesh(meshPolygonPoints) {
    var _this = this;

    var meshShrinkAmount = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

    classCallCheck(this, NavMesh);

    defineProperty(this, "_meshShrinkAmount", void 0);

    defineProperty(this, "_navPolygons", void 0);

    defineProperty(this, "_graph", void 0);

    defineProperty(this, "_qtree", void 0);

    defineProperty(this, "vecTemp", new Vector());

    this._meshShrinkAmount = meshShrinkAmount;
    var width = 0,
        height = 0;
    var newPolys = meshPolygonPoints.map(function (polyPoints) {
      var vectors = polyPoints.map(function (p) {
        width = Math.max(width, p.x);
        height = Math.max(height, p.y);
        return new Vector(p.x, p.y);
      });
      return new Polygon(new Vector(), vectors);
    });
    this._qtree = new LQTree(width, height);
    newPolys.forEach(function (p) {
      return _this._qtree.insert(p.getAABB(), p);
    });
    this._navPolygons = newPolys.map(function (polygon, i) {
      return new NavPoly(i, polygon);
    });

    this._calculateNeighbors(); // Astar graph of connections between polygons


    this._graph = new NavGraph(this._navPolygons, function (navPolygon1, navPolygon2) {
      return navPolygon1.centroidDistance(navPolygon2);
    });
  }
  /**
   * Get the NavPolys that are in this navmesh.
   *
   * @returns {NavPoly[]}
   * @memberof NavMesh
   */


  createClass(NavMesh, [{
    key: "getPolygons",
    value: function getPolygons() {
      return this._navPolygons;
    }
    /**
     * Cleanup method to remove references.
     *
     * @memberof NavMesh
     */

  }, {
    key: "destroy",
    value: function destroy() {
      this._graph.destroy();

      var _iterator = _createForOfIteratorHelper$5(this._navPolygons),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var poly = _step.value;
          poly.destroy();
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      this._navPolygons = [];
    }
    /**
     * Find a path from the start point to the end point using this nav mesh.
     *
     * @param {object} startPoint A point-like object in the form {x, y}
     * @param {object} endPoint A point-like object in the form {x, y}
     * @returns {Vector[]|null} An array of points if a path is found, or null if no path
     *
     * @memberof NavMesh
     */

  }, {
    key: "findPath",
    value: function findPath(startPoint, endPoint) {
      var startPoly = null;
      var endPoly = null;
      var startDistance = Number.MAX_VALUE;
      var endDistance = Number.MAX_VALUE;
      var d, r;
      var startVector = new Vector(startPoint.x, startPoint.y);
      var endVector = new Vector(endPoint.x, endPoint.y); // Find the closest poly for the starting and ending point

      var _iterator2 = _createForOfIteratorHelper$5(this._navPolygons),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _navPoly2 = _step2.value;
          r = _navPoly2.boundingRadius; // Start

          d = _navPoly2.centroid.dist(startVector);

          if (d <= startDistance && d <= r && _navPoly2.contains(startVector)) {
            startPoly = _navPoly2;
            startDistance = d;
          } // End


          d = _navPoly2.centroid.dist(endVector);

          if (d <= endDistance && d <= r && _navPoly2.contains(endVector)) {
            endPoly = _navPoly2;
            endDistance = d;
          }
        } // If the start point wasn't inside a polygon, run a more liberal check that allows a point
        // to be within meshShrinkAmount radius of a polygon

      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      if (!startPoly && this._meshShrinkAmount > 0) {
        var _iterator3 = _createForOfIteratorHelper$5(this._navPolygons),
            _step3;

        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var navPoly = _step3.value;
            // Check if point is within bounding circle to avoid extra projection calculations
            r = navPoly.boundingRadius + this._meshShrinkAmount;
            d = navPoly.centroid.dist(startVector);

            if (d <= r) {
              // Check if projected point is within range of a polgyon and is closer than the
              // previous point
              var _this$_projectPointTo = this._projectPointToPolygon(startVector, navPoly),
                  distance = _this$_projectPointTo.distance;

              if (distance <= this._meshShrinkAmount && distance < startDistance) {
                startPoly = navPoly;
                startDistance = distance;
              }
            }
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      } // Same check as above, but for the end point


      if (!endPoly && this._meshShrinkAmount > 0) {
        var _iterator4 = _createForOfIteratorHelper$5(this._navPolygons),
            _step4;

        try {
          for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
            var _navPoly = _step4.value;
            r = _navPoly.boundingRadius + this._meshShrinkAmount;
            d = _navPoly.centroid.dist(endVector);

            if (d <= r) {
              var _this$_projectPointTo2 = this._projectPointToPolygon(endVector, _navPoly),
                  _distance = _this$_projectPointTo2.distance;

              if (_distance <= this._meshShrinkAmount && _distance < endDistance) {
                endPoly = _navPoly;
                endDistance = _distance;
              }
            }
          }
        } catch (err) {
          _iterator4.e(err);
        } finally {
          _iterator4.f();
        }
      } // No matching polygons locations for the start or end, so no path found


      if (!startPoly || !endPoly) return null; // If the start and end polygons are the same, return a direct path

      if (startPoly === endPoly) return [startVector, endVector]; // Search!

      var astarPath = this._graph.search(startPoly, endPoly); // While the start and end polygons may be valid, no path between them


      if (astarPath.length === 0) return null; // jsastar drops the first point from the path, but the funnel algorithm needs it

      astarPath.unshift(startPoly.astar); // We have a path, so now time for the funnel algorithm

      var channel = new Channel();
      channel.push(startVector);

      for (var i = 0; i < astarPath.length - 1; i++) {
        var navPolygon = astarPath[i];
        var nextNavPolygon = astarPath[i + 1]; // Find the portal

        var portal = null;

        for (var _i = 0; _i < navPolygon.node.neighbors().length; _i++) {
          if (navPolygon.node.neighbors()[_i].id === nextNavPolygon.node.id) {
            portal = navPolygon.node.portals[_i];
          }
        } // Push the portal vertices into the channel


        channel.push(portal.v1, portal.v2);
      }

      channel.push(endVector); // Pull a string along the channel to run the funnel

      channel.stringPull(); // Clone path, excluding duplicates

      var lastPoint = null;
      var phaserPath = [];

      var _iterator5 = _createForOfIteratorHelper$5(channel.path),
          _step5;

      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var p = _step5.value;
          var newPoint = p.clone();
          if (!lastPoint || !newPoint.equalsTo(lastPoint)) phaserPath.push(newPoint);
          lastPoint = newPoint;
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }

      return phaserPath;
    }
  }, {
    key: "_calculateNeighbors",
    value: function _calculateNeighbors() {
      // Fill out the neighbor information for each navpoly
      for (var i = 0; i < this._navPolygons.length; i++) {
        var navPoly = this._navPolygons[i];

        for (var j = i + 1; j < this._navPolygons.length; j++) {
          var otherNavPoly = this._navPolygons[j]; // Check if the other navpoly is within range to touch

          var d = navPoly.centroidDistance(otherNavPoly);
          if (d > navPoly.boundingRadius + otherNavPoly.boundingRadius) continue; // The are in range, so check each edge pairing

          var _iterator6 = _createForOfIteratorHelper$5(navPoly.edges),
              _step6;

          try {
            for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
              var edge = _step6.value;

              var _iterator7 = _createForOfIteratorHelper$5(otherNavPoly.edges),
                  _step7;

              try {
                for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
                  var otherEdge = _step7.value;
                  // If edges aren't collinear, not an option for connecting navpolys
                  if (!NavMesh.areCollinear(edge, otherEdge)) continue; // If they are collinear, check if they overlap

                  var overlap = this._getSegmentOverlap(edge, otherEdge);

                  if (!overlap) continue; // Connections are symmetric!

                  navPoly.neighbors().push(otherNavPoly);
                  otherNavPoly.neighbors().push(navPoly); // Calculate the portal between the two polygons - this needs to be in
                  // counter-clockwise order, relative to each polygon

                  var _overlap = slicedToArray(overlap, 2),
                      p1 = _overlap[0],
                      p2 = _overlap[1];

                  var edgeStartAngle = navPoly.centroid.angle(edge.v1);
                  var a1 = navPoly.centroid.angle(overlap[0]);
                  var a2 = navPoly.centroid.angle(overlap[1]);
                  var d1 = angleDiff(edgeStartAngle, a1);
                  var d2 = angleDiff(edgeStartAngle, a2);

                  if (d1 < d2) {
                    navPoly.portals.push(new Segment(p1, p2));
                  } else {
                    navPoly.portals.push(new Segment(p2, p1));
                  }

                  edgeStartAngle = otherNavPoly.centroid.angle(otherEdge.v1);
                  a1 = otherNavPoly.centroid.angle(overlap[0]);
                  a2 = otherNavPoly.centroid.angle(overlap[1]);
                  d1 = angleDiff(edgeStartAngle, a1);
                  d2 = angleDiff(edgeStartAngle, a2);

                  if (d1 < d2) {
                    otherNavPoly.portals.push(new Segment(p1, p2));
                  } else {
                    otherNavPoly.portals.push(new Segment(p2, p1));
                  } // Two convex polygons shouldn't be connected more than once! (Unless
                  // there are unnecessary vertices...)

                }
              } catch (err) {
                _iterator7.e(err);
              } finally {
                _iterator7.f();
              }
            }
          } catch (err) {
            _iterator6.e(err);
          } finally {
            _iterator6.f();
          }
        }
      }
    } // Check two collinear line segments to see if they overlap by sorting the points.
    // Algorithm source: http://stackoverflow.com/a/17152247

  }, {
    key: "_getSegmentOverlap",
    value: function _getSegmentOverlap(line1, line2) {
      var points = [{
        line: line1,
        point: line1.v1
      }, {
        line: line1,
        point: line1.v2
      }, {
        line: line2,
        point: line2.v1
      }, {
        line: line2,
        point: line2.v2
      }];
      points.sort(function (a, b) {
        if (a.point.x < b.point.x) return -1;else if (a.point.x > b.point.x) return 1;else {
          if (a.point.y < b.point.y) return -1;else if (a.point.y > b.point.y) return 1;else return 0;
        }
      }); // If the first two points in the array come from the same line, no overlap

      var noOverlap = points[0].line === points[1].line; // If the two middle points in the array are the same coordinates, then there is a
      // single point of overlap.

      var singlePointOverlap = points[1].point.equalsTo(points[2].point);
      if (noOverlap || singlePointOverlap) return null;else return [points[1].point, points[2].point];
    }
    /**
     * Project a point onto a polygon in the shortest distance possible.
     *
     * @param {Phaser.Point} point The point to project
     * @param {NavPoly} navPoly The navigation polygon to test against
     * @returns {{point: Phaser.Point, distance: number}}
     *
     * @private
     * @memberof NavMesh
     */

  }, {
    key: "_projectPointToPolygon",
    value: function _projectPointToPolygon(point, navPoly) {
      var closestProjection = null;
      var closestDistance = Number.MAX_VALUE;

      var _iterator8 = _createForOfIteratorHelper$5(navPoly.edges),
          _step8;

      try {
        for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
          var edge = _step8.value;

          var projectedPoint = this._projectPointToEdge(point, edge);

          var d = point.dist(projectedPoint);

          if (closestProjection === null || d < closestDistance) {
            closestDistance = d;
            closestProjection = projectedPoint;
          }
        }
      } catch (err) {
        _iterator8.e(err);
      } finally {
        _iterator8.f();
      }

      return {
        point: closestProjection,
        distance: closestDistance
      };
    } // Project a point onto a line segment
    // JS Source: http://stackoverflow.com/questions/849211/shortest-distance-between-a-point-and-a-line-segment

  }, {
    key: "_projectPointToEdge",
    value: function _projectPointToEdge(point, line) {
      var a = line.v1;
      var b = line.v2; // Consider the parametric equation for the edge's line, p = a + t (b - a). We want to find
      // where our point lies on the line by solving for t:
      //  t = [(p-a) . (b-a)] / |b-a|^2

      var l2 = a.dist2(b);
      var t = ((point.x - a.x) * (b.x - a.x) + (point.y - a.y) * (b.y - a.y)) / l2; // We clamp t from [0,1] to handle points outside the segment vw.

      t = clamp(t, 0, 1); // Project onto the segment

      var p = new Vector(a.x + t * (b.x - a.x), a.y + t * (b.y - a.y));
      return p;
    }
  }, {
    key: "getReachableNearTarget",
    value: function getReachableNearTarget(target, width) {
      var _this2 = this;

      var height = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : width;
      var res = null;
      var min = 9999999;

      this._qtree.search(AABB.fromCenter(target, width, height), function (poly) {
        //console.log(poly);
        if (poly.isPointIn(target)) {
          if (res === null) {
            res = new Vector();
          }

          res.set(target);
          return true;
        } else {
          var d = point2polygon(target, poly.calcPoints, _this2.vecTemp); //console.log(this.vecTemp);
          //console.log(d);

          if (d < min) {
            if (res === null) {
              res = new Vector();
            }

            res.set(_this2.vecTemp);
            min = d;
          }
        }

        return false;
      });

      return res;
    }
  }], [{
    key: "areCollinear",
    value: function areCollinear(edge1, edge2) {
      return edge1.isPointOnLine(edge2.v1) && edge1.isPointOnLine(edge2.v2);
    }
  }]);

  return NavMesh;
}();

exports.AABB = AABB;
exports.AStarNode = AStarNode;
exports.Arc = Arc;
exports.BinaryHeap = BinaryHeap;
exports.Circle = Circle;
exports.CollisionResult = CollisionResult;
exports.Comparator = Comparator;
exports.ComposedShape = ComposedShape;
exports.Geom2Const = Geom2Const;
exports.LQTree = LQTree;
exports.NavGraph = NavGraph;
exports.NavMesh = NavMesh;
exports.NavPoly = NavPoly;
exports.PartitionPolygon = PartitionPolygon;
exports.PartitionVertex = PartitionVertex;
exports.PolyVertex = PolyVertex;
exports.Polygon = Polygon;
exports.Segment = Segment;
exports.Transform = Transform;
exports.UnionPolygon = UnionPolygon;
exports.Vector = Vector;
exports.angleDiff = angleDiff;
exports.angleDiffPI2 = angleDiffPI2;
exports.angleNormalize = angleNormalize;
exports.angleNormalizePI2 = angleNormalizePI2;
exports.applyImpulse = applyImpulse;
exports.clamp = clamp;
exports.clip = clip;
exports.convexPartitionHM = convexPartitionHM;
exports.convexPartitionHMList = convexPartitionHMList;
exports.crossProduct3 = crossProduct3;
exports.epa = epa;
exports.generateRandomConvexPolygon = generateRandomConvexPolygon;
exports.getEnlargedPolygon = getEnlargedPolygon;
exports.gjk = gjk;
exports.inCone = inCone;
exports.intersectingVertex = intersectingVertex;
exports.intersects = intersects;
exports.isConvex = isConvex;
exports.lineLineIntersection = lineLineIntersection;
exports.makeHull = makeHull;
exports.onSegment = onSegment;
exports.orientation = orientation;
exports.originDistance = originDistance;
exports.pMod = pMod;
exports.point2polygon = point2polygon;
exports.point2segment = point2segment;
exports.positionalCorrection = positionalCorrection;
exports.preprocessIntersection = preprocessIntersection;
exports.removeHoles = removeHoles;
exports.resolveContact = resolveContact;
exports.resolvePointsOfContact = resolvePointsOfContact;
exports.resolvePointsOfContact2 = resolvePointsOfContact2;
exports.sameSign = sameSign;
exports.segmentHasPoint = segmentHasPoint;
exports.sgn = sgn;
exports.shuffle = shuffle;
exports.support = support;
exports.testCircleCircle = testCircleCircle;
exports.testPolygonCircle = testPolygonCircle;
exports.testSegmentSegment = testSegmentSegment;
exports.triangulateEC = triangulateEC;
exports.triangulateECList = triangulateECList;
exports.triarea2 = triarea2;
exports.tripleProduct = tripleProduct;
exports.unionPolygons = unionPolygons;
